# AnalysisApi

All URIs are relative to *https://lichess.org*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiCloudEval**](AnalysisApi.md#apiCloudEval) | **GET** /api/cloud-eval | Get cloud evaluation of a position.


<a name="apiCloudEval"></a>
# **apiCloudEval**
> apiCloudEval(fen, multiPv, variant)

Get cloud evaluation of a position.

Get the cached evaluation of a position, if available.  Opening positions have more chances of being available. There are about 7 million positions in the database.  Up to 5 variations may be available. Variants are supported. 

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.AnalysisApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://lichess.org");

    AnalysisApi apiInstance = new AnalysisApi(defaultClient);
    String fen = "rnbqkbnr/ppp1pppp/8/3pP3/8/8/PPPP1PPP/RNBQKBNR b KQkq - 0 2"; // String | FEN of the position
    BigDecimal multiPv = new BigDecimal("1"); // BigDecimal | Number of variations
    VariantKey variant = VariantKey.fromValue("standard"); // VariantKey | Variant
    try {
      apiInstance.apiCloudEval(fen, multiPv, variant);
    } catch (ApiException e) {
      System.err.println("Exception when calling AnalysisApi#apiCloudEval");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fen** | **String**| FEN of the position |
 **multiPv** | **BigDecimal**| Number of variations | [optional] [default to 1]
 **variant** | [**VariantKey**](.md)| Variant | [optional] [default to standard] [enum: standard, chess960, crazyhouse, antichess, atomic, horde, kingOfTheHill, racingKings, threeCheck]

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The evaluation of the position. |  * Access-Control-Allow-Origin -  <br>  |

