# TablebaseApi

All URIs are relative to *https://lichess.org*

Method | HTTP request | Description
------------- | ------------- | -------------
[**antichessAtomic**](TablebaseApi.md#antichessAtomic) | **GET** /antichess | Tablebase lookup for Antichess
[**tablebaseAtomic**](TablebaseApi.md#tablebaseAtomic) | **GET** /atomic | Tablebase lookup for Atomic chess
[**tablebaseStandard**](TablebaseApi.md#tablebaseStandard) | **GET** /standard | Tablebase lookup


<a name="antichessAtomic"></a>
# **antichessAtomic**
> String antichessAtomic()

Tablebase lookup for Antichess

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.TablebaseApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://lichess.org");

    TablebaseApi apiInstance = new TablebaseApi(defaultClient);
    try {
      String result = apiInstance.antichessAtomic();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling TablebaseApi#antichessAtomic");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The tablebase information for the position in atomic chess. |  * Access-Control-Allow-Origin -  <br>  |

<a name="tablebaseAtomic"></a>
# **tablebaseAtomic**
> String tablebaseAtomic()

Tablebase lookup for Atomic chess

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.TablebaseApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://lichess.org");

    TablebaseApi apiInstance = new TablebaseApi(defaultClient);
    try {
      String result = apiInstance.tablebaseAtomic();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling TablebaseApi#tablebaseAtomic");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The tablebase information for the position in atomic chess. |  * Access-Control-Allow-Origin -  <br>  |

<a name="tablebaseStandard"></a>
# **tablebaseStandard**
> TablebaseJson tablebaseStandard(fen)

Tablebase lookup

**Endpoint: &lt;https://tablebase.lichess.ovh&gt;**  Example: &#x60;curl http://tablebase.lichess.ovh/standard?fen&#x3D;4k3/6KP/8/8/8/8/7p/8_w_-_-_0_1&#x60; 

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.TablebaseApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://lichess.org");

    TablebaseApi apiInstance = new TablebaseApi(defaultClient);
    String fen = "fen_example"; // String | FEN of the position. Underscores allowed.
    try {
      TablebaseJson result = apiInstance.tablebaseStandard(fen);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling TablebaseApi#tablebaseStandard");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fen** | **String**| FEN of the position. Underscores allowed. |

### Return type

[**TablebaseJson**](TablebaseJson.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The tablebase information for the position in standard chess. |  * Access-Control-Allow-Origin -  <br>  |

