

# TablebaseJson


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**category** | [**CategoryEnum**](#CategoryEnum) | &#x60;cursed-win&#x60; and &#x60;blessed-loss&#x60; means the 50-move rule prevents the decisive result.  &#x60;maybe-win&#x60; and &#x60;maybe-loss&#x60; means exact result is unknown due to [DTZ rounding](https://syzygy-tables.info/metrics#dtz), i.e., the win or loss could also be prevented by the 50-move rule if the user has deviated from the tablebase recommendation since the last pawn move or capture.  |  [optional]
**dtz** | **Integer** | [DTZ50&#39;&#39; with rounding](https://syzygy-tables.info/metrics#dtz) or null if unknown  |  [optional]
**dtm** | **Integer** | Distance to mate (only for positions with not more than 5 pieces) |  [optional]
**checkmate** | **Boolean** |  |  [optional]
**stalemate** | **Boolean** |  |  [optional]
**variantWin** | **Boolean** | Only in chess variants |  [optional]
**variantLoss** | **Boolean** | Only in chess variants |  [optional]
**insufficientMaterial** | **Boolean** |  |  [optional]
**moves** | [**List&lt;Move&gt;**](Move.md) | Information about legal moves, best first |  [optional]



## Enum: CategoryEnum

Name | Value
---- | -----
WIN | &quot;win&quot;
UNKNOWN | &quot;unknown&quot;
MAYBE_WIN | &quot;maybe-win&quot;
CURSED_WIN | &quot;cursed-win&quot;
DRAW | &quot;draw&quot;
BLESSED_LOSS | &quot;blessed-loss&quot;
MAYBE_LOSS | &quot;maybe-loss&quot;
LOSS | &quot;loss&quot;



