/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.ApiStreamEvent;
import java.math.BigDecimal;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.GameStreamEvent;
import org.openapitools.client.model.NotFound;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.VariantKey;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BoardApi {
    private ApiClient localVarApiClient;

    public BoardApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BoardApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for apiBoardSeek
     * @param rated Whether the game is rated and impacts players ratings. (optional, default to false)
     * @param time Clock initial time in minutes. Required for real-time seeks. (optional)
     * @param increment Clock increment in seconds. Required for real-time seeks. (optional)
     * @param days Days per turn. Required for correspondence seeks. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param color The color to play. Better left empty to automatically get 50% white. (optional, default to random)
     * @param ratingRange The rating range of potential opponents. Better left empty. Example: 1500-1800  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The seek was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the seek failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiBoardSeekCall(Boolean rated, BigDecimal time, Integer increment, Integer days, VariantKey variant, String color, String ratingRange, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/seek";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (rated != null) {
            localVarFormParams.put("rated", rated);
        }

        if (time != null) {
            localVarFormParams.put("time", time);
        }

        if (increment != null) {
            localVarFormParams.put("increment", increment);
        }

        if (days != null) {
            localVarFormParams.put("days", days);
        }

        if (variant != null) {
            localVarFormParams.put("variant", variant);
        }

        if (color != null) {
            localVarFormParams.put("color", color);
        }

        if (ratingRange != null) {
            localVarFormParams.put("ratingRange", ratingRange);
        }

        final String[] localVarAccepts = {
            "text/plain", "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiBoardSeekValidateBeforeCall(Boolean rated, BigDecimal time, Integer increment, Integer days, VariantKey variant, String color, String ratingRange, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = apiBoardSeekCall(rated, time, increment, days, variant, color, ratingRange, _callback);
        return localVarCall;

    }

    /**
     * Create a seek
     *    Create a public seek, to start a game with a random player.    ### Real-time seek    Specify the &#x60;time&#x60; and &#x60;increment&#x60; clock values.  The response is streamed but doesn&#39;t contain any information.    **Keep the connection open to keep the seek active**.    If the client closes the connection, the seek is canceled. This way, if the client terminates, the user won&#39;t be paired in a game they wouldn&#39;t play.   When the seek is accepted, or expires, the server closes the connection.    **Make sure to also have an [Event stream](#operation/apiStreamEvent) open**, to be notified when a game starts.   We recommend opening the [Event stream](#operation/apiStreamEvent) first, then the seek stream. This way,   you won&#39;t miss the game event if the seek is accepted immediately.    ### Correspondence seek    Specify the &#x60;days&#x60; per turn value.  The response is not streamed, it immediately completes with the seek ID. The seek remains active on the server until it is joined by someone.
     * @param rated Whether the game is rated and impacts players ratings. (optional, default to false)
     * @param time Clock initial time in minutes. Required for real-time seeks. (optional)
     * @param increment Clock increment in seconds. Required for real-time seeks. (optional)
     * @param days Days per turn. Required for correspondence seeks. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param color The color to play. Better left empty to automatically get 50% white. (optional, default to random)
     * @param ratingRange The rating range of potential opponents. Better left empty. Example: 1500-1800  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The seek was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the seek failed. </td><td>  -  </td></tr>
     </table>
     */
    public void apiBoardSeek(Boolean rated, BigDecimal time, Integer increment, Integer days, VariantKey variant, String color, String ratingRange) throws ApiException {
        apiBoardSeekWithHttpInfo(rated, time, increment, days, variant, color, ratingRange);
    }

    /**
     * Create a seek
     *    Create a public seek, to start a game with a random player.    ### Real-time seek    Specify the &#x60;time&#x60; and &#x60;increment&#x60; clock values.  The response is streamed but doesn&#39;t contain any information.    **Keep the connection open to keep the seek active**.    If the client closes the connection, the seek is canceled. This way, if the client terminates, the user won&#39;t be paired in a game they wouldn&#39;t play.   When the seek is accepted, or expires, the server closes the connection.    **Make sure to also have an [Event stream](#operation/apiStreamEvent) open**, to be notified when a game starts.   We recommend opening the [Event stream](#operation/apiStreamEvent) first, then the seek stream. This way,   you won&#39;t miss the game event if the seek is accepted immediately.    ### Correspondence seek    Specify the &#x60;days&#x60; per turn value.  The response is not streamed, it immediately completes with the seek ID. The seek remains active on the server until it is joined by someone.
     * @param rated Whether the game is rated and impacts players ratings. (optional, default to false)
     * @param time Clock initial time in minutes. Required for real-time seeks. (optional)
     * @param increment Clock increment in seconds. Required for real-time seeks. (optional)
     * @param days Days per turn. Required for correspondence seeks. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param color The color to play. Better left empty to automatically get 50% white. (optional, default to random)
     * @param ratingRange The rating range of potential opponents. Better left empty. Example: 1500-1800  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The seek was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the seek failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> apiBoardSeekWithHttpInfo(Boolean rated, BigDecimal time, Integer increment, Integer days, VariantKey variant, String color, String ratingRange) throws ApiException {
        okhttp3.Call localVarCall = apiBoardSeekValidateBeforeCall(rated, time, increment, days, variant, color, ratingRange, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Create a seek (asynchronously)
     *    Create a public seek, to start a game with a random player.    ### Real-time seek    Specify the &#x60;time&#x60; and &#x60;increment&#x60; clock values.  The response is streamed but doesn&#39;t contain any information.    **Keep the connection open to keep the seek active**.    If the client closes the connection, the seek is canceled. This way, if the client terminates, the user won&#39;t be paired in a game they wouldn&#39;t play.   When the seek is accepted, or expires, the server closes the connection.    **Make sure to also have an [Event stream](#operation/apiStreamEvent) open**, to be notified when a game starts.   We recommend opening the [Event stream](#operation/apiStreamEvent) first, then the seek stream. This way,   you won&#39;t miss the game event if the seek is accepted immediately.    ### Correspondence seek    Specify the &#x60;days&#x60; per turn value.  The response is not streamed, it immediately completes with the seek ID. The seek remains active on the server until it is joined by someone.
     * @param rated Whether the game is rated and impacts players ratings. (optional, default to false)
     * @param time Clock initial time in minutes. Required for real-time seeks. (optional)
     * @param increment Clock increment in seconds. Required for real-time seeks. (optional)
     * @param days Days per turn. Required for correspondence seeks. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param color The color to play. Better left empty to automatically get 50% white. (optional, default to random)
     * @param ratingRange The rating range of potential opponents. Better left empty. Example: 1500-1800  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The seek was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the seek failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiBoardSeekAsync(Boolean rated, BigDecimal time, Integer increment, Integer days, VariantKey variant, String color, String ratingRange, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiBoardSeekValidateBeforeCall(rated, time, increment, days, variant, color, ratingRange, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for apiStreamEvent
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of events reaching the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiStreamEventCall(final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/stream/event";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/x-ndjson"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiStreamEventValidateBeforeCall(final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = apiStreamEventCall(_callback);
        return localVarCall;

    }

    /**
     * Stream incoming events
     *    Stream the events reaching a lichess user in real time as [ndjson](#section/Introduction/Streaming-with-ND-JSON).    Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameStart&#x60; Start of a game   - &#x60;gameFinish&#x60; Completion of a game   - &#x60;challenge&#x60; A player sends you a challenge   - &#x60;challengeCanceled&#x60; A player cancels their challenge to you   - &#x60;challengeDeclined&#x60; The opponent declines your challenge     When the stream opens, all current challenges and games are sent.
     * @return ApiStreamEvent
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of events reaching the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiStreamEvent apiStreamEvent() throws ApiException {
        ApiResponse<ApiStreamEvent> localVarResp = apiStreamEventWithHttpInfo();
        return localVarResp.getData();
    }

    /**
     * Stream incoming events
     *    Stream the events reaching a lichess user in real time as [ndjson](#section/Introduction/Streaming-with-ND-JSON).    Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameStart&#x60; Start of a game   - &#x60;gameFinish&#x60; Completion of a game   - &#x60;challenge&#x60; A player sends you a challenge   - &#x60;challengeCanceled&#x60; A player cancels their challenge to you   - &#x60;challengeDeclined&#x60; The opponent declines your challenge     When the stream opens, all current challenges and games are sent.
     * @return ApiResponse&lt;ApiStreamEvent&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of events reaching the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<ApiStreamEvent> apiStreamEventWithHttpInfo() throws ApiException {
        okhttp3.Call localVarCall = apiStreamEventValidateBeforeCall(null);
        Type localVarReturnType = new TypeToken<ApiStreamEvent>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Stream incoming events (asynchronously)
     *    Stream the events reaching a lichess user in real time as [ndjson](#section/Introduction/Streaming-with-ND-JSON).    Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameStart&#x60; Start of a game   - &#x60;gameFinish&#x60; Completion of a game   - &#x60;challenge&#x60; A player sends you a challenge   - &#x60;challengeCanceled&#x60; A player cancels their challenge to you   - &#x60;challengeDeclined&#x60; The opponent declines your challenge     When the stream opens, all current challenges and games are sent.
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of events reaching the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiStreamEventAsync(final ApiCallback<ApiStreamEvent> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiStreamEventValidateBeforeCall(_callback);
        Type localVarReturnType = new TypeToken<ApiStreamEvent>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameAbort
     * @param gameId  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game successfully aborted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The abortion of the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameAbortCall(String gameId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/abort"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameAbortValidateBeforeCall(String gameId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameAbort(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameAbortCall(gameId, _callback);
        return localVarCall;

    }

    /**
     * Abort a game
     * Abort a game being played with the Board API. 
     * @param gameId  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game successfully aborted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The abortion of the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameAbort(String gameId) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameAbortWithHttpInfo(gameId);
        return localVarResp.getData();
    }

    /**
     * Abort a game
     * Abort a game being played with the Board API. 
     * @param gameId  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game successfully aborted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The abortion of the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameAbortWithHttpInfo(String gameId) throws ApiException {
        okhttp3.Call localVarCall = boardGameAbortValidateBeforeCall(gameId, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Abort a game (asynchronously)
     * Abort a game being played with the Board API. 
     * @param gameId  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game successfully aborted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The abortion of the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameAbortAsync(String gameId, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameAbortValidateBeforeCall(gameId, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameChatGet
     * @param gameId  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The messages posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameChatGetCall(String gameId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/chat"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/x-ndjson"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameChatGetValidateBeforeCall(String gameId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameChatGet(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameChatGetCall(gameId, _callback);
        return localVarCall;

    }

    /**
     * Fetch the game chat
     * Get the messages posted in the game chat 
     * @param gameId  (required)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The messages posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public Object boardGameChatGet(String gameId) throws ApiException {
        ApiResponse<Object> localVarResp = boardGameChatGetWithHttpInfo(gameId);
        return localVarResp.getData();
    }

    /**
     * Fetch the game chat
     * Get the messages posted in the game chat 
     * @param gameId  (required)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The messages posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Object> boardGameChatGetWithHttpInfo(String gameId) throws ApiException {
        okhttp3.Call localVarCall = boardGameChatGetValidateBeforeCall(gameId, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Fetch the game chat (asynchronously)
     * Get the messages posted in the game chat 
     * @param gameId  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The messages posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameChatGetAsync(String gameId, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameChatGetValidateBeforeCall(gameId, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameChatPost
     * @param gameId  (required)
     * @param room  (required)
     * @param text  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The message was successfully posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The posting of the message in the chat failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameChatPostCall(String gameId, String room, String text, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/chat"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (room != null) {
            localVarFormParams.put("room", room);
        }

        if (text != null) {
            localVarFormParams.put("text", text);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameChatPostValidateBeforeCall(String gameId, String room, String text, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameChatPost(Async)");
        }
        
        // verify the required parameter 'room' is set
        if (room == null) {
            throw new ApiException("Missing the required parameter 'room' when calling boardGameChatPost(Async)");
        }
        
        // verify the required parameter 'text' is set
        if (text == null) {
            throw new ApiException("Missing the required parameter 'text' when calling boardGameChatPost(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameChatPostCall(gameId, room, text, _callback);
        return localVarCall;

    }

    /**
     * Write in the chat
     * Post a message to the player or spectator chat, in a game being played with the Board API. 
     * @param gameId  (required)
     * @param room  (required)
     * @param text  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The message was successfully posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The posting of the message in the chat failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameChatPost(String gameId, String room, String text) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameChatPostWithHttpInfo(gameId, room, text);
        return localVarResp.getData();
    }

    /**
     * Write in the chat
     * Post a message to the player or spectator chat, in a game being played with the Board API. 
     * @param gameId  (required)
     * @param room  (required)
     * @param text  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The message was successfully posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The posting of the message in the chat failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameChatPostWithHttpInfo(String gameId, String room, String text) throws ApiException {
        okhttp3.Call localVarCall = boardGameChatPostValidateBeforeCall(gameId, room, text, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Write in the chat (asynchronously)
     * Post a message to the player or spectator chat, in a game being played with the Board API. 
     * @param gameId  (required)
     * @param room  (required)
     * @param text  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The message was successfully posted in the chat. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The posting of the message in the chat failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameChatPostAsync(String gameId, String room, String text, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameChatPostValidateBeforeCall(gameId, room, text, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameClaimVictory
     * @param gameId  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The victory was successfully claimed. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The victory claim has failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameClaimVictoryCall(String gameId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/claim-victory"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameClaimVictoryValidateBeforeCall(String gameId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameClaimVictory(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameClaimVictoryCall(gameId, _callback);
        return localVarCall;

    }

    /**
     * Claim victory of a game
     * Claim victory when the opponent has left the game for a while. 
     * @param gameId  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The victory was successfully claimed. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The victory claim has failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameClaimVictory(String gameId) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameClaimVictoryWithHttpInfo(gameId);
        return localVarResp.getData();
    }

    /**
     * Claim victory of a game
     * Claim victory when the opponent has left the game for a while. 
     * @param gameId  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The victory was successfully claimed. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The victory claim has failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameClaimVictoryWithHttpInfo(String gameId) throws ApiException {
        okhttp3.Call localVarCall = boardGameClaimVictoryValidateBeforeCall(gameId, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Claim victory of a game (asynchronously)
     * Claim victory when the opponent has left the game for a while. 
     * @param gameId  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The victory was successfully claimed. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The victory claim has failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameClaimVictoryAsync(String gameId, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameClaimVictoryValidateBeforeCall(gameId, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameDraw
     * @param gameId  (required)
     * @param accept  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The draw offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The draw offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameDrawCall(String gameId, Boolean accept, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/draw/{accept}"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()))
            .replaceAll("\\{" + "accept" + "\\}", localVarApiClient.escapeString(accept.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameDrawValidateBeforeCall(String gameId, Boolean accept, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameDraw(Async)");
        }
        
        // verify the required parameter 'accept' is set
        if (accept == null) {
            throw new ApiException("Missing the required parameter 'accept' when calling boardGameDraw(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameDrawCall(gameId, accept, _callback);
        return localVarCall;

    }

    /**
     * Handle draw offers
     * Create/accept/decline draw offers. - &#x60;yes&#x60;: Offer a draw, or accept the opponent&#39;s draw offer. - &#x60;no&#x60;: Decline a draw offer from the opponent. 
     * @param gameId  (required)
     * @param accept  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The draw offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The draw offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameDraw(String gameId, Boolean accept) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameDrawWithHttpInfo(gameId, accept);
        return localVarResp.getData();
    }

    /**
     * Handle draw offers
     * Create/accept/decline draw offers. - &#x60;yes&#x60;: Offer a draw, or accept the opponent&#39;s draw offer. - &#x60;no&#x60;: Decline a draw offer from the opponent. 
     * @param gameId  (required)
     * @param accept  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The draw offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The draw offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameDrawWithHttpInfo(String gameId, Boolean accept) throws ApiException {
        okhttp3.Call localVarCall = boardGameDrawValidateBeforeCall(gameId, accept, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Handle draw offers (asynchronously)
     * Create/accept/decline draw offers. - &#x60;yes&#x60;: Offer a draw, or accept the opponent&#39;s draw offer. - &#x60;no&#x60;: Decline a draw offer from the opponent. 
     * @param gameId  (required)
     * @param accept  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The draw offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The draw offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameDrawAsync(String gameId, Boolean accept, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameDrawValidateBeforeCall(gameId, accept, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameMove
     * @param gameId  (required)
     * @param move The move to play, in UCI format (required)
     * @param offeringDraw Whether to offer (or agree to) a draw (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The move was successfully made. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The move failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameMoveCall(String gameId, String move, Boolean offeringDraw, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/move/{move}"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()))
            .replaceAll("\\{" + "move" + "\\}", localVarApiClient.escapeString(move.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (offeringDraw != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("offeringDraw", offeringDraw));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameMoveValidateBeforeCall(String gameId, String move, Boolean offeringDraw, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameMove(Async)");
        }
        
        // verify the required parameter 'move' is set
        if (move == null) {
            throw new ApiException("Missing the required parameter 'move' when calling boardGameMove(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameMoveCall(gameId, move, offeringDraw, _callback);
        return localVarCall;

    }

    /**
     * Make a Board move
     * Make a move in a game being played with the Board API.  The move can also contain a draw offer/agreement. 
     * @param gameId  (required)
     * @param move The move to play, in UCI format (required)
     * @param offeringDraw Whether to offer (or agree to) a draw (optional)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The move was successfully made. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The move failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameMove(String gameId, String move, Boolean offeringDraw) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameMoveWithHttpInfo(gameId, move, offeringDraw);
        return localVarResp.getData();
    }

    /**
     * Make a Board move
     * Make a move in a game being played with the Board API.  The move can also contain a draw offer/agreement. 
     * @param gameId  (required)
     * @param move The move to play, in UCI format (required)
     * @param offeringDraw Whether to offer (or agree to) a draw (optional)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The move was successfully made. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The move failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameMoveWithHttpInfo(String gameId, String move, Boolean offeringDraw) throws ApiException {
        okhttp3.Call localVarCall = boardGameMoveValidateBeforeCall(gameId, move, offeringDraw, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Make a Board move (asynchronously)
     * Make a move in a game being played with the Board API.  The move can also contain a draw offer/agreement. 
     * @param gameId  (required)
     * @param move The move to play, in UCI format (required)
     * @param offeringDraw Whether to offer (or agree to) a draw (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The move was successfully made. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The move failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameMoveAsync(String gameId, String move, Boolean offeringDraw, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameMoveValidateBeforeCall(gameId, move, offeringDraw, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameResign
     * @param gameId  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game was successfully resigned. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The resigning from the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameResignCall(String gameId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/resign"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameResignValidateBeforeCall(String gameId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameResign(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameResignCall(gameId, _callback);
        return localVarCall;

    }

    /**
     * Resign a game
     * Resign a game being played with the Board API. 
     * @param gameId  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game was successfully resigned. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The resigning from the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameResign(String gameId) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameResignWithHttpInfo(gameId);
        return localVarResp.getData();
    }

    /**
     * Resign a game
     * Resign a game being played with the Board API. 
     * @param gameId  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game was successfully resigned. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The resigning from the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameResignWithHttpInfo(String gameId) throws ApiException {
        okhttp3.Call localVarCall = boardGameResignValidateBeforeCall(gameId, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Resign a game (asynchronously)
     * Resign a game being played with the Board API. 
     * @param gameId  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game was successfully resigned. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The resigning from the game failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameResignAsync(String gameId, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameResignValidateBeforeCall(gameId, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameStream
     * @param gameId  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of the game. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The game was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameStreamCall(String gameId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/stream/{gameId}"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/x-ndjson", "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameStreamValidateBeforeCall(String gameId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameStream(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameStreamCall(gameId, _callback);
        return localVarCall;

    }

    /**
     * Stream Board game state
     *  Stream the state of a game being played with the Board API, as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  Use this endpoint to get updates about the game in real-time, with a single request.  Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameFull&#x60; Full game data. All values are immutable, except for the &#x60;state&#x60; field.   - &#x60;gameState&#x60; Current state of the game. Immutable values not included. Sent when a move is played, a draw is offered, or when the game ends.   - &#x60;chatLine&#x60; Chat message sent by a user in the &#x60;room&#x60; \&quot;player\&quot; or \&quot;spectator\&quot;.    The first line is always of type &#x60;gameFull&#x60;.
     * @param gameId  (required)
     * @return GameStreamEvent
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of the game. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The game was not found. </td><td>  -  </td></tr>
     </table>
     */
    public GameStreamEvent boardGameStream(String gameId) throws ApiException {
        ApiResponse<GameStreamEvent> localVarResp = boardGameStreamWithHttpInfo(gameId);
        return localVarResp.getData();
    }

    /**
     * Stream Board game state
     *  Stream the state of a game being played with the Board API, as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  Use this endpoint to get updates about the game in real-time, with a single request.  Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameFull&#x60; Full game data. All values are immutable, except for the &#x60;state&#x60; field.   - &#x60;gameState&#x60; Current state of the game. Immutable values not included. Sent when a move is played, a draw is offered, or when the game ends.   - &#x60;chatLine&#x60; Chat message sent by a user in the &#x60;room&#x60; \&quot;player\&quot; or \&quot;spectator\&quot;.    The first line is always of type &#x60;gameFull&#x60;.
     * @param gameId  (required)
     * @return ApiResponse&lt;GameStreamEvent&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of the game. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The game was not found. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GameStreamEvent> boardGameStreamWithHttpInfo(String gameId) throws ApiException {
        okhttp3.Call localVarCall = boardGameStreamValidateBeforeCall(gameId, null);
        Type localVarReturnType = new TypeToken<GameStreamEvent>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Stream Board game state (asynchronously)
     *  Stream the state of a game being played with the Board API, as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  Use this endpoint to get updates about the game in real-time, with a single request.  Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameFull&#x60; Full game data. All values are immutable, except for the &#x60;state&#x60; field.   - &#x60;gameState&#x60; Current state of the game. Immutable values not included. Sent when a move is played, a draw is offered, or when the game ends.   - &#x60;chatLine&#x60; Chat message sent by a user in the &#x60;room&#x60; \&quot;player\&quot; or \&quot;spectator\&quot;.    The first line is always of type &#x60;gameFull&#x60;.
     * @param gameId  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The stream of the game. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The game was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameStreamAsync(String gameId, final ApiCallback<GameStreamEvent> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameStreamValidateBeforeCall(gameId, _callback);
        Type localVarReturnType = new TypeToken<GameStreamEvent>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for boardGameTakeback
     * @param gameId  (required)
     * @param accept  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The takeback offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The takeback offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameTakebackCall(String gameId, Boolean accept, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/board/game/{gameId}/takeback/{accept}"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()))
            .replaceAll("\\{" + "accept" + "\\}", localVarApiClient.escapeString(accept.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call boardGameTakebackValidateBeforeCall(String gameId, Boolean accept, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling boardGameTakeback(Async)");
        }
        
        // verify the required parameter 'accept' is set
        if (accept == null) {
            throw new ApiException("Missing the required parameter 'accept' when calling boardGameTakeback(Async)");
        }
        

        okhttp3.Call localVarCall = boardGameTakebackCall(gameId, accept, _callback);
        return localVarCall;

    }

    /**
     * Handle takeback offers
     * Create/accept/decline takebacks. - &#x60;yes&#x60;: Propose a takeback, or accept the opponent&#39;s takeback offer. - &#x60;no&#x60;: Decline a takeback offer from the opponent. 
     * @param gameId  (required)
     * @param accept  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The takeback offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The takeback offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok boardGameTakeback(String gameId, Boolean accept) throws ApiException {
        ApiResponse<Ok> localVarResp = boardGameTakebackWithHttpInfo(gameId, accept);
        return localVarResp.getData();
    }

    /**
     * Handle takeback offers
     * Create/accept/decline takebacks. - &#x60;yes&#x60;: Propose a takeback, or accept the opponent&#39;s takeback offer. - &#x60;no&#x60;: Decline a takeback offer from the opponent. 
     * @param gameId  (required)
     * @param accept  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The takeback offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The takeback offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> boardGameTakebackWithHttpInfo(String gameId, Boolean accept) throws ApiException {
        okhttp3.Call localVarCall = boardGameTakebackValidateBeforeCall(gameId, accept, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Handle takeback offers (asynchronously)
     * Create/accept/decline takebacks. - &#x60;yes&#x60;: Propose a takeback, or accept the opponent&#39;s takeback offer. - &#x60;no&#x60;: Decline a takeback offer from the opponent. 
     * @param gameId  (required)
     * @param accept  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The takeback offer was successfully sent. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The takeback offering failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call boardGameTakebackAsync(String gameId, Boolean accept, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = boardGameTakebackValidateBeforeCall(gameId, accept, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
