/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import java.math.BigDecimal;
import org.openapitools.client.model.ChallengeJson;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.GameJson;
import org.openapitools.client.model.InlineResponse2003;
import org.openapitools.client.model.NotFound;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.VariantKey;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ChallengesApi {
    private ApiClient localVarApiClient;

    public ChallengesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ChallengesApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for adminChallengeTokens
     * @param users Usernames separated with commas (required)
     * @param description User visible description of the token (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The &#x60;challenge:write&#x60; tokens of each user </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the tokens failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call adminChallengeTokensCall(String users, String description, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/token/admin-challenge";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (users != null) {
            localVarFormParams.put("users", users);
        }

        if (description != null) {
            localVarFormParams.put("description", description);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call adminChallengeTokensValidateBeforeCall(String users, String description, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'users' is set
        if (users == null) {
            throw new ApiException("Missing the required parameter 'users' when calling adminChallengeTokens(Async)");
        }
        
        // verify the required parameter 'description' is set
        if (description == null) {
            throw new ApiException("Missing the required parameter 'description' when calling adminChallengeTokens(Async)");
        }
        

        okhttp3.Call localVarCall = adminChallengeTokensCall(users, description, _callback);
        return localVarCall;

    }

    /**
     * Admin challenge tokens
     * **For administrators only. You are not allowed to use this endpoint.**  Create and obtain &#x60;challenge:write&#x60; tokens for multiple users.  If a similar token already exists for a user, it is reused. This endpoint is idempotent. 
     * @param users Usernames separated with commas (required)
     * @param description User visible description of the token (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The &#x60;challenge:write&#x60; tokens of each user </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the tokens failed. </td><td>  -  </td></tr>
     </table>
     */
    public void adminChallengeTokens(String users, String description) throws ApiException {
        adminChallengeTokensWithHttpInfo(users, description);
    }

    /**
     * Admin challenge tokens
     * **For administrators only. You are not allowed to use this endpoint.**  Create and obtain &#x60;challenge:write&#x60; tokens for multiple users.  If a similar token already exists for a user, it is reused. This endpoint is idempotent. 
     * @param users Usernames separated with commas (required)
     * @param description User visible description of the token (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The &#x60;challenge:write&#x60; tokens of each user </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the tokens failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> adminChallengeTokensWithHttpInfo(String users, String description) throws ApiException {
        okhttp3.Call localVarCall = adminChallengeTokensValidateBeforeCall(users, description, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Admin challenge tokens (asynchronously)
     * **For administrators only. You are not allowed to use this endpoint.**  Create and obtain &#x60;challenge:write&#x60; tokens for multiple users.  If a similar token already exists for a user, it is reused. This endpoint is idempotent. 
     * @param users Usernames separated with commas (required)
     * @param description User visible description of the token (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The &#x60;challenge:write&#x60; tokens of each user </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the tokens failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call adminChallengeTokensAsync(String users, String description, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = adminChallengeTokensValidateBeforeCall(users, description, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeAccept
     * @param challengeId  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully accepted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to accept was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeAcceptCall(String challengeId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/{challengeId}/accept"
            .replaceAll("\\{" + "challengeId" + "\\}", localVarApiClient.escapeString(challengeId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeAcceptValidateBeforeCall(String challengeId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'challengeId' is set
        if (challengeId == null) {
            throw new ApiException("Missing the required parameter 'challengeId' when calling challengeAccept(Async)");
        }
        

        okhttp3.Call localVarCall = challengeAcceptCall(challengeId, _callback);
        return localVarCall;

    }

    /**
     * Accept a challenge
     * Accept an incoming challenge.  You should receive a &#x60;gameStart&#x60; event on the [incoming events stream](#operation/apiStreamEvent). 
     * @param challengeId  (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully accepted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to accept was not found. </td><td>  -  </td></tr>
     </table>
     */
    public Ok challengeAccept(String challengeId) throws ApiException {
        ApiResponse<Ok> localVarResp = challengeAcceptWithHttpInfo(challengeId);
        return localVarResp.getData();
    }

    /**
     * Accept a challenge
     * Accept an incoming challenge.  You should receive a &#x60;gameStart&#x60; event on the [incoming events stream](#operation/apiStreamEvent). 
     * @param challengeId  (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully accepted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to accept was not found. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> challengeAcceptWithHttpInfo(String challengeId) throws ApiException {
        okhttp3.Call localVarCall = challengeAcceptValidateBeforeCall(challengeId, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Accept a challenge (asynchronously)
     * Accept an incoming challenge.  You should receive a &#x60;gameStart&#x60; event on the [incoming events stream](#operation/apiStreamEvent). 
     * @param challengeId  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully accepted. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to accept was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeAcceptAsync(String challengeId, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeAcceptValidateBeforeCall(challengeId, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeAi
     * @param level AI strength (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to ColorEnum.RANDOM)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game with Lichess AI was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of a game with Lichess AI failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeAiCall(BigDecimal level, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/ai";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (level != null) {
            localVarFormParams.put("level", level);
        }

        if (clockLimit != null) {
            localVarFormParams.put("clock.limit", clockLimit);
        }

        if (clockIncrement != null) {
            localVarFormParams.put("clock.increment", clockIncrement);
        }

        if (days != null) {
            localVarFormParams.put("days", days);
        }

        if (color != null) {
            localVarFormParams.put("color", color);
        }

        if (variant != null) {
            localVarFormParams.put("variant", variant);
        }

        if (fen != null) {
            localVarFormParams.put("fen", fen);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeAiValidateBeforeCall(BigDecimal level, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = challengeAiCall(level, clockLimit, clockIncrement, days, color, variant, fen, _callback);
        return localVarCall;

    }

    /**
     * Challenge the AI
     * Start a game with Lichess AI.  You will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. 
     * @param level AI strength (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to ColorEnum.RANDOM)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @return GameJson
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game with Lichess AI was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of a game with Lichess AI failed. </td><td>  -  </td></tr>
     </table>
     */
    public GameJson challengeAi(BigDecimal level, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen) throws ApiException {
        ApiResponse<GameJson> localVarResp = challengeAiWithHttpInfo(level, clockLimit, clockIncrement, days, color, variant, fen);
        return localVarResp.getData();
    }

    /**
     * Challenge the AI
     * Start a game with Lichess AI.  You will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. 
     * @param level AI strength (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to ColorEnum.RANDOM)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @return ApiResponse&lt;GameJson&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game with Lichess AI was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of a game with Lichess AI failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GameJson> challengeAiWithHttpInfo(BigDecimal level, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen) throws ApiException {
        okhttp3.Call localVarCall = challengeAiValidateBeforeCall(level, clockLimit, clockIncrement, days, color, variant, fen, null);
        Type localVarReturnType = new TypeToken<GameJson>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Challenge the AI (asynchronously)
     * Start a game with Lichess AI.  You will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. 
     * @param level AI strength (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to ColorEnum.RANDOM)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The game with Lichess AI was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of a game with Lichess AI failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeAiAsync(BigDecimal level, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, final ApiCallback<GameJson> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeAiValidateBeforeCall(level, clockLimit, clockIncrement, days, color, variant, fen, _callback);
        Type localVarReturnType = new TypeToken<GameJson>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeCancel
     * @param challengeId  (required)
     * @param opponentToken Optional &#x60;challenge:write&#x60; token of the opponent. If set, the game can be canceled even if both players have moved. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully cancelled. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to cancel was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeCancelCall(String challengeId, String opponentToken, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/{challengeId}/cancel"
            .replaceAll("\\{" + "challengeId" + "\\}", localVarApiClient.escapeString(challengeId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (opponentToken != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("opponentToken", opponentToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeCancelValidateBeforeCall(String challengeId, String opponentToken, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'challengeId' is set
        if (challengeId == null) {
            throw new ApiException("Missing the required parameter 'challengeId' when calling challengeCancel(Async)");
        }
        

        okhttp3.Call localVarCall = challengeCancelCall(challengeId, opponentToken, _callback);
        return localVarCall;

    }

    /**
     * Cancel a challenge
     * Cancel a challenge you sent, or aborts the game if the challenge was accepted, but the game was not yet played. Note that the ID of a game is the same as the ID of the challenge that created it. 
     * @param challengeId  (required)
     * @param opponentToken Optional &#x60;challenge:write&#x60; token of the opponent. If set, the game can be canceled even if both players have moved. (optional)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully cancelled. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to cancel was not found. </td><td>  -  </td></tr>
     </table>
     */
    public Ok challengeCancel(String challengeId, String opponentToken) throws ApiException {
        ApiResponse<Ok> localVarResp = challengeCancelWithHttpInfo(challengeId, opponentToken);
        return localVarResp.getData();
    }

    /**
     * Cancel a challenge
     * Cancel a challenge you sent, or aborts the game if the challenge was accepted, but the game was not yet played. Note that the ID of a game is the same as the ID of the challenge that created it. 
     * @param challengeId  (required)
     * @param opponentToken Optional &#x60;challenge:write&#x60; token of the opponent. If set, the game can be canceled even if both players have moved. (optional)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully cancelled. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to cancel was not found. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> challengeCancelWithHttpInfo(String challengeId, String opponentToken) throws ApiException {
        okhttp3.Call localVarCall = challengeCancelValidateBeforeCall(challengeId, opponentToken, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Cancel a challenge (asynchronously)
     * Cancel a challenge you sent, or aborts the game if the challenge was accepted, but the game was not yet played. Note that the ID of a game is the same as the ID of the challenge that created it. 
     * @param challengeId  (required)
     * @param opponentToken Optional &#x60;challenge:write&#x60; token of the opponent. If set, the game can be canceled even if both players have moved. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully cancelled. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to cancel was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeCancelAsync(String challengeId, String opponentToken, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeCancelValidateBeforeCall(challengeId, opponentToken, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeCreate
     * @param username  (required)
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to random)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. Castling moves will use UCI_Chess960 notation, for example e1h1 instead of e1g1. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param keepAliveStream If set, the response is streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). The challenge is kept alive until the connection is closed by the client. When the challenge is accepted, declined or canceled, a message of the form &#x60;{\\\&quot;done\\\&quot;:\\\&quot;accepted\\\&quot;}&#x60; is sent, then the connection is closed by the server. If not set, the response is not streamed, and the challenge expires after 20s if not accepted.  (optional)
     * @param acceptByToken Immediately accept the challenge and create the game. Pass in an OAuth token (with the &#x60;challenge:write&#x60; scope) for the receiving user. On success, the response will contain a &#x60;game&#x60; field instead of a &#x60;challenge&#x60; field.  Alternatively, consider the [bulk pairing API](#operation/bulkPairingCreate).  (optional)
     * @param message **Only if &#x60;acceptByToken&#x60; is set.**  Message that is sent to each player, when the game is created. It is sent from your user account.  &#x60;{opponent}&#x60;, &#x60;{player}&#x60; and &#x60;{game}&#x60; are placeholders that will be replaced with the opponent name, player name, and the game URLs.  You can omit this field to send the default message, but if you set your own message, it must at least contain the &#x60;{game}&#x60; placeholder.  (optional, default to &quot;Your game with {opponent} is ready: {game}.&quot;)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeCreateCall(String username, Boolean rated, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, Boolean keepAliveStream, String acceptByToken, String message, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/{username}"
            .replaceAll("\\{" + "username" + "\\}", localVarApiClient.escapeString(username.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (rated != null) {
            localVarFormParams.put("rated", rated);
        }

        if (clockLimit != null) {
            localVarFormParams.put("clock.limit", clockLimit);
        }

        if (clockIncrement != null) {
            localVarFormParams.put("clock.increment", clockIncrement);
        }

        if (days != null) {
            localVarFormParams.put("days", days);
        }

        if (color != null) {
            localVarFormParams.put("color", color);
        }

        if (variant != null) {
            localVarFormParams.put("variant", variant);
        }

        if (fen != null) {
            localVarFormParams.put("fen", fen);
        }

        if (keepAliveStream != null) {
            localVarFormParams.put("keepAliveStream", keepAliveStream);
        }

        if (acceptByToken != null) {
            localVarFormParams.put("acceptByToken", acceptByToken);
        }

        if (message != null) {
            localVarFormParams.put("message", message);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeCreateValidateBeforeCall(String username, Boolean rated, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, Boolean keepAliveStream, String acceptByToken, String message, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'username' is set
        if (username == null) {
            throw new ApiException("Missing the required parameter 'username' when calling challengeCreate(Async)");
        }
        

        okhttp3.Call localVarCall = challengeCreateCall(username, rated, clockLimit, clockIncrement, days, color, variant, fen, keepAliveStream, acceptByToken, message, _callback);
        return localVarCall;

    }

    /**
     * Create a challenge
     * Challenge someone to play. The targeted player can choose to accept or decline.  If the challenge is accepted, you will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. The game ID will be the same as the challenge ID.  If you also have an OAuth token with &#x60;challenge:write&#x60; scope for the receiving user, you can make them accept the challenge immediately by setting the &#x60;acceptByToken&#x60; field.  Challenges for realtime games (not correspondence) expire after 20s if not accepted. To prevent that, use the &#x60;keepAliveStream&#x60; flag described below. 
     * @param username  (required)
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to random)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. Castling moves will use UCI_Chess960 notation, for example e1h1 instead of e1g1. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param keepAliveStream If set, the response is streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). The challenge is kept alive until the connection is closed by the client. When the challenge is accepted, declined or canceled, a message of the form &#x60;{\\\&quot;done\\\&quot;:\\\&quot;accepted\\\&quot;}&#x60; is sent, then the connection is closed by the server. If not set, the response is not streamed, and the challenge expires after 20s if not accepted.  (optional)
     * @param acceptByToken Immediately accept the challenge and create the game. Pass in an OAuth token (with the &#x60;challenge:write&#x60; scope) for the receiving user. On success, the response will contain a &#x60;game&#x60; field instead of a &#x60;challenge&#x60; field.  Alternatively, consider the [bulk pairing API](#operation/bulkPairingCreate).  (optional)
     * @param message **Only if &#x60;acceptByToken&#x60; is set.**  Message that is sent to each player, when the game is created. It is sent from your user account.  &#x60;{opponent}&#x60;, &#x60;{player}&#x60; and &#x60;{game}&#x60; are placeholders that will be replaced with the opponent name, player name, and the game URLs.  You can omit this field to send the default message, but if you set your own message, it must at least contain the &#x60;{game}&#x60; placeholder.  (optional, default to &quot;Your game with {opponent} is ready: {game}.&quot;)
     * @return ChallengeJson
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public ChallengeJson challengeCreate(String username, Boolean rated, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, Boolean keepAliveStream, String acceptByToken, String message) throws ApiException {
        ApiResponse<ChallengeJson> localVarResp = challengeCreateWithHttpInfo(username, rated, clockLimit, clockIncrement, days, color, variant, fen, keepAliveStream, acceptByToken, message);
        return localVarResp.getData();
    }

    /**
     * Create a challenge
     * Challenge someone to play. The targeted player can choose to accept or decline.  If the challenge is accepted, you will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. The game ID will be the same as the challenge ID.  If you also have an OAuth token with &#x60;challenge:write&#x60; scope for the receiving user, you can make them accept the challenge immediately by setting the &#x60;acceptByToken&#x60; field.  Challenges for realtime games (not correspondence) expire after 20s if not accepted. To prevent that, use the &#x60;keepAliveStream&#x60; flag described below. 
     * @param username  (required)
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to random)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. Castling moves will use UCI_Chess960 notation, for example e1h1 instead of e1g1. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param keepAliveStream If set, the response is streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). The challenge is kept alive until the connection is closed by the client. When the challenge is accepted, declined or canceled, a message of the form &#x60;{\\\&quot;done\\\&quot;:\\\&quot;accepted\\\&quot;}&#x60; is sent, then the connection is closed by the server. If not set, the response is not streamed, and the challenge expires after 20s if not accepted.  (optional)
     * @param acceptByToken Immediately accept the challenge and create the game. Pass in an OAuth token (with the &#x60;challenge:write&#x60; scope) for the receiving user. On success, the response will contain a &#x60;game&#x60; field instead of a &#x60;challenge&#x60; field.  Alternatively, consider the [bulk pairing API](#operation/bulkPairingCreate).  (optional)
     * @param message **Only if &#x60;acceptByToken&#x60; is set.**  Message that is sent to each player, when the game is created. It is sent from your user account.  &#x60;{opponent}&#x60;, &#x60;{player}&#x60; and &#x60;{game}&#x60; are placeholders that will be replaced with the opponent name, player name, and the game URLs.  You can omit this field to send the default message, but if you set your own message, it must at least contain the &#x60;{game}&#x60; placeholder.  (optional, default to &quot;Your game with {opponent} is ready: {game}.&quot;)
     * @return ApiResponse&lt;ChallengeJson&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ChallengeJson> challengeCreateWithHttpInfo(String username, Boolean rated, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, Boolean keepAliveStream, String acceptByToken, String message) throws ApiException {
        okhttp3.Call localVarCall = challengeCreateValidateBeforeCall(username, rated, clockLimit, clockIncrement, days, color, variant, fen, keepAliveStream, acceptByToken, message, null);
        Type localVarReturnType = new TypeToken<ChallengeJson>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create a challenge (asynchronously)
     * Challenge someone to play. The targeted player can choose to accept or decline.  If the challenge is accepted, you will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. The game ID will be the same as the challenge ID.  If you also have an OAuth token with &#x60;challenge:write&#x60; scope for the receiving user, you can make them accept the challenge immediately by setting the &#x60;acceptByToken&#x60; field.  Challenges for realtime games (not correspondence) expire after 20s if not accepted. To prevent that, use the &#x60;keepAliveStream&#x60; flag described below. 
     * @param username  (required)
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param days Days per move, for correspondence games. Clock settings must be omitted. (optional)
     * @param color Which color you get to play (optional, default to random)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. Castling moves will use UCI_Chess960 notation, for example e1h1 instead of e1g1. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param keepAliveStream If set, the response is streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). The challenge is kept alive until the connection is closed by the client. When the challenge is accepted, declined or canceled, a message of the form &#x60;{\\\&quot;done\\\&quot;:\\\&quot;accepted\\\&quot;}&#x60; is sent, then the connection is closed by the server. If not set, the response is not streamed, and the challenge expires after 20s if not accepted.  (optional)
     * @param acceptByToken Immediately accept the challenge and create the game. Pass in an OAuth token (with the &#x60;challenge:write&#x60; scope) for the receiving user. On success, the response will contain a &#x60;game&#x60; field instead of a &#x60;challenge&#x60; field.  Alternatively, consider the [bulk pairing API](#operation/bulkPairingCreate).  (optional)
     * @param message **Only if &#x60;acceptByToken&#x60; is set.**  Message that is sent to each player, when the game is created. It is sent from your user account.  &#x60;{opponent}&#x60;, &#x60;{player}&#x60; and &#x60;{game}&#x60; are placeholders that will be replaced with the opponent name, player name, and the game URLs.  You can omit this field to send the default message, but if you set your own message, it must at least contain the &#x60;{game}&#x60; placeholder.  (optional, default to &quot;Your game with {opponent} is ready: {game}.&quot;)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeCreateAsync(String username, Boolean rated, BigDecimal clockLimit, Integer clockIncrement, Integer days, String color, VariantKey variant, String fen, Boolean keepAliveStream, String acceptByToken, String message, final ApiCallback<ChallengeJson> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeCreateValidateBeforeCall(username, rated, clockLimit, clockIncrement, days, color, variant, fen, keepAliveStream, acceptByToken, message, _callback);
        Type localVarReturnType = new TypeToken<ChallengeJson>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeDecline
     * @param challengeId  (required)
     * @param reason Reason challenge was declined. It will be translated to the player&#39;s language. See [the full list in the translation file](https://github.com/ornicar/lila/blob/43fbd61029ff3960a21fbd213944bed66325696d/translation/source/challenge.xml#L14). (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully declined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to decline was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeDeclineCall(String challengeId, String reason, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/{challengeId}/decline"
            .replaceAll("\\{" + "challengeId" + "\\}", localVarApiClient.escapeString(challengeId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (reason != null) {
            localVarFormParams.put("reason", reason);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeDeclineValidateBeforeCall(String challengeId, String reason, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'challengeId' is set
        if (challengeId == null) {
            throw new ApiException("Missing the required parameter 'challengeId' when calling challengeDecline(Async)");
        }
        

        okhttp3.Call localVarCall = challengeDeclineCall(challengeId, reason, _callback);
        return localVarCall;

    }

    /**
     * Decline a challenge
     * Decline an incoming challenge. 
     * @param challengeId  (required)
     * @param reason Reason challenge was declined. It will be translated to the player&#39;s language. See [the full list in the translation file](https://github.com/ornicar/lila/blob/43fbd61029ff3960a21fbd213944bed66325696d/translation/source/challenge.xml#L14). (optional)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully declined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to decline was not found. </td><td>  -  </td></tr>
     </table>
     */
    public Ok challengeDecline(String challengeId, String reason) throws ApiException {
        ApiResponse<Ok> localVarResp = challengeDeclineWithHttpInfo(challengeId, reason);
        return localVarResp.getData();
    }

    /**
     * Decline a challenge
     * Decline an incoming challenge. 
     * @param challengeId  (required)
     * @param reason Reason challenge was declined. It will be translated to the player&#39;s language. See [the full list in the translation file](https://github.com/ornicar/lila/blob/43fbd61029ff3960a21fbd213944bed66325696d/translation/source/challenge.xml#L14). (optional)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully declined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to decline was not found. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> challengeDeclineWithHttpInfo(String challengeId, String reason) throws ApiException {
        okhttp3.Call localVarCall = challengeDeclineValidateBeforeCall(challengeId, reason, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Decline a challenge (asynchronously)
     * Decline an incoming challenge. 
     * @param challengeId  (required)
     * @param reason Reason challenge was declined. It will be translated to the player&#39;s language. See [the full list in the translation file](https://github.com/ornicar/lila/blob/43fbd61029ff3960a21fbd213944bed66325696d/translation/source/challenge.xml#L14). (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully declined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 404 </td><td> The challenge to decline was not found. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeDeclineAsync(String challengeId, String reason, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeDeclineValidateBeforeCall(challengeId, reason, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeList
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of challenges created by or targeted at the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call challengeListCall(final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeListValidateBeforeCall(final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = challengeListCall(_callback);
        return localVarCall;

    }

    /**
     * List your challenges
     * Get a list of challenges created by or targeted at you. 
     * @return InlineResponse2003
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of challenges created by or targeted at the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public InlineResponse2003 challengeList() throws ApiException {
        ApiResponse<InlineResponse2003> localVarResp = challengeListWithHttpInfo();
        return localVarResp.getData();
    }

    /**
     * List your challenges
     * Get a list of challenges created by or targeted at you. 
     * @return ApiResponse&lt;InlineResponse2003&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of challenges created by or targeted at the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<InlineResponse2003> challengeListWithHttpInfo() throws ApiException {
        okhttp3.Call localVarCall = challengeListValidateBeforeCall(null);
        Type localVarReturnType = new TypeToken<InlineResponse2003>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * List your challenges (asynchronously)
     * Get a list of challenges created by or targeted at you. 
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of challenges created by or targeted at the logged in user. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call challengeListAsync(final ApiCallback<InlineResponse2003> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeListValidateBeforeCall(_callback);
        Type localVarReturnType = new TypeToken<InlineResponse2003>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeOpen
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param name Optional name for the challenge, that players will see on the challenge page. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeOpenCall(Boolean rated, BigDecimal clockLimit, Integer clockIncrement, VariantKey variant, String fen, String name, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/open";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (rated != null) {
            localVarFormParams.put("rated", rated);
        }

        if (clockLimit != null) {
            localVarFormParams.put("clock.limit", clockLimit);
        }

        if (clockIncrement != null) {
            localVarFormParams.put("clock.increment", clockIncrement);
        }

        if (variant != null) {
            localVarFormParams.put("variant", variant);
        }

        if (fen != null) {
            localVarFormParams.put("fen", fen);
        }

        if (name != null) {
            localVarFormParams.put("name", name);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeOpenValidateBeforeCall(Boolean rated, BigDecimal clockLimit, Integer clockIncrement, VariantKey variant, String fen, String name, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = challengeOpenCall(rated, clockLimit, clockIncrement, variant, fen, name, _callback);
        return localVarCall;

    }

    /**
     * Open-ended challenge
     * Create a challenge that any 2 players can join.  Share the URL of the challenge. the first 2 players to click it will be paired for a game.  The response body also contains &#x60;whiteUrl&#x60; and &#x60;blackUrl&#x60;. You can control which color each player gets by giving them these URLs, instead of the main challenge URL.  Open challenges expire after 24h.  To directly pair 2 known players, use [this endpoint](#operation/challengeCreate) instead, with the &#x60;acceptByToken&#x60; parameter. 
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param name Optional name for the challenge, that players will see on the challenge page. (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public Object challengeOpen(Boolean rated, BigDecimal clockLimit, Integer clockIncrement, VariantKey variant, String fen, String name) throws ApiException {
        ApiResponse<Object> localVarResp = challengeOpenWithHttpInfo(rated, clockLimit, clockIncrement, variant, fen, name);
        return localVarResp.getData();
    }

    /**
     * Open-ended challenge
     * Create a challenge that any 2 players can join.  Share the URL of the challenge. the first 2 players to click it will be paired for a game.  The response body also contains &#x60;whiteUrl&#x60; and &#x60;blackUrl&#x60;. You can control which color each player gets by giving them these URLs, instead of the main challenge URL.  Open challenges expire after 24h.  To directly pair 2 known players, use [this endpoint](#operation/challengeCreate) instead, with the &#x60;acceptByToken&#x60; parameter. 
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param name Optional name for the challenge, that players will see on the challenge page. (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Object> challengeOpenWithHttpInfo(Boolean rated, BigDecimal clockLimit, Integer clockIncrement, VariantKey variant, String fen, String name) throws ApiException {
        okhttp3.Call localVarCall = challengeOpenValidateBeforeCall(rated, clockLimit, clockIncrement, variant, fen, name, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Open-ended challenge (asynchronously)
     * Create a challenge that any 2 players can join.  Share the URL of the challenge. the first 2 players to click it will be paired for a game.  The response body also contains &#x60;whiteUrl&#x60; and &#x60;blackUrl&#x60;. You can control which color each player gets by giving them these URLs, instead of the main challenge URL.  Open challenges expire after 24h.  To directly pair 2 known players, use [this endpoint](#operation/challengeCreate) instead, with the &#x60;acceptByToken&#x60; parameter. 
     * @param rated Game is rated and impacts players ratings (optional)
     * @param clockLimit Clock initial time in seconds. If empty, a correspondence game is created. (optional)
     * @param clockIncrement Clock increment in seconds. If empty, a correspondence game is created. (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param fen Custom initial position (in FEN). Variant must be standard, and the game cannot be rated. (optional, default to &quot;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1&quot;)
     * @param name Optional name for the challenge, that players will see on the challenge page. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The challenge was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the challenge failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call challengeOpenAsync(Boolean rated, BigDecimal clockLimit, Integer clockIncrement, VariantKey variant, String fen, String name, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeOpenValidateBeforeCall(rated, clockLimit, clockIncrement, variant, fen, name, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for challengeStartClocks
     * @param gameId  (required)
     * @param token1 OAuth token of a player (optional)
     * @param token2 OAuth token of the other player (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The clock of a game was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call challengeStartClocksCall(String gameId, String token1, String token2, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/challenge/{gameId}/start-clocks"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (token1 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("token1", token1));
        }

        if (token2 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("token2", token2));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call challengeStartClocksValidateBeforeCall(String gameId, String token1, String token2, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling challengeStartClocks(Async)");
        }
        

        okhttp3.Call localVarCall = challengeStartClocksCall(gameId, token1, token2, _callback);
        return localVarCall;

    }

    /**
     * Start clocks of a game
     * Start the clocks of a game immediately, even if a player has not yet made a move.  Requires the OAuth tokens of both players with &#x60;challenge:write&#x60; scope.  If the clocks have already started, the call will have no effect. 
     * @param gameId  (required)
     * @param token1 OAuth token of a player (optional)
     * @param token2 OAuth token of the other player (optional)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The clock of a game was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public Ok challengeStartClocks(String gameId, String token1, String token2) throws ApiException {
        ApiResponse<Ok> localVarResp = challengeStartClocksWithHttpInfo(gameId, token1, token2);
        return localVarResp.getData();
    }

    /**
     * Start clocks of a game
     * Start the clocks of a game immediately, even if a player has not yet made a move.  Requires the OAuth tokens of both players with &#x60;challenge:write&#x60; scope.  If the clocks have already started, the call will have no effect. 
     * @param gameId  (required)
     * @param token1 OAuth token of a player (optional)
     * @param token2 OAuth token of the other player (optional)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The clock of a game was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Ok> challengeStartClocksWithHttpInfo(String gameId, String token1, String token2) throws ApiException {
        okhttp3.Call localVarCall = challengeStartClocksValidateBeforeCall(gameId, token1, token2, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Start clocks of a game (asynchronously)
     * Start the clocks of a game immediately, even if a player has not yet made a move.  Requires the OAuth tokens of both players with &#x60;challenge:write&#x60; scope.  If the clocks have already started, the call will have no effect. 
     * @param gameId  (required)
     * @param token1 OAuth token of a player (optional)
     * @param token2 OAuth token of the other player (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The clock of a game was successfully started. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call challengeStartClocksAsync(String gameId, String token1, String token2, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = challengeStartClocksValidateBeforeCall(gameId, token1, token2, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for roundAddTime
     * @param gameId  (required)
     * @param seconds How many seconds to give (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Time was successfully added to the opponent&#39;s clock. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call roundAddTimeCall(String gameId, String seconds, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/round/{gameId}/add-time/{seconds}"
            .replaceAll("\\{" + "gameId" + "\\}", localVarApiClient.escapeString(gameId.toString()))
            .replaceAll("\\{" + "seconds" + "\\}", localVarApiClient.escapeString(seconds.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call roundAddTimeValidateBeforeCall(String gameId, String seconds, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'gameId' is set
        if (gameId == null) {
            throw new ApiException("Missing the required parameter 'gameId' when calling roundAddTime(Async)");
        }
        
        // verify the required parameter 'seconds' is set
        if (seconds == null) {
            throw new ApiException("Missing the required parameter 'seconds' when calling roundAddTime(Async)");
        }
        

        okhttp3.Call localVarCall = roundAddTimeCall(gameId, seconds, _callback);
        return localVarCall;

    }

    /**
     * Add time to the opponent clock
     * Add seconds to the opponent&#39;s clock. Can be used to create games with time odds. 
     * @param gameId  (required)
     * @param seconds How many seconds to give (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Time was successfully added to the opponent&#39;s clock. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public Ok roundAddTime(String gameId, String seconds) throws ApiException {
        ApiResponse<Ok> localVarResp = roundAddTimeWithHttpInfo(gameId, seconds);
        return localVarResp.getData();
    }

    /**
     * Add time to the opponent clock
     * Add seconds to the opponent&#39;s clock. Can be used to create games with time odds. 
     * @param gameId  (required)
     * @param seconds How many seconds to give (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Time was successfully added to the opponent&#39;s clock. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Ok> roundAddTimeWithHttpInfo(String gameId, String seconds) throws ApiException {
        okhttp3.Call localVarCall = roundAddTimeValidateBeforeCall(gameId, seconds, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Add time to the opponent clock (asynchronously)
     * Add seconds to the opponent&#39;s clock. Can be used to create games with time odds. 
     * @param gameId  (required)
     * @param seconds How many seconds to give (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Time was successfully added to the opponent&#39;s clock. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call roundAddTimeAsync(String gameId, String seconds, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = roundAddTimeValidateBeforeCall(gameId, seconds, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
