/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.Error;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class OAuthApi {
    private ApiClient localVarApiClient;

    public OAuthApi() {
        this(Configuration.getDefaultApiClient());
    }

    public OAuthApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for apiToken
     * @param grantType Must be &#x60;authorization_code&#x60;. (optional)
     * @param code The authorization code that was sent in the &#x60;code&#x60; parameter to your &#x60;redirect_uri&#x60;. (optional)
     * @param codeVerifier A &#x60;code_challenge&#x60; was used to request the authorization code. This must be the &#x60;code_verifier&#x60; it was derived from. (optional)
     * @param redirectUri Must match the &#x60;redirect_uri&#x60; used to request the authorization code. (optional)
     * @param clientId Must match the &#x60;client_id&#x60; used to request the authorization code. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Access token successfully obtained. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Failed to obtain access token. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiTokenCall(String grantType, String code, String codeVerifier, String redirectUri, String clientId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/token";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (grantType != null) {
            localVarFormParams.put("grant_type", grantType);
        }

        if (code != null) {
            localVarFormParams.put("code", code);
        }

        if (codeVerifier != null) {
            localVarFormParams.put("code_verifier", codeVerifier);
        }

        if (redirectUri != null) {
            localVarFormParams.put("redirect_uri", redirectUri);
        }

        if (clientId != null) {
            localVarFormParams.put("client_id", clientId);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiTokenValidateBeforeCall(String grantType, String code, String codeVerifier, String redirectUri, String clientId, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = apiTokenCall(grantType, code, codeVerifier, redirectUri, clientId, _callback);
        return localVarCall;

    }

    /**
     * Obtain access token
     * OAuth2 token endpoint. Exchanges an authorization code for an access token. 
     * @param grantType Must be &#x60;authorization_code&#x60;. (optional)
     * @param code The authorization code that was sent in the &#x60;code&#x60; parameter to your &#x60;redirect_uri&#x60;. (optional)
     * @param codeVerifier A &#x60;code_challenge&#x60; was used to request the authorization code. This must be the &#x60;code_verifier&#x60; it was derived from. (optional)
     * @param redirectUri Must match the &#x60;redirect_uri&#x60; used to request the authorization code. (optional)
     * @param clientId Must match the &#x60;client_id&#x60; used to request the authorization code. (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Access token successfully obtained. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Failed to obtain access token. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public void apiToken(String grantType, String code, String codeVerifier, String redirectUri, String clientId) throws ApiException {
        apiTokenWithHttpInfo(grantType, code, codeVerifier, redirectUri, clientId);
    }

    /**
     * Obtain access token
     * OAuth2 token endpoint. Exchanges an authorization code for an access token. 
     * @param grantType Must be &#x60;authorization_code&#x60;. (optional)
     * @param code The authorization code that was sent in the &#x60;code&#x60; parameter to your &#x60;redirect_uri&#x60;. (optional)
     * @param codeVerifier A &#x60;code_challenge&#x60; was used to request the authorization code. This must be the &#x60;code_verifier&#x60; it was derived from. (optional)
     * @param redirectUri Must match the &#x60;redirect_uri&#x60; used to request the authorization code. (optional)
     * @param clientId Must match the &#x60;client_id&#x60; used to request the authorization code. (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Access token successfully obtained. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Failed to obtain access token. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Void> apiTokenWithHttpInfo(String grantType, String code, String codeVerifier, String redirectUri, String clientId) throws ApiException {
        okhttp3.Call localVarCall = apiTokenValidateBeforeCall(grantType, code, codeVerifier, redirectUri, clientId, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Obtain access token (asynchronously)
     * OAuth2 token endpoint. Exchanges an authorization code for an access token. 
     * @param grantType Must be &#x60;authorization_code&#x60;. (optional)
     * @param code The authorization code that was sent in the &#x60;code&#x60; parameter to your &#x60;redirect_uri&#x60;. (optional)
     * @param codeVerifier A &#x60;code_challenge&#x60; was used to request the authorization code. This must be the &#x60;code_verifier&#x60; it was derived from. (optional)
     * @param redirectUri Must match the &#x60;redirect_uri&#x60; used to request the authorization code. (optional)
     * @param clientId Must match the &#x60;client_id&#x60; used to request the authorization code. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Access token successfully obtained. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Failed to obtain access token. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiTokenAsync(String grantType, String code, String codeVerifier, String redirectUri, String clientId, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiTokenValidateBeforeCall(grantType, code, codeVerifier, redirectUri, clientId, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for apiTokenDelete
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Access token revoked. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiTokenDeleteCall(final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/token";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiTokenDeleteValidateBeforeCall(final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = apiTokenDeleteCall(_callback);
        return localVarCall;

    }

    /**
     * Revoke access token
     * Revokes the access token sent as Bearer for this request.
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Access token revoked. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public void apiTokenDelete() throws ApiException {
        apiTokenDeleteWithHttpInfo();
    }

    /**
     * Revoke access token
     * Revokes the access token sent as Bearer for this request.
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Access token revoked. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Void> apiTokenDeleteWithHttpInfo() throws ApiException {
        okhttp3.Call localVarCall = apiTokenDeleteValidateBeforeCall(null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Revoke access token (asynchronously)
     * Revokes the access token sent as Bearer for this request.
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Access token revoked. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiTokenDeleteAsync(final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiTokenDeleteValidateBeforeCall(_callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for oauth
     * @param responseType Must be &#x60;code&#x60;. (required)
     * @param clientId Arbitrary identifier that uniquely identifies your application. (required)
     * @param redirectUri The absolute URL that the user should be redirected to with the authorization result. (required)
     * @param codeChallengeMethod Must be &#x60;S256&#x60;. (required)
     * @param codeChallenge Compute &#x60;BASE64URL(SHA256(code_verifier))&#x60;. (required)
     * @param scope Space separated list of requested OAuth scopes, if any. (optional)
     * @param state Arbitrary state that will be returned verbatim with the authorization result. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Authorization prompt will be displayed to the user. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call oauthCall(String responseType, String clientId, String redirectUri, String codeChallengeMethod, String codeChallenge, String scope, String state, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/oauth";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (responseType != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("response_type", responseType));
        }

        if (clientId != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("client_id", clientId));
        }

        if (redirectUri != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("redirect_uri", redirectUri));
        }

        if (codeChallengeMethod != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("code_challenge_method", codeChallengeMethod));
        }

        if (codeChallenge != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("code_challenge", codeChallenge));
        }

        if (scope != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("scope", scope));
        }

        if (state != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("state", state));
        }

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call oauthValidateBeforeCall(String responseType, String clientId, String redirectUri, String codeChallengeMethod, String codeChallenge, String scope, String state, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'responseType' is set
        if (responseType == null) {
            throw new ApiException("Missing the required parameter 'responseType' when calling oauth(Async)");
        }
        
        // verify the required parameter 'clientId' is set
        if (clientId == null) {
            throw new ApiException("Missing the required parameter 'clientId' when calling oauth(Async)");
        }
        
        // verify the required parameter 'redirectUri' is set
        if (redirectUri == null) {
            throw new ApiException("Missing the required parameter 'redirectUri' when calling oauth(Async)");
        }
        
        // verify the required parameter 'codeChallengeMethod' is set
        if (codeChallengeMethod == null) {
            throw new ApiException("Missing the required parameter 'codeChallengeMethod' when calling oauth(Async)");
        }
        
        // verify the required parameter 'codeChallenge' is set
        if (codeChallenge == null) {
            throw new ApiException("Missing the required parameter 'codeChallenge' when calling oauth(Async)");
        }
        

        okhttp3.Call localVarCall = oauthCall(responseType, clientId, redirectUri, codeChallengeMethod, codeChallenge, scope, state, _callback);
        return localVarCall;

    }

    /**
     * Request authorization code
     * OAuth2 authorization endpoint.  Start the OAuth2 Authorization Code Flow with PKCE by securely generating two random strings unique to each authorization request: * &#x60;code_verifier&#x60; * &#x60;state&#x60;  Store these in session storage. Make sure not to reveal &#x60;code_verifier&#x60; to eavesdroppers. Do not show it in URLs, do not abuse &#x60;state&#x60; to store it, do not send it over insecure connections. However it is fine if the user themselves can extract &#x60;code_verifier&#x60;, which will always be possible for fully client-side apps.  Then send the user to this endpoint. They will be prompted to grant authorization and then be redirected back to the given &#x60;redirect_uri&#x60;.  If the authorization failed, the following query string parameters will be appended to the redirection: * &#x60;error&#x60;, in particular with value &#x60;access_denied&#x60; if the user    cancelled authorization * &#x60;error_description&#x60; to aid debugging * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  If the authorization succeeded, the following query string parameters will be appended to the redirection: * &#x60;code&#x60;, containing a fresh short-lived authorization code * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  Next, to defend against cross site request forgery, check that the returned &#x60;state&#x60; matches the &#x60;state&#x60; you originally generated.  Finally, continue by using the authorization code to [obtain an access token](#operation/apiToken). 
     * @param responseType Must be &#x60;code&#x60;. (required)
     * @param clientId Arbitrary identifier that uniquely identifies your application. (required)
     * @param redirectUri The absolute URL that the user should be redirected to with the authorization result. (required)
     * @param codeChallengeMethod Must be &#x60;S256&#x60;. (required)
     * @param codeChallenge Compute &#x60;BASE64URL(SHA256(code_verifier))&#x60;. (required)
     * @param scope Space separated list of requested OAuth scopes, if any. (optional)
     * @param state Arbitrary state that will be returned verbatim with the authorization result. (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Authorization prompt will be displayed to the user. </td><td>  -  </td></tr>
     </table>
     */
    public void oauth(String responseType, String clientId, String redirectUri, String codeChallengeMethod, String codeChallenge, String scope, String state) throws ApiException {
        oauthWithHttpInfo(responseType, clientId, redirectUri, codeChallengeMethod, codeChallenge, scope, state);
    }

    /**
     * Request authorization code
     * OAuth2 authorization endpoint.  Start the OAuth2 Authorization Code Flow with PKCE by securely generating two random strings unique to each authorization request: * &#x60;code_verifier&#x60; * &#x60;state&#x60;  Store these in session storage. Make sure not to reveal &#x60;code_verifier&#x60; to eavesdroppers. Do not show it in URLs, do not abuse &#x60;state&#x60; to store it, do not send it over insecure connections. However it is fine if the user themselves can extract &#x60;code_verifier&#x60;, which will always be possible for fully client-side apps.  Then send the user to this endpoint. They will be prompted to grant authorization and then be redirected back to the given &#x60;redirect_uri&#x60;.  If the authorization failed, the following query string parameters will be appended to the redirection: * &#x60;error&#x60;, in particular with value &#x60;access_denied&#x60; if the user    cancelled authorization * &#x60;error_description&#x60; to aid debugging * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  If the authorization succeeded, the following query string parameters will be appended to the redirection: * &#x60;code&#x60;, containing a fresh short-lived authorization code * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  Next, to defend against cross site request forgery, check that the returned &#x60;state&#x60; matches the &#x60;state&#x60; you originally generated.  Finally, continue by using the authorization code to [obtain an access token](#operation/apiToken). 
     * @param responseType Must be &#x60;code&#x60;. (required)
     * @param clientId Arbitrary identifier that uniquely identifies your application. (required)
     * @param redirectUri The absolute URL that the user should be redirected to with the authorization result. (required)
     * @param codeChallengeMethod Must be &#x60;S256&#x60;. (required)
     * @param codeChallenge Compute &#x60;BASE64URL(SHA256(code_verifier))&#x60;. (required)
     * @param scope Space separated list of requested OAuth scopes, if any. (optional)
     * @param state Arbitrary state that will be returned verbatim with the authorization result. (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Authorization prompt will be displayed to the user. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> oauthWithHttpInfo(String responseType, String clientId, String redirectUri, String codeChallengeMethod, String codeChallenge, String scope, String state) throws ApiException {
        okhttp3.Call localVarCall = oauthValidateBeforeCall(responseType, clientId, redirectUri, codeChallengeMethod, codeChallenge, scope, state, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Request authorization code (asynchronously)
     * OAuth2 authorization endpoint.  Start the OAuth2 Authorization Code Flow with PKCE by securely generating two random strings unique to each authorization request: * &#x60;code_verifier&#x60; * &#x60;state&#x60;  Store these in session storage. Make sure not to reveal &#x60;code_verifier&#x60; to eavesdroppers. Do not show it in URLs, do not abuse &#x60;state&#x60; to store it, do not send it over insecure connections. However it is fine if the user themselves can extract &#x60;code_verifier&#x60;, which will always be possible for fully client-side apps.  Then send the user to this endpoint. They will be prompted to grant authorization and then be redirected back to the given &#x60;redirect_uri&#x60;.  If the authorization failed, the following query string parameters will be appended to the redirection: * &#x60;error&#x60;, in particular with value &#x60;access_denied&#x60; if the user    cancelled authorization * &#x60;error_description&#x60; to aid debugging * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  If the authorization succeeded, the following query string parameters will be appended to the redirection: * &#x60;code&#x60;, containing a fresh short-lived authorization code * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  Next, to defend against cross site request forgery, check that the returned &#x60;state&#x60; matches the &#x60;state&#x60; you originally generated.  Finally, continue by using the authorization code to [obtain an access token](#operation/apiToken). 
     * @param responseType Must be &#x60;code&#x60;. (required)
     * @param clientId Arbitrary identifier that uniquely identifies your application. (required)
     * @param redirectUri The absolute URL that the user should be redirected to with the authorization result. (required)
     * @param codeChallengeMethod Must be &#x60;S256&#x60;. (required)
     * @param codeChallenge Compute &#x60;BASE64URL(SHA256(code_verifier))&#x60;. (required)
     * @param scope Space separated list of requested OAuth scopes, if any. (optional)
     * @param state Arbitrary state that will be returned verbatim with the authorization result. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Authorization prompt will be displayed to the user. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call oauthAsync(String responseType, String clientId, String redirectUri, String codeChallengeMethod, String codeChallenge, String scope, String state, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = oauthValidateBeforeCall(responseType, clientId, redirectUri, codeChallengeMethod, codeChallenge, scope, state, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
}
