/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import java.math.BigDecimal;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.SwissUnauthorisedEdit;
import org.openapitools.client.model.VariantKey;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SwissTournamentsApi {
    private ApiClient localVarApiClient;

    public SwissTournamentsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SwissTournamentsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for apiSwissJoin
     * @param id The tournament ID. (required)
     * @param password The tournament password, if one is required (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The tournament was successfully joined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Joining the tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissJoinCall(String id, String password, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/swiss/{id}/join"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (password != null) {
            localVarFormParams.put("password", password);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiSwissJoinValidateBeforeCall(String id, String password, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling apiSwissJoin(Async)");
        }
        

        okhttp3.Call localVarCall = apiSwissJoinCall(id, password, _callback);
        return localVarCall;

    }

    /**
     * Join a Swiss tournament
     * Join a Swiss tournament, possibly with a password. 
     * @param id The tournament ID. (required)
     * @param password The tournament password, if one is required (optional)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The tournament was successfully joined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Joining the tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok apiSwissJoin(String id, String password) throws ApiException {
        ApiResponse<Ok> localVarResp = apiSwissJoinWithHttpInfo(id, password);
        return localVarResp.getData();
    }

    /**
     * Join a Swiss tournament
     * Join a Swiss tournament, possibly with a password. 
     * @param id The tournament ID. (required)
     * @param password The tournament password, if one is required (optional)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The tournament was successfully joined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Joining the tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> apiSwissJoinWithHttpInfo(String id, String password) throws ApiException {
        okhttp3.Call localVarCall = apiSwissJoinValidateBeforeCall(id, password, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Join a Swiss tournament (asynchronously)
     * Join a Swiss tournament, possibly with a password. 
     * @param id The tournament ID. (required)
     * @param password The tournament password, if one is required (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The tournament was successfully joined. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Joining the tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissJoinAsync(String id, String password, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiSwissJoinValidateBeforeCall(id, password, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for apiSwissNew
     * @param teamId ID of the team (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissNewCall(String teamId, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/swiss/new/{teamId}"
            .replaceAll("\\{" + "teamId" + "\\}", localVarApiClient.escapeString(teamId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (name != null) {
            localVarFormParams.put("name", name);
        }

        if (clockLimit != null) {
            localVarFormParams.put("clock.limit", clockLimit);
        }

        if (clockIncrement != null) {
            localVarFormParams.put("clock.increment", clockIncrement);
        }

        if (nbRounds != null) {
            localVarFormParams.put("nbRounds", nbRounds);
        }

        if (startsAt != null) {
            localVarFormParams.put("startsAt", startsAt);
        }

        if (roundInterval != null) {
            localVarFormParams.put("roundInterval", roundInterval);
        }

        if (variant != null) {
            localVarFormParams.put("variant", variant);
        }

        if (description != null) {
            localVarFormParams.put("description", description);
        }

        if (rated != null) {
            localVarFormParams.put("rated", rated);
        }

        if (chatFor != null) {
            localVarFormParams.put("chatFor", chatFor);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiSwissNewValidateBeforeCall(String teamId, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'teamId' is set
        if (teamId == null) {
            throw new ApiException("Missing the required parameter 'teamId' when calling apiSwissNew(Async)");
        }
        
        // verify the required parameter 'clockLimit' is set
        if (clockLimit == null) {
            throw new ApiException("Missing the required parameter 'clockLimit' when calling apiSwissNew(Async)");
        }
        
        // verify the required parameter 'clockIncrement' is set
        if (clockIncrement == null) {
            throw new ApiException("Missing the required parameter 'clockIncrement' when calling apiSwissNew(Async)");
        }
        
        // verify the required parameter 'nbRounds' is set
        if (nbRounds == null) {
            throw new ApiException("Missing the required parameter 'nbRounds' when calling apiSwissNew(Async)");
        }
        

        okhttp3.Call localVarCall = apiSwissNewCall(teamId, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor, _callback);
        return localVarCall;

    }

    /**
     * Create a new Swiss tournament
     * Create a Swiss tournament for your team.  This endpoint mirrors the Swiss tournament form from your team pagee.  You can create up to 12 tournaments per day. 
     * @param teamId ID of the team (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public Object apiSwissNew(String teamId, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor) throws ApiException {
        ApiResponse<Object> localVarResp = apiSwissNewWithHttpInfo(teamId, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor);
        return localVarResp.getData();
    }

    /**
     * Create a new Swiss tournament
     * Create a Swiss tournament for your team.  This endpoint mirrors the Swiss tournament form from your team pagee.  You can create up to 12 tournaments per day. 
     * @param teamId ID of the team (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Object> apiSwissNewWithHttpInfo(String teamId, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor) throws ApiException {
        okhttp3.Call localVarCall = apiSwissNewValidateBeforeCall(teamId, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create a new Swiss tournament (asynchronously)
     * Create a Swiss tournament for your team.  This endpoint mirrors the Swiss tournament form from your team pagee.  You can create up to 12 tournaments per day. 
     * @param teamId ID of the team (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully created. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> The creation of the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissNewAsync(String teamId, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiSwissNewValidateBeforeCall(teamId, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for apiSwissTerminate
     * @param id The Swiss tournament ID. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully terminated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Terminating the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissTerminateCall(String id, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/swiss/{id}/terminate"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiSwissTerminateValidateBeforeCall(String id, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling apiSwissTerminate(Async)");
        }
        

        okhttp3.Call localVarCall = apiSwissTerminateCall(id, _callback);
        return localVarCall;

    }

    /**
     * Terminate a Swiss tournament
     * Terminate a Swiss tournament 
     * @param id The Swiss tournament ID. (required)
     * @return Ok
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully terminated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Terminating the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public Ok apiSwissTerminate(String id) throws ApiException {
        ApiResponse<Ok> localVarResp = apiSwissTerminateWithHttpInfo(id);
        return localVarResp.getData();
    }

    /**
     * Terminate a Swiss tournament
     * Terminate a Swiss tournament 
     * @param id The Swiss tournament ID. (required)
     * @return ApiResponse&lt;Ok&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully terminated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Terminating the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Ok> apiSwissTerminateWithHttpInfo(String id) throws ApiException {
        okhttp3.Call localVarCall = apiSwissTerminateValidateBeforeCall(id, null);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Terminate a Swiss tournament (asynchronously)
     * Terminate a Swiss tournament 
     * @param id The Swiss tournament ID. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully terminated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Terminating the Swiss tournament failed. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissTerminateAsync(String id, final ApiCallback<Ok> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiSwissTerminateValidateBeforeCall(id, _callback);
        Type localVarReturnType = new TypeToken<Ok>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for apiSwissUpdate
     * @param id The tournament ID. (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully updated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Updating the swiss failed. </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> This user cannot update this Swiss. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissUpdateCall(String id, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/swiss/{id}/edit"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (name != null) {
            localVarFormParams.put("name", name);
        }

        if (clockLimit != null) {
            localVarFormParams.put("clock.limit", clockLimit);
        }

        if (clockIncrement != null) {
            localVarFormParams.put("clock.increment", clockIncrement);
        }

        if (nbRounds != null) {
            localVarFormParams.put("nbRounds", nbRounds);
        }

        if (startsAt != null) {
            localVarFormParams.put("startsAt", startsAt);
        }

        if (roundInterval != null) {
            localVarFormParams.put("roundInterval", roundInterval);
        }

        if (variant != null) {
            localVarFormParams.put("variant", variant);
        }

        if (description != null) {
            localVarFormParams.put("description", description);
        }

        if (rated != null) {
            localVarFormParams.put("rated", rated);
        }

        if (chatFor != null) {
            localVarFormParams.put("chatFor", chatFor);
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "OAuth2" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiSwissUpdateValidateBeforeCall(String id, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling apiSwissUpdate(Async)");
        }
        
        // verify the required parameter 'clockLimit' is set
        if (clockLimit == null) {
            throw new ApiException("Missing the required parameter 'clockLimit' when calling apiSwissUpdate(Async)");
        }
        
        // verify the required parameter 'clockIncrement' is set
        if (clockIncrement == null) {
            throw new ApiException("Missing the required parameter 'clockIncrement' when calling apiSwissUpdate(Async)");
        }
        
        // verify the required parameter 'nbRounds' is set
        if (nbRounds == null) {
            throw new ApiException("Missing the required parameter 'nbRounds' when calling apiSwissUpdate(Async)");
        }
        

        okhttp3.Call localVarCall = apiSwissUpdateCall(id, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor, _callback);
        return localVarCall;

    }

    /**
     * Update a Swiss tournament.
     * Update a Swiss tournament.  Be mindful not to make important changes to ongoing tournaments. 
     * @param id The tournament ID. (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully updated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Updating the swiss failed. </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> This user cannot update this Swiss. </td><td>  -  </td></tr>
     </table>
     */
    public Object apiSwissUpdate(String id, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor) throws ApiException {
        ApiResponse<Object> localVarResp = apiSwissUpdateWithHttpInfo(id, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor);
        return localVarResp.getData();
    }

    /**
     * Update a Swiss tournament.
     * Update a Swiss tournament.  Be mindful not to make important changes to ongoing tournaments. 
     * @param id The tournament ID. (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully updated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Updating the swiss failed. </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> This user cannot update this Swiss. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Object> apiSwissUpdateWithHttpInfo(String id, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor) throws ApiException {
        okhttp3.Call localVarCall = apiSwissUpdateValidateBeforeCall(id, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Update a Swiss tournament. (asynchronously)
     * Update a Swiss tournament.  Be mindful not to make important changes to ongoing tournaments. 
     * @param id The tournament ID. (required)
     * @param clockLimit Clock initial time in seconds (required)
     * @param clockIncrement Clock increment in seconds (required)
     * @param nbRounds Maximum number of rounds to play (required)
     * @param name The tournament name. Leave empty to get a random Grandmaster name (optional)
     * @param startsAt Timestamp in milliseconds to start the tournament at a given date and time. By default, it starts 10 minutes after creation. (optional)
     * @param roundInterval How long to wait between each round, in seconds.  Set to 99999999 to manually schedule each round from the tournament UI.  (optional)
     * @param variant  (optional, default to VariantKey.STANDARD)
     * @param description Anything you want to tell players about the tournament (optional)
     * @param rated Games are rated and impact players ratings (optional, default to true)
     * @param chatFor Who can read and write in the chat. - 0  &#x3D; No-one - 10 &#x3D; Only team leaders - 20 &#x3D; Only team members - 30 &#x3D; All Lichess players  (optional, default to new BigDecimal(&quot;20&quot;))
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Swiss tournament was successfully updated. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
        <tr><td> 400 </td><td> Updating the swiss failed. </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> This user cannot update this Swiss. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call apiSwissUpdateAsync(String id, BigDecimal clockLimit, Integer clockIncrement, Integer nbRounds, String name, Integer startsAt, Integer roundInterval, VariantKey variant, String description, Boolean rated, BigDecimal chatFor, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiSwissUpdateValidateBeforeCall(id, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for apiTeamSwiss
     * @param teamId  (required)
     * @param max How many tournaments to download. (optional, default to 100)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of Swiss tournaments of a team. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiTeamSwissCall(String teamId, Integer max, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/team/{teamId}/swiss"
            .replaceAll("\\{" + "teamId" + "\\}", localVarApiClient.escapeString(teamId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (max != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max", max));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call apiTeamSwissValidateBeforeCall(String teamId, Integer max, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'teamId' is set
        if (teamId == null) {
            throw new ApiException("Missing the required parameter 'teamId' when calling apiTeamSwiss(Async)");
        }
        

        okhttp3.Call localVarCall = apiTeamSwissCall(teamId, max, _callback);
        return localVarCall;

    }

    /**
     * Get team swiss tournaments
     * Get all swiss tournaments of a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     * @param teamId  (required)
     * @param max How many tournaments to download. (optional, default to 100)
     * @return List&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of Swiss tournaments of a team. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public List<Object> apiTeamSwiss(String teamId, Integer max) throws ApiException {
        ApiResponse<List<Object>> localVarResp = apiTeamSwissWithHttpInfo(teamId, max);
        return localVarResp.getData();
    }

    /**
     * Get team swiss tournaments
     * Get all swiss tournaments of a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     * @param teamId  (required)
     * @param max How many tournaments to download. (optional, default to 100)
     * @return ApiResponse&lt;List&lt;Object&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of Swiss tournaments of a team. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<List<Object>> apiTeamSwissWithHttpInfo(String teamId, Integer max) throws ApiException {
        okhttp3.Call localVarCall = apiTeamSwissValidateBeforeCall(teamId, max, null);
        Type localVarReturnType = new TypeToken<List<Object>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get team swiss tournaments (asynchronously)
     * Get all swiss tournaments of a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     * @param teamId  (required)
     * @param max How many tournaments to download. (optional, default to 100)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of Swiss tournaments of a team. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call apiTeamSwissAsync(String teamId, Integer max, final ApiCallback<List<Object>> _callback) throws ApiException {

        okhttp3.Call localVarCall = apiTeamSwissValidateBeforeCall(teamId, max, _callback);
        Type localVarReturnType = new TypeToken<List<Object>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for gamesBySwiss
     * @param id The tournament ID. (required)
     * @param moves Include the PGN moves. (optional, default to true)
     * @param pgnInJson Include the full PGN within the JSON response, in a &#x60;pgn&#x60; field. (optional, default to false)
     * @param tags Include the PGN tags. (optional, default to true)
     * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60;  (optional, default to false)
     * @param evals Include analysis evaluation comments in the PGN, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { [%eval -1.09] }&#x60;  (optional, default to false)
     * @param opening Include the opening name.  Example: &#x60;[Opening \&quot;King&#39;s Gambit Accepted, King&#39;s Knight Gambit\&quot;]&#x60;  (optional, default to false)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of games of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call gamesBySwissCall(String id, Boolean moves, Boolean pgnInJson, Boolean tags, Boolean clocks, Boolean evals, Boolean opening, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/swiss/{id}/games"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (moves != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("moves", moves));
        }

        if (pgnInJson != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("pgnInJson", pgnInJson));
        }

        if (tags != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("tags", tags));
        }

        if (clocks != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("clocks", clocks));
        }

        if (evals != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("evals", evals));
        }

        if (opening != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("opening", opening));
        }

        final String[] localVarAccepts = {
            "application/x-chess-pgn", "application/x-ndjson"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call gamesBySwissValidateBeforeCall(String id, Boolean moves, Boolean pgnInJson, Boolean tags, Boolean clocks, Boolean evals, Boolean opening, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling gamesBySwiss(Async)");
        }
        

        okhttp3.Call localVarCall = gamesBySwissCall(id, moves, pgnInJson, tags, clocks, evals, opening, _callback);
        return localVarCall;

    }

    /**
     * Export games of a Swiss tournament
     * Download games of a swiss tournament in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Games are sorted by reverse chronological order (last round first) 
     * @param id The tournament ID. (required)
     * @param moves Include the PGN moves. (optional, default to true)
     * @param pgnInJson Include the full PGN within the JSON response, in a &#x60;pgn&#x60; field. (optional, default to false)
     * @param tags Include the PGN tags. (optional, default to true)
     * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60;  (optional, default to false)
     * @param evals Include analysis evaluation comments in the PGN, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { [%eval -1.09] }&#x60;  (optional, default to false)
     * @param opening Include the opening name.  Example: &#x60;[Opening \&quot;King&#39;s Gambit Accepted, King&#39;s Knight Gambit\&quot;]&#x60;  (optional, default to false)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of games of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public Object gamesBySwiss(String id, Boolean moves, Boolean pgnInJson, Boolean tags, Boolean clocks, Boolean evals, Boolean opening) throws ApiException {
        ApiResponse<Object> localVarResp = gamesBySwissWithHttpInfo(id, moves, pgnInJson, tags, clocks, evals, opening);
        return localVarResp.getData();
    }

    /**
     * Export games of a Swiss tournament
     * Download games of a swiss tournament in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Games are sorted by reverse chronological order (last round first) 
     * @param id The tournament ID. (required)
     * @param moves Include the PGN moves. (optional, default to true)
     * @param pgnInJson Include the full PGN within the JSON response, in a &#x60;pgn&#x60; field. (optional, default to false)
     * @param tags Include the PGN tags. (optional, default to true)
     * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60;  (optional, default to false)
     * @param evals Include analysis evaluation comments in the PGN, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { [%eval -1.09] }&#x60;  (optional, default to false)
     * @param opening Include the opening name.  Example: &#x60;[Opening \&quot;King&#39;s Gambit Accepted, King&#39;s Knight Gambit\&quot;]&#x60;  (optional, default to false)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of games of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Object> gamesBySwissWithHttpInfo(String id, Boolean moves, Boolean pgnInJson, Boolean tags, Boolean clocks, Boolean evals, Boolean opening) throws ApiException {
        okhttp3.Call localVarCall = gamesBySwissValidateBeforeCall(id, moves, pgnInJson, tags, clocks, evals, opening, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Export games of a Swiss tournament (asynchronously)
     * Download games of a swiss tournament in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Games are sorted by reverse chronological order (last round first) 
     * @param id The tournament ID. (required)
     * @param moves Include the PGN moves. (optional, default to true)
     * @param pgnInJson Include the full PGN within the JSON response, in a &#x60;pgn&#x60; field. (optional, default to false)
     * @param tags Include the PGN tags. (optional, default to true)
     * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60;  (optional, default to false)
     * @param evals Include analysis evaluation comments in the PGN, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { [%eval -1.09] }&#x60;  (optional, default to false)
     * @param opening Include the opening name.  Example: &#x60;[Opening \&quot;King&#39;s Gambit Accepted, King&#39;s Knight Gambit\&quot;]&#x60;  (optional, default to false)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The list of games of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call gamesBySwissAsync(String id, Boolean moves, Boolean pgnInJson, Boolean tags, Boolean clocks, Boolean evals, Boolean opening, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = gamesBySwissValidateBeforeCall(id, moves, pgnInJson, tags, clocks, evals, opening, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for resultsBySwiss
     * @param id The tournament ID. (required)
     * @param nb Max number of players to fetch (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The results of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call resultsBySwissCall(String id, Integer nb, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/swiss/{id}/results"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (nb != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("nb", nb));
        }

        final String[] localVarAccepts = {
            "application/x-ndjson"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call resultsBySwissValidateBeforeCall(String id, Integer nb, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling resultsBySwiss(Async)");
        }
        

        okhttp3.Call localVarCall = resultsBySwissCall(id, nb, _callback);
        return localVarCall;

    }

    /**
     * Get results of a swiss tournament
     * Players of a swiss tournament, with their score and performance, sorted by rank (best first).  Players are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  If called on an ongoing tournament, results can be inconsistent due to ranking changes while the players are being streamed. Use on finished tournaments for guaranteed consistency. 
     * @param id The tournament ID. (required)
     * @param nb Max number of players to fetch (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The results of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public Object resultsBySwiss(String id, Integer nb) throws ApiException {
        ApiResponse<Object> localVarResp = resultsBySwissWithHttpInfo(id, nb);
        return localVarResp.getData();
    }

    /**
     * Get results of a swiss tournament
     * Players of a swiss tournament, with their score and performance, sorted by rank (best first).  Players are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  If called on an ongoing tournament, results can be inconsistent due to ranking changes while the players are being streamed. Use on finished tournaments for guaranteed consistency. 
     * @param id The tournament ID. (required)
     * @param nb Max number of players to fetch (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The results of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<Object> resultsBySwissWithHttpInfo(String id, Integer nb) throws ApiException {
        okhttp3.Call localVarCall = resultsBySwissValidateBeforeCall(id, nb, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get results of a swiss tournament (asynchronously)
     * Players of a swiss tournament, with their score and performance, sorted by rank (best first).  Players are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  If called on an ongoing tournament, results can be inconsistent due to ranking changes while the players are being streamed. Use on finished tournaments for guaranteed consistency. 
     * @param id The tournament ID. (required)
     * @param nb Max number of players to fetch (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The results of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call resultsBySwissAsync(String id, Integer nb, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = resultsBySwissValidateBeforeCall(id, nb, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for swissTrf
     * @param id The tournament ID. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The TRF representation of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call swissTrfCall(String id, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/swiss/{id}.trf"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call swissTrfValidateBeforeCall(String id, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling swissTrf(Async)");
        }
        

        okhttp3.Call localVarCall = swissTrfCall(id, _callback);
        return localVarCall;

    }

    /**
     * Export TRF of a Swiss tournament
     * Download a tournament in the Tournament Report File format, the FIDE standard.  Documentation: &lt;https://www.fide.com/FIDE/handbook/C04Annex2_TRF16.pdf&gt;  Example: &lt;https://lichess.org/swiss/j8rtJ5GL.trf&gt; 
     * @param id The tournament ID. (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The TRF representation of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public String swissTrf(String id) throws ApiException {
        ApiResponse<String> localVarResp = swissTrfWithHttpInfo(id);
        return localVarResp.getData();
    }

    /**
     * Export TRF of a Swiss tournament
     * Download a tournament in the Tournament Report File format, the FIDE standard.  Documentation: &lt;https://www.fide.com/FIDE/handbook/C04Annex2_TRF16.pdf&gt;  Example: &lt;https://lichess.org/swiss/j8rtJ5GL.trf&gt; 
     * @param id The tournament ID. (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The TRF representation of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public ApiResponse<String> swissTrfWithHttpInfo(String id) throws ApiException {
        okhttp3.Call localVarCall = swissTrfValidateBeforeCall(id, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Export TRF of a Swiss tournament (asynchronously)
     * Download a tournament in the Tournament Report File format, the FIDE standard.  Documentation: &lt;https://www.fide.com/FIDE/handbook/C04Annex2_TRF16.pdf&gt;  Example: &lt;https://lichess.org/swiss/j8rtJ5GL.trf&gt; 
     * @param id The tournament ID. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The TRF representation of a Swiss tournament. </td><td>  * Access-Control-Allow-Origin -  <br>  </td></tr>
     </table>
     */
    public okhttp3.Call swissTrfAsync(String id, final ApiCallback<String> _callback) throws ApiException {

        okhttp3.Call localVarCall = swissTrfValidateBeforeCall(id, _callback);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
