/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ArenaTournaments
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class ArenaTournaments {
  public static final String SERIALIZED_NAME_CREATED = "created";
  @SerializedName(SERIALIZED_NAME_CREATED)
  private List<Object> created = null;

  public static final String SERIALIZED_NAME_STARTED = "started";
  @SerializedName(SERIALIZED_NAME_STARTED)
  private List<Object> started = null;

  public static final String SERIALIZED_NAME_FINISHED = "finished";
  @SerializedName(SERIALIZED_NAME_FINISHED)
  private List<Object> finished = null;


  public ArenaTournaments created(List<Object> created) {
    
    this.created = created;
    return this;
  }

  public ArenaTournaments addCreatedItem(Object createdItem) {
    if (this.created == null) {
      this.created = new ArrayList<Object>();
    }
    this.created.add(createdItem);
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<Object> getCreated() {
    return created;
  }


  public void setCreated(List<Object> created) {
    this.created = created;
  }


  public ArenaTournaments started(List<Object> started) {
    
    this.started = started;
    return this;
  }

  public ArenaTournaments addStartedItem(Object startedItem) {
    if (this.started == null) {
      this.started = new ArrayList<Object>();
    }
    this.started.add(startedItem);
    return this;
  }

   /**
   * Get started
   * @return started
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<Object> getStarted() {
    return started;
  }


  public void setStarted(List<Object> started) {
    this.started = started;
  }


  public ArenaTournaments finished(List<Object> finished) {
    
    this.finished = finished;
    return this;
  }

  public ArenaTournaments addFinishedItem(Object finishedItem) {
    if (this.finished == null) {
      this.finished = new ArrayList<Object>();
    }
    this.finished.add(finishedItem);
    return this;
  }

   /**
   * Get finished
   * @return finished
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<Object> getFinished() {
    return finished;
  }


  public void setFinished(List<Object> finished) {
    this.finished = finished;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ArenaTournaments arenaTournaments = (ArenaTournaments) o;
    return Objects.equals(this.created, arenaTournaments.created) &&
        Objects.equals(this.started, arenaTournaments.started) &&
        Objects.equals(this.finished, arenaTournaments.finished);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, started, finished);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ArenaTournaments {\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    started: ").append(toIndentedString(started)).append("\n");
    sb.append("    finished: ").append(toIndentedString(finished)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

