/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.ChallengeJsonPerf;
import org.openapitools.client.model.ChallengeUser;
import org.openapitools.client.model.Speed;
import org.openapitools.client.model.TimeControl;
import org.openapitools.client.model.Variant;

/**
 * ChallengeJson
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class ChallengeJson {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_URL = "url";
  @SerializedName(SERIALIZED_NAME_URL)
  private String url;

  /**
   * Gets or Sets status
   */
  @JsonAdapter(StatusEnum.Adapter.class)
  public enum StatusEnum {
    CREATED("created"),
    
    OFFLINE("offline"),
    
    CANCELED("canceled"),
    
    DECLINED("declined"),
    
    ACCEPTED("accepted");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static StatusEnum fromValue(String value) {
      for (StatusEnum b : StatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<StatusEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StatusEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public StatusEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return StatusEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private StatusEnum status;

  public static final String SERIALIZED_NAME_CHALLENGER = "challenger";
  @SerializedName(SERIALIZED_NAME_CHALLENGER)
  private ChallengeUser challenger;

  public static final String SERIALIZED_NAME_DEST_USER = "destUser";
  @SerializedName(SERIALIZED_NAME_DEST_USER)
  private ChallengeUser destUser;

  public static final String SERIALIZED_NAME_VARIANT = "variant";
  @SerializedName(SERIALIZED_NAME_VARIANT)
  private Variant variant;

  public static final String SERIALIZED_NAME_RATED = "rated";
  @SerializedName(SERIALIZED_NAME_RATED)
  private Boolean rated;

  public static final String SERIALIZED_NAME_SPEED = "speed";
  @SerializedName(SERIALIZED_NAME_SPEED)
  private Speed speed;

  public static final String SERIALIZED_NAME_TIME_CONTROL = "timeControl";
  @SerializedName(SERIALIZED_NAME_TIME_CONTROL)
  private TimeControl timeControl;

  /**
   * Gets or Sets color
   */
  @JsonAdapter(ColorEnum.Adapter.class)
  public enum ColorEnum {
    WHITE("white"),
    
    BLACK("black"),
    
    RANDOM("random");

    private String value;

    ColorEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ColorEnum fromValue(String value) {
      for (ColorEnum b : ColorEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<ColorEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ColorEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ColorEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return ColorEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_COLOR = "color";
  @SerializedName(SERIALIZED_NAME_COLOR)
  private ColorEnum color;

  public static final String SERIALIZED_NAME_PERF = "perf";
  @SerializedName(SERIALIZED_NAME_PERF)
  private ChallengeJsonPerf perf;

  /**
   * Gets or Sets direction
   */
  @JsonAdapter(DirectionEnum.Adapter.class)
  public enum DirectionEnum {
    IN("in"),
    
    OUT("out");

    private String value;

    DirectionEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static DirectionEnum fromValue(String value) {
      for (DirectionEnum b : DirectionEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<DirectionEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final DirectionEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public DirectionEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return DirectionEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_DIRECTION = "direction";
  @SerializedName(SERIALIZED_NAME_DIRECTION)
  private DirectionEnum direction;

  public static final String SERIALIZED_NAME_INITIAL_FEN = "initialFen";
  @SerializedName(SERIALIZED_NAME_INITIAL_FEN)
  private String initialFen;

  public static final String SERIALIZED_NAME_DECLINE_REASON = "declineReason";
  @SerializedName(SERIALIZED_NAME_DECLINE_REASON)
  private String declineReason;


  public ChallengeJson id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public ChallengeJson url(String url) {
    
    this.url = url;
    return this;
  }

   /**
   * Get url
   * @return url
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public String getUrl() {
    return url;
  }


  public void setUrl(String url) {
    this.url = url;
  }


  public ChallengeJson status(StatusEnum status) {
    
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public StatusEnum getStatus() {
    return status;
  }


  public void setStatus(StatusEnum status) {
    this.status = status;
  }


  public ChallengeJson challenger(ChallengeUser challenger) {
    
    this.challenger = challenger;
    return this;
  }

   /**
   * Get challenger
   * @return challenger
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public ChallengeUser getChallenger() {
    return challenger;
  }


  public void setChallenger(ChallengeUser challenger) {
    this.challenger = challenger;
  }


  public ChallengeJson destUser(ChallengeUser destUser) {
    
    this.destUser = destUser;
    return this;
  }

   /**
   * Get destUser
   * @return destUser
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public ChallengeUser getDestUser() {
    return destUser;
  }


  public void setDestUser(ChallengeUser destUser) {
    this.destUser = destUser;
  }


  public ChallengeJson variant(Variant variant) {
    
    this.variant = variant;
    return this;
  }

   /**
   * Get variant
   * @return variant
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Variant getVariant() {
    return variant;
  }


  public void setVariant(Variant variant) {
    this.variant = variant;
  }


  public ChallengeJson rated(Boolean rated) {
    
    this.rated = rated;
    return this;
  }

   /**
   * Get rated
   * @return rated
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Boolean getRated() {
    return rated;
  }


  public void setRated(Boolean rated) {
    this.rated = rated;
  }


  public ChallengeJson speed(Speed speed) {
    
    this.speed = speed;
    return this;
  }

   /**
   * Get speed
   * @return speed
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Speed getSpeed() {
    return speed;
  }


  public void setSpeed(Speed speed) {
    this.speed = speed;
  }


  public ChallengeJson timeControl(TimeControl timeControl) {
    
    this.timeControl = timeControl;
    return this;
  }

   /**
   * Get timeControl
   * @return timeControl
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public TimeControl getTimeControl() {
    return timeControl;
  }


  public void setTimeControl(TimeControl timeControl) {
    this.timeControl = timeControl;
  }


  public ChallengeJson color(ColorEnum color) {
    
    this.color = color;
    return this;
  }

   /**
   * Get color
   * @return color
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public ColorEnum getColor() {
    return color;
  }


  public void setColor(ColorEnum color) {
    this.color = color;
  }


  public ChallengeJson perf(ChallengeJsonPerf perf) {
    
    this.perf = perf;
    return this;
  }

   /**
   * Get perf
   * @return perf
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public ChallengeJsonPerf getPerf() {
    return perf;
  }


  public void setPerf(ChallengeJsonPerf perf) {
    this.perf = perf;
  }


  public ChallengeJson direction(DirectionEnum direction) {
    
    this.direction = direction;
    return this;
  }

   /**
   * Get direction
   * @return direction
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public DirectionEnum getDirection() {
    return direction;
  }


  public void setDirection(DirectionEnum direction) {
    this.direction = direction;
  }


  public ChallengeJson initialFen(String initialFen) {
    
    this.initialFen = initialFen;
    return this;
  }

   /**
   * Get initialFen
   * @return initialFen
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getInitialFen() {
    return initialFen;
  }


  public void setInitialFen(String initialFen) {
    this.initialFen = initialFen;
  }


  public ChallengeJson declineReason(String declineReason) {
    
    this.declineReason = declineReason;
    return this;
  }

   /**
   * Get declineReason
   * @return declineReason
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getDeclineReason() {
    return declineReason;
  }


  public void setDeclineReason(String declineReason) {
    this.declineReason = declineReason;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ChallengeJson challengeJson = (ChallengeJson) o;
    return Objects.equals(this.id, challengeJson.id) &&
        Objects.equals(this.url, challengeJson.url) &&
        Objects.equals(this.status, challengeJson.status) &&
        Objects.equals(this.challenger, challengeJson.challenger) &&
        Objects.equals(this.destUser, challengeJson.destUser) &&
        Objects.equals(this.variant, challengeJson.variant) &&
        Objects.equals(this.rated, challengeJson.rated) &&
        Objects.equals(this.speed, challengeJson.speed) &&
        Objects.equals(this.timeControl, challengeJson.timeControl) &&
        Objects.equals(this.color, challengeJson.color) &&
        Objects.equals(this.perf, challengeJson.perf) &&
        Objects.equals(this.direction, challengeJson.direction) &&
        Objects.equals(this.initialFen, challengeJson.initialFen) &&
        Objects.equals(this.declineReason, challengeJson.declineReason);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, url, status, challenger, destUser, variant, rated, speed, timeControl, color, perf, direction, initialFen, declineReason);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ChallengeJson {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    challenger: ").append(toIndentedString(challenger)).append("\n");
    sb.append("    destUser: ").append(toIndentedString(destUser)).append("\n");
    sb.append("    variant: ").append(toIndentedString(variant)).append("\n");
    sb.append("    rated: ").append(toIndentedString(rated)).append("\n");
    sb.append("    speed: ").append(toIndentedString(speed)).append("\n");
    sb.append("    timeControl: ").append(toIndentedString(timeControl)).append("\n");
    sb.append("    color: ").append(toIndentedString(color)).append("\n");
    sb.append("    perf: ").append(toIndentedString(perf)).append("\n");
    sb.append("    direction: ").append(toIndentedString(direction)).append("\n");
    sb.append("    initialFen: ").append(toIndentedString(initialFen)).append("\n");
    sb.append("    declineReason: ").append(toIndentedString(declineReason)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

