/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Count
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class Count {
  public static final String SERIALIZED_NAME_ALL = "all";
  @SerializedName(SERIALIZED_NAME_ALL)
  private Integer all;

  public static final String SERIALIZED_NAME_RATED = "rated";
  @SerializedName(SERIALIZED_NAME_RATED)
  private Integer rated;

  public static final String SERIALIZED_NAME_AI = "ai";
  @SerializedName(SERIALIZED_NAME_AI)
  private Integer ai;

  public static final String SERIALIZED_NAME_DRAW = "draw";
  @SerializedName(SERIALIZED_NAME_DRAW)
  private Integer draw;

  public static final String SERIALIZED_NAME_DRAW_H = "drawH";
  @SerializedName(SERIALIZED_NAME_DRAW_H)
  private Integer drawH;

  public static final String SERIALIZED_NAME_LOSS = "loss";
  @SerializedName(SERIALIZED_NAME_LOSS)
  private Integer loss;

  public static final String SERIALIZED_NAME_LOSS_H = "lossH";
  @SerializedName(SERIALIZED_NAME_LOSS_H)
  private Integer lossH;

  public static final String SERIALIZED_NAME_WIN = "win";
  @SerializedName(SERIALIZED_NAME_WIN)
  private Integer win;

  public static final String SERIALIZED_NAME_WIN_H = "winH";
  @SerializedName(SERIALIZED_NAME_WIN_H)
  private Integer winH;

  public static final String SERIALIZED_NAME_BOOKMARK = "bookmark";
  @SerializedName(SERIALIZED_NAME_BOOKMARK)
  private Integer bookmark;

  public static final String SERIALIZED_NAME_PLAYING = "playing";
  @SerializedName(SERIALIZED_NAME_PLAYING)
  private Integer playing;

  public static final String SERIALIZED_NAME_IMPORT = "import";
  @SerializedName(SERIALIZED_NAME_IMPORT)
  private Integer _import;

  public static final String SERIALIZED_NAME_ME = "me";
  @SerializedName(SERIALIZED_NAME_ME)
  private Integer me;


  public Count all(Integer all) {
    
    this.all = all;
    return this;
  }

   /**
   * Get all
   * @return all
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "9265", value = "")

  public Integer getAll() {
    return all;
  }


  public void setAll(Integer all) {
    this.all = all;
  }


  public Count rated(Integer rated) {
    
    this.rated = rated;
    return this;
  }

   /**
   * Get rated
   * @return rated
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7157", value = "")

  public Integer getRated() {
    return rated;
  }


  public void setRated(Integer rated) {
    this.rated = rated;
  }


  public Count ai(Integer ai) {
    
    this.ai = ai;
    return this;
  }

   /**
   * Get ai
   * @return ai
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "531", value = "")

  public Integer getAi() {
    return ai;
  }


  public void setAi(Integer ai) {
    this.ai = ai;
  }


  public Count draw(Integer draw) {
    
    this.draw = draw;
    return this;
  }

   /**
   * Get draw
   * @return draw
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "340", value = "")

  public Integer getDraw() {
    return draw;
  }


  public void setDraw(Integer draw) {
    this.draw = draw;
  }


  public Count drawH(Integer drawH) {
    
    this.drawH = drawH;
    return this;
  }

   /**
   * Get drawH
   * @return drawH
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "331", value = "")

  public Integer getDrawH() {
    return drawH;
  }


  public void setDrawH(Integer drawH) {
    this.drawH = drawH;
  }


  public Count loss(Integer loss) {
    
    this.loss = loss;
    return this;
  }

   /**
   * Get loss
   * @return loss
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4480", value = "")

  public Integer getLoss() {
    return loss;
  }


  public void setLoss(Integer loss) {
    this.loss = loss;
  }


  public Count lossH(Integer lossH) {
    
    this.lossH = lossH;
    return this;
  }

   /**
   * Get lossH
   * @return lossH
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4207", value = "")

  public Integer getLossH() {
    return lossH;
  }


  public void setLossH(Integer lossH) {
    this.lossH = lossH;
  }


  public Count win(Integer win) {
    
    this.win = win;
    return this;
  }

   /**
   * Get win
   * @return win
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4440", value = "")

  public Integer getWin() {
    return win;
  }


  public void setWin(Integer win) {
    this.win = win;
  }


  public Count winH(Integer winH) {
    
    this.winH = winH;
    return this;
  }

   /**
   * Get winH
   * @return winH
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4378", value = "")

  public Integer getWinH() {
    return winH;
  }


  public void setWinH(Integer winH) {
    this.winH = winH;
  }


  public Count bookmark(Integer bookmark) {
    
    this.bookmark = bookmark;
    return this;
  }

   /**
   * Get bookmark
   * @return bookmark
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "71", value = "")

  public Integer getBookmark() {
    return bookmark;
  }


  public void setBookmark(Integer bookmark) {
    this.bookmark = bookmark;
  }


  public Count playing(Integer playing) {
    
    this.playing = playing;
    return this;
  }

   /**
   * Get playing
   * @return playing
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "6", value = "")

  public Integer getPlaying() {
    return playing;
  }


  public void setPlaying(Integer playing) {
    this.playing = playing;
  }


  public Count _import(Integer _import) {
    
    this._import = _import;
    return this;
  }

   /**
   * Get _import
   * @return _import
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "66", value = "")

  public Integer getImport() {
    return _import;
  }


  public void setImport(Integer _import) {
    this._import = _import;
  }


  public Count me(Integer me) {
    
    this.me = me;
    return this;
  }

   /**
   * Get me
   * @return me
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")

  public Integer getMe() {
    return me;
  }


  public void setMe(Integer me) {
    this.me = me;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Count count = (Count) o;
    return Objects.equals(this.all, count.all) &&
        Objects.equals(this.rated, count.rated) &&
        Objects.equals(this.ai, count.ai) &&
        Objects.equals(this.draw, count.draw) &&
        Objects.equals(this.drawH, count.drawH) &&
        Objects.equals(this.loss, count.loss) &&
        Objects.equals(this.lossH, count.lossH) &&
        Objects.equals(this.win, count.win) &&
        Objects.equals(this.winH, count.winH) &&
        Objects.equals(this.bookmark, count.bookmark) &&
        Objects.equals(this.playing, count.playing) &&
        Objects.equals(this._import, count._import) &&
        Objects.equals(this.me, count.me);
  }

  @Override
  public int hashCode() {
    return Objects.hash(all, rated, ai, draw, drawH, loss, lossH, win, winH, bookmark, playing, _import, me);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Count {\n");
    sb.append("    all: ").append(toIndentedString(all)).append("\n");
    sb.append("    rated: ").append(toIndentedString(rated)).append("\n");
    sb.append("    ai: ").append(toIndentedString(ai)).append("\n");
    sb.append("    draw: ").append(toIndentedString(draw)).append("\n");
    sb.append("    drawH: ").append(toIndentedString(drawH)).append("\n");
    sb.append("    loss: ").append(toIndentedString(loss)).append("\n");
    sb.append("    lossH: ").append(toIndentedString(lossH)).append("\n");
    sb.append("    win: ").append(toIndentedString(win)).append("\n");
    sb.append("    winH: ").append(toIndentedString(winH)).append("\n");
    sb.append("    bookmark: ").append(toIndentedString(bookmark)).append("\n");
    sb.append("    playing: ").append(toIndentedString(playing)).append("\n");
    sb.append("    _import: ").append(toIndentedString(_import)).append("\n");
    sb.append("    me: ").append(toIndentedString(me)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

