/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import org.openapitools.client.model.Clock;
import org.openapitools.client.model.GameEventPlayer;
import org.openapitools.client.model.GameFullEventPerf;
import org.openapitools.client.model.GameStateEvent;
import org.openapitools.client.model.Speed;
import org.openapitools.client.model.Variant;

/**
 * GameFullEvent
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class GameFullEvent {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_VARIANT = "variant";
  @SerializedName(SERIALIZED_NAME_VARIANT)
  private Variant variant;

  public static final String SERIALIZED_NAME_CLOCK = "clock";
  @SerializedName(SERIALIZED_NAME_CLOCK)
  private Clock clock;

  public static final String SERIALIZED_NAME_SPEED = "speed";
  @SerializedName(SERIALIZED_NAME_SPEED)
  private Speed speed;

  public static final String SERIALIZED_NAME_PERF = "perf";
  @SerializedName(SERIALIZED_NAME_PERF)
  private GameFullEventPerf perf;

  public static final String SERIALIZED_NAME_RATED = "rated";
  @SerializedName(SERIALIZED_NAME_RATED)
  private Boolean rated;

  public static final String SERIALIZED_NAME_CREATED_AT = "createdAt";
  @SerializedName(SERIALIZED_NAME_CREATED_AT)
  private BigDecimal createdAt;

  public static final String SERIALIZED_NAME_WHITE = "white";
  @SerializedName(SERIALIZED_NAME_WHITE)
  private GameEventPlayer white;

  public static final String SERIALIZED_NAME_BLACK = "black";
  @SerializedName(SERIALIZED_NAME_BLACK)
  private GameEventPlayer black;

  /**
   * Gets or Sets initialFen
   */
  @JsonAdapter(InitialFenEnum.Adapter.class)
  public enum InitialFenEnum {
    STARTPOS("startpos");

    private String value;

    InitialFenEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static InitialFenEnum fromValue(String value) {
      for (InitialFenEnum b : InitialFenEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<InitialFenEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final InitialFenEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public InitialFenEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return InitialFenEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_INITIAL_FEN = "initialFen";
  @SerializedName(SERIALIZED_NAME_INITIAL_FEN)
  private InitialFenEnum initialFen;

  public static final String SERIALIZED_NAME_STATE = "state";
  @SerializedName(SERIALIZED_NAME_STATE)
  private GameStateEvent state;

  public static final String SERIALIZED_NAME_TOURNAMENT_ID = "tournamentId";
  @SerializedName(SERIALIZED_NAME_TOURNAMENT_ID)
  private String tournamentId;


  public GameFullEvent id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public GameFullEvent variant(Variant variant) {
    
    this.variant = variant;
    return this;
  }

   /**
   * Get variant
   * @return variant
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Variant getVariant() {
    return variant;
  }


  public void setVariant(Variant variant) {
    this.variant = variant;
  }


  public GameFullEvent clock(Clock clock) {
    
    this.clock = clock;
    return this;
  }

   /**
   * Get clock
   * @return clock
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Clock getClock() {
    return clock;
  }


  public void setClock(Clock clock) {
    this.clock = clock;
  }


  public GameFullEvent speed(Speed speed) {
    
    this.speed = speed;
    return this;
  }

   /**
   * Get speed
   * @return speed
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Speed getSpeed() {
    return speed;
  }


  public void setSpeed(Speed speed) {
    this.speed = speed;
  }


  public GameFullEvent perf(GameFullEventPerf perf) {
    
    this.perf = perf;
    return this;
  }

   /**
   * Get perf
   * @return perf
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameFullEventPerf getPerf() {
    return perf;
  }


  public void setPerf(GameFullEventPerf perf) {
    this.perf = perf;
  }


  public GameFullEvent rated(Boolean rated) {
    
    this.rated = rated;
    return this;
  }

   /**
   * Get rated
   * @return rated
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Boolean getRated() {
    return rated;
  }


  public void setRated(Boolean rated) {
    this.rated = rated;
  }


  public GameFullEvent createdAt(BigDecimal createdAt) {
    
    this.createdAt = createdAt;
    return this;
  }

   /**
   * Get createdAt
   * @return createdAt
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public BigDecimal getCreatedAt() {
    return createdAt;
  }


  public void setCreatedAt(BigDecimal createdAt) {
    this.createdAt = createdAt;
  }


  public GameFullEvent white(GameEventPlayer white) {
    
    this.white = white;
    return this;
  }

   /**
   * Get white
   * @return white
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameEventPlayer getWhite() {
    return white;
  }


  public void setWhite(GameEventPlayer white) {
    this.white = white;
  }


  public GameFullEvent black(GameEventPlayer black) {
    
    this.black = black;
    return this;
  }

   /**
   * Get black
   * @return black
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameEventPlayer getBlack() {
    return black;
  }


  public void setBlack(GameEventPlayer black) {
    this.black = black;
  }


  public GameFullEvent initialFen(InitialFenEnum initialFen) {
    
    this.initialFen = initialFen;
    return this;
  }

   /**
   * Get initialFen
   * @return initialFen
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public InitialFenEnum getInitialFen() {
    return initialFen;
  }


  public void setInitialFen(InitialFenEnum initialFen) {
    this.initialFen = initialFen;
  }


  public GameFullEvent state(GameStateEvent state) {
    
    this.state = state;
    return this;
  }

   /**
   * Get state
   * @return state
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameStateEvent getState() {
    return state;
  }


  public void setState(GameStateEvent state) {
    this.state = state;
  }


  public GameFullEvent tournamentId(String tournamentId) {
    
    this.tournamentId = tournamentId;
    return this;
  }

   /**
   * Get tournamentId
   * @return tournamentId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getTournamentId() {
    return tournamentId;
  }


  public void setTournamentId(String tournamentId) {
    this.tournamentId = tournamentId;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GameFullEvent gameFullEvent = (GameFullEvent) o;
    return Objects.equals(this.id, gameFullEvent.id) &&
        Objects.equals(this.variant, gameFullEvent.variant) &&
        Objects.equals(this.clock, gameFullEvent.clock) &&
        Objects.equals(this.speed, gameFullEvent.speed) &&
        Objects.equals(this.perf, gameFullEvent.perf) &&
        Objects.equals(this.rated, gameFullEvent.rated) &&
        Objects.equals(this.createdAt, gameFullEvent.createdAt) &&
        Objects.equals(this.white, gameFullEvent.white) &&
        Objects.equals(this.black, gameFullEvent.black) &&
        Objects.equals(this.initialFen, gameFullEvent.initialFen) &&
        Objects.equals(this.state, gameFullEvent.state) &&
        Objects.equals(this.tournamentId, gameFullEvent.tournamentId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, variant, clock, speed, perf, rated, createdAt, white, black, initialFen, state, tournamentId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GameFullEvent {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    variant: ").append(toIndentedString(variant)).append("\n");
    sb.append("    clock: ").append(toIndentedString(clock)).append("\n");
    sb.append("    speed: ").append(toIndentedString(speed)).append("\n");
    sb.append("    perf: ").append(toIndentedString(perf)).append("\n");
    sb.append("    rated: ").append(toIndentedString(rated)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    white: ").append(toIndentedString(white)).append("\n");
    sb.append("    black: ").append(toIndentedString(black)).append("\n");
    sb.append("    initialFen: ").append(toIndentedString(initialFen)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    tournamentId: ").append(toIndentedString(tournamentId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

