/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.GameJsonAnalysis;
import org.openapitools.client.model.GameJsonClock;
import org.openapitools.client.model.GameJsonOpening;
import org.openapitools.client.model.GameJsonPlayers;
import org.openapitools.client.model.GameStatus;
import org.openapitools.client.model.Speed;
import org.openapitools.client.model.VariantKey;

/**
 * GameJson
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class GameJson {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_RATED = "rated";
  @SerializedName(SERIALIZED_NAME_RATED)
  private Boolean rated;

  public static final String SERIALIZED_NAME_VARIANT = "variant";
  @SerializedName(SERIALIZED_NAME_VARIANT)
  private VariantKey variant = VariantKey.STANDARD;

  public static final String SERIALIZED_NAME_SPEED = "speed";
  @SerializedName(SERIALIZED_NAME_SPEED)
  private Speed speed;

  public static final String SERIALIZED_NAME_PERF = "perf";
  @SerializedName(SERIALIZED_NAME_PERF)
  private String perf;

  public static final String SERIALIZED_NAME_CREATED_AT = "createdAt";
  @SerializedName(SERIALIZED_NAME_CREATED_AT)
  private BigDecimal createdAt;

  public static final String SERIALIZED_NAME_LAST_MOVE_AT = "lastMoveAt";
  @SerializedName(SERIALIZED_NAME_LAST_MOVE_AT)
  private BigDecimal lastMoveAt;

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private GameStatus status;

  public static final String SERIALIZED_NAME_PLAYERS = "players";
  @SerializedName(SERIALIZED_NAME_PLAYERS)
  private GameJsonPlayers players;

  public static final String SERIALIZED_NAME_INITIAL_FEN = "initialFen";
  @SerializedName(SERIALIZED_NAME_INITIAL_FEN)
  private String initialFen;

  /**
   * Gets or Sets winner
   */
  @JsonAdapter(WinnerEnum.Adapter.class)
  public enum WinnerEnum {
    WHITE("white"),
    
    BLACK("black");

    private String value;

    WinnerEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static WinnerEnum fromValue(String value) {
      for (WinnerEnum b : WinnerEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<WinnerEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final WinnerEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public WinnerEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return WinnerEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_WINNER = "winner";
  @SerializedName(SERIALIZED_NAME_WINNER)
  private WinnerEnum winner;

  public static final String SERIALIZED_NAME_OPENING = "opening";
  @SerializedName(SERIALIZED_NAME_OPENING)
  private GameJsonOpening opening;

  public static final String SERIALIZED_NAME_MOVES = "moves";
  @SerializedName(SERIALIZED_NAME_MOVES)
  private String moves;

  public static final String SERIALIZED_NAME_PGN = "pgn";
  @SerializedName(SERIALIZED_NAME_PGN)
  private String pgn;

  public static final String SERIALIZED_NAME_DAYS_PER_TURN = "daysPerTurn";
  @SerializedName(SERIALIZED_NAME_DAYS_PER_TURN)
  private BigDecimal daysPerTurn;

  public static final String SERIALIZED_NAME_ANALYSIS = "analysis";
  @SerializedName(SERIALIZED_NAME_ANALYSIS)
  private List<GameJsonAnalysis> analysis = null;

  public static final String SERIALIZED_NAME_TOURNAMENT = "tournament";
  @SerializedName(SERIALIZED_NAME_TOURNAMENT)
  private String tournament;

  public static final String SERIALIZED_NAME_SWISS = "swiss";
  @SerializedName(SERIALIZED_NAME_SWISS)
  private String swiss;

  public static final String SERIALIZED_NAME_CLOCK = "clock";
  @SerializedName(SERIALIZED_NAME_CLOCK)
  private GameJsonClock clock;


  public GameJson id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public GameJson rated(Boolean rated) {
    
    this.rated = rated;
    return this;
  }

   /**
   * Get rated
   * @return rated
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Boolean getRated() {
    return rated;
  }


  public void setRated(Boolean rated) {
    this.rated = rated;
  }


  public GameJson variant(VariantKey variant) {
    
    this.variant = variant;
    return this;
  }

   /**
   * Get variant
   * @return variant
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public VariantKey getVariant() {
    return variant;
  }


  public void setVariant(VariantKey variant) {
    this.variant = variant;
  }


  public GameJson speed(Speed speed) {
    
    this.speed = speed;
    return this;
  }

   /**
   * Get speed
   * @return speed
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public Speed getSpeed() {
    return speed;
  }


  public void setSpeed(Speed speed) {
    this.speed = speed;
  }


  public GameJson perf(String perf) {
    
    this.perf = perf;
    return this;
  }

   /**
   * Get perf
   * @return perf
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public String getPerf() {
    return perf;
  }


  public void setPerf(String perf) {
    this.perf = perf;
  }


  public GameJson createdAt(BigDecimal createdAt) {
    
    this.createdAt = createdAt;
    return this;
  }

   /**
   * Get createdAt
   * @return createdAt
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public BigDecimal getCreatedAt() {
    return createdAt;
  }


  public void setCreatedAt(BigDecimal createdAt) {
    this.createdAt = createdAt;
  }


  public GameJson lastMoveAt(BigDecimal lastMoveAt) {
    
    this.lastMoveAt = lastMoveAt;
    return this;
  }

   /**
   * Get lastMoveAt
   * @return lastMoveAt
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public BigDecimal getLastMoveAt() {
    return lastMoveAt;
  }


  public void setLastMoveAt(BigDecimal lastMoveAt) {
    this.lastMoveAt = lastMoveAt;
  }


  public GameJson status(GameStatus status) {
    
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameStatus getStatus() {
    return status;
  }


  public void setStatus(GameStatus status) {
    this.status = status;
  }


  public GameJson players(GameJsonPlayers players) {
    
    this.players = players;
    return this;
  }

   /**
   * Get players
   * @return players
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameJsonPlayers getPlayers() {
    return players;
  }


  public void setPlayers(GameJsonPlayers players) {
    this.players = players;
  }


  public GameJson initialFen(String initialFen) {
    
    this.initialFen = initialFen;
    return this;
  }

   /**
   * Get initialFen
   * @return initialFen
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getInitialFen() {
    return initialFen;
  }


  public void setInitialFen(String initialFen) {
    this.initialFen = initialFen;
  }


  public GameJson winner(WinnerEnum winner) {
    
    this.winner = winner;
    return this;
  }

   /**
   * Get winner
   * @return winner
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public WinnerEnum getWinner() {
    return winner;
  }


  public void setWinner(WinnerEnum winner) {
    this.winner = winner;
  }


  public GameJson opening(GameJsonOpening opening) {
    
    this.opening = opening;
    return this;
  }

   /**
   * Get opening
   * @return opening
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public GameJsonOpening getOpening() {
    return opening;
  }


  public void setOpening(GameJsonOpening opening) {
    this.opening = opening;
  }


  public GameJson moves(String moves) {
    
    this.moves = moves;
    return this;
  }

   /**
   * Get moves
   * @return moves
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getMoves() {
    return moves;
  }


  public void setMoves(String moves) {
    this.moves = moves;
  }


  public GameJson pgn(String pgn) {
    
    this.pgn = pgn;
    return this;
  }

   /**
   * Get pgn
   * @return pgn
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getPgn() {
    return pgn;
  }


  public void setPgn(String pgn) {
    this.pgn = pgn;
  }


  public GameJson daysPerTurn(BigDecimal daysPerTurn) {
    
    this.daysPerTurn = daysPerTurn;
    return this;
  }

   /**
   * Get daysPerTurn
   * @return daysPerTurn
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public BigDecimal getDaysPerTurn() {
    return daysPerTurn;
  }


  public void setDaysPerTurn(BigDecimal daysPerTurn) {
    this.daysPerTurn = daysPerTurn;
  }


  public GameJson analysis(List<GameJsonAnalysis> analysis) {
    
    this.analysis = analysis;
    return this;
  }

  public GameJson addAnalysisItem(GameJsonAnalysis analysisItem) {
    if (this.analysis == null) {
      this.analysis = new ArrayList<GameJsonAnalysis>();
    }
    this.analysis.add(analysisItem);
    return this;
  }

   /**
   * Get analysis
   * @return analysis
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<GameJsonAnalysis> getAnalysis() {
    return analysis;
  }


  public void setAnalysis(List<GameJsonAnalysis> analysis) {
    this.analysis = analysis;
  }


  public GameJson tournament(String tournament) {
    
    this.tournament = tournament;
    return this;
  }

   /**
   * Get tournament
   * @return tournament
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getTournament() {
    return tournament;
  }


  public void setTournament(String tournament) {
    this.tournament = tournament;
  }


  public GameJson swiss(String swiss) {
    
    this.swiss = swiss;
    return this;
  }

   /**
   * Get swiss
   * @return swiss
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getSwiss() {
    return swiss;
  }


  public void setSwiss(String swiss) {
    this.swiss = swiss;
  }


  public GameJson clock(GameJsonClock clock) {
    
    this.clock = clock;
    return this;
  }

   /**
   * Get clock
   * @return clock
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public GameJsonClock getClock() {
    return clock;
  }


  public void setClock(GameJsonClock clock) {
    this.clock = clock;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GameJson gameJson = (GameJson) o;
    return Objects.equals(this.id, gameJson.id) &&
        Objects.equals(this.rated, gameJson.rated) &&
        Objects.equals(this.variant, gameJson.variant) &&
        Objects.equals(this.speed, gameJson.speed) &&
        Objects.equals(this.perf, gameJson.perf) &&
        Objects.equals(this.createdAt, gameJson.createdAt) &&
        Objects.equals(this.lastMoveAt, gameJson.lastMoveAt) &&
        Objects.equals(this.status, gameJson.status) &&
        Objects.equals(this.players, gameJson.players) &&
        Objects.equals(this.initialFen, gameJson.initialFen) &&
        Objects.equals(this.winner, gameJson.winner) &&
        Objects.equals(this.opening, gameJson.opening) &&
        Objects.equals(this.moves, gameJson.moves) &&
        Objects.equals(this.pgn, gameJson.pgn) &&
        Objects.equals(this.daysPerTurn, gameJson.daysPerTurn) &&
        Objects.equals(this.analysis, gameJson.analysis) &&
        Objects.equals(this.tournament, gameJson.tournament) &&
        Objects.equals(this.swiss, gameJson.swiss) &&
        Objects.equals(this.clock, gameJson.clock);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, rated, variant, speed, perf, createdAt, lastMoveAt, status, players, initialFen, winner, opening, moves, pgn, daysPerTurn, analysis, tournament, swiss, clock);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GameJson {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    rated: ").append(toIndentedString(rated)).append("\n");
    sb.append("    variant: ").append(toIndentedString(variant)).append("\n");
    sb.append("    speed: ").append(toIndentedString(speed)).append("\n");
    sb.append("    perf: ").append(toIndentedString(perf)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    lastMoveAt: ").append(toIndentedString(lastMoveAt)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    players: ").append(toIndentedString(players)).append("\n");
    sb.append("    initialFen: ").append(toIndentedString(initialFen)).append("\n");
    sb.append("    winner: ").append(toIndentedString(winner)).append("\n");
    sb.append("    opening: ").append(toIndentedString(opening)).append("\n");
    sb.append("    moves: ").append(toIndentedString(moves)).append("\n");
    sb.append("    pgn: ").append(toIndentedString(pgn)).append("\n");
    sb.append("    daysPerTurn: ").append(toIndentedString(daysPerTurn)).append("\n");
    sb.append("    analysis: ").append(toIndentedString(analysis)).append("\n");
    sb.append("    tournament: ").append(toIndentedString(tournament)).append("\n");
    sb.append("    swiss: ").append(toIndentedString(swiss)).append("\n");
    sb.append("    clock: ").append(toIndentedString(clock)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

