/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.GameStatus;

/**
 * GameStateEvent
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class GameStateEvent {
  public static final String SERIALIZED_NAME_MOVES = "moves";
  @SerializedName(SERIALIZED_NAME_MOVES)
  private String moves;

  public static final String SERIALIZED_NAME_WTIME = "wtime";
  @SerializedName(SERIALIZED_NAME_WTIME)
  private Integer wtime;

  public static final String SERIALIZED_NAME_BTIME = "btime";
  @SerializedName(SERIALIZED_NAME_BTIME)
  private Integer btime;

  public static final String SERIALIZED_NAME_WINC = "winc";
  @SerializedName(SERIALIZED_NAME_WINC)
  private Integer winc;

  public static final String SERIALIZED_NAME_BINC = "binc";
  @SerializedName(SERIALIZED_NAME_BINC)
  private Integer binc;

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private GameStatus status;

  public static final String SERIALIZED_NAME_WINNER = "winner";
  @SerializedName(SERIALIZED_NAME_WINNER)
  private String winner;

  public static final String SERIALIZED_NAME_WDRAW = "wdraw";
  @SerializedName(SERIALIZED_NAME_WDRAW)
  private Boolean wdraw;

  public static final String SERIALIZED_NAME_BDRAW = "bdraw";
  @SerializedName(SERIALIZED_NAME_BDRAW)
  private Boolean bdraw;

  public static final String SERIALIZED_NAME_WTAKEBACK = "wtakeback";
  @SerializedName(SERIALIZED_NAME_WTAKEBACK)
  private Boolean wtakeback;

  public static final String SERIALIZED_NAME_BTAKEBACK = "btakeback";
  @SerializedName(SERIALIZED_NAME_BTAKEBACK)
  private Boolean btakeback;


  public GameStateEvent moves(String moves) {
    
    this.moves = moves;
    return this;
  }

   /**
   * Current moves in UCI format
   * @return moves
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "Current moves in UCI format")

  public String getMoves() {
    return moves;
  }


  public void setMoves(String moves) {
    this.moves = moves;
  }


  public GameStateEvent wtime(Integer wtime) {
    
    this.wtime = wtime;
    return this;
  }

   /**
   * Integer of milliseconds White has left on the clock
   * @return wtime
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "Integer of milliseconds White has left on the clock")

  public Integer getWtime() {
    return wtime;
  }


  public void setWtime(Integer wtime) {
    this.wtime = wtime;
  }


  public GameStateEvent btime(Integer btime) {
    
    this.btime = btime;
    return this;
  }

   /**
   * Integer of milliseconds Black has left on the clock
   * @return btime
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "Integer of milliseconds Black has left on the clock")

  public Integer getBtime() {
    return btime;
  }


  public void setBtime(Integer btime) {
    this.btime = btime;
  }


  public GameStateEvent winc(Integer winc) {
    
    this.winc = winc;
    return this;
  }

   /**
   * Integer of White Fisher increment.
   * @return winc
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "Integer of White Fisher increment.")

  public Integer getWinc() {
    return winc;
  }


  public void setWinc(Integer winc) {
    this.winc = winc;
  }


  public GameStateEvent binc(Integer binc) {
    
    this.binc = binc;
    return this;
  }

   /**
   * Integer of Black Fisher increment.
   * @return binc
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "Integer of Black Fisher increment.")

  public Integer getBinc() {
    return binc;
  }


  public void setBinc(Integer binc) {
    this.binc = binc;
  }


  public GameStateEvent status(GameStatus status) {
    
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @javax.annotation.Nonnull
  @ApiModelProperty(required = true, value = "")

  public GameStatus getStatus() {
    return status;
  }


  public void setStatus(GameStatus status) {
    this.status = status;
  }


  public GameStateEvent winner(String winner) {
    
    this.winner = winner;
    return this;
  }

   /**
   * Color of the winner, if any
   * @return winner
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Color of the winner, if any")

  public String getWinner() {
    return winner;
  }


  public void setWinner(String winner) {
    this.winner = winner;
  }


  public GameStateEvent wdraw(Boolean wdraw) {
    
    this.wdraw = wdraw;
    return this;
  }

   /**
   * true if white is offering draw, else omitted
   * @return wdraw
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "true if white is offering draw, else omitted")

  public Boolean getWdraw() {
    return wdraw;
  }


  public void setWdraw(Boolean wdraw) {
    this.wdraw = wdraw;
  }


  public GameStateEvent bdraw(Boolean bdraw) {
    
    this.bdraw = bdraw;
    return this;
  }

   /**
   * true if black is offering draw, else omitted
   * @return bdraw
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "true if black is offering draw, else omitted")

  public Boolean getBdraw() {
    return bdraw;
  }


  public void setBdraw(Boolean bdraw) {
    this.bdraw = bdraw;
  }


  public GameStateEvent wtakeback(Boolean wtakeback) {
    
    this.wtakeback = wtakeback;
    return this;
  }

   /**
   * true if white is proposing takeback, else omitted
   * @return wtakeback
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "true if white is proposing takeback, else omitted")

  public Boolean getWtakeback() {
    return wtakeback;
  }


  public void setWtakeback(Boolean wtakeback) {
    this.wtakeback = wtakeback;
  }


  public GameStateEvent btakeback(Boolean btakeback) {
    
    this.btakeback = btakeback;
    return this;
  }

   /**
   * true if black is proposing takeback, else omitted
   * @return btakeback
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "true if black is proposing takeback, else omitted")

  public Boolean getBtakeback() {
    return btakeback;
  }


  public void setBtakeback(Boolean btakeback) {
    this.btakeback = btakeback;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GameStateEvent gameStateEvent = (GameStateEvent) o;
    return Objects.equals(this.moves, gameStateEvent.moves) &&
        Objects.equals(this.wtime, gameStateEvent.wtime) &&
        Objects.equals(this.btime, gameStateEvent.btime) &&
        Objects.equals(this.winc, gameStateEvent.winc) &&
        Objects.equals(this.binc, gameStateEvent.binc) &&
        Objects.equals(this.status, gameStateEvent.status) &&
        Objects.equals(this.winner, gameStateEvent.winner) &&
        Objects.equals(this.wdraw, gameStateEvent.wdraw) &&
        Objects.equals(this.bdraw, gameStateEvent.bdraw) &&
        Objects.equals(this.wtakeback, gameStateEvent.wtakeback) &&
        Objects.equals(this.btakeback, gameStateEvent.btakeback);
  }

  @Override
  public int hashCode() {
    return Objects.hash(moves, wtime, btime, winc, binc, status, winner, wdraw, bdraw, wtakeback, btakeback);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GameStateEvent {\n");
    sb.append("    moves: ").append(toIndentedString(moves)).append("\n");
    sb.append("    wtime: ").append(toIndentedString(wtime)).append("\n");
    sb.append("    btime: ").append(toIndentedString(btime)).append("\n");
    sb.append("    winc: ").append(toIndentedString(winc)).append("\n");
    sb.append("    binc: ").append(toIndentedString(binc)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    winner: ").append(toIndentedString(winner)).append("\n");
    sb.append("    wdraw: ").append(toIndentedString(wdraw)).append("\n");
    sb.append("    bdraw: ").append(toIndentedString(bdraw)).append("\n");
    sb.append("    wtakeback: ").append(toIndentedString(wtakeback)).append("\n");
    sb.append("    btakeback: ").append(toIndentedString(btakeback)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

