/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import org.openapitools.client.model.GameUserAnalysis;
import org.openapitools.client.model.LightUser;

/**
 * GameUser
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class GameUser {
  public static final String SERIALIZED_NAME_USER = "user";
  @SerializedName(SERIALIZED_NAME_USER)
  private LightUser user;

  public static final String SERIALIZED_NAME_RATING = "rating";
  @SerializedName(SERIALIZED_NAME_RATING)
  private BigDecimal rating;

  public static final String SERIALIZED_NAME_RATING_DIFF = "ratingDiff";
  @SerializedName(SERIALIZED_NAME_RATING_DIFF)
  private BigDecimal ratingDiff;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_PROVISIONAL = "provisional";
  @SerializedName(SERIALIZED_NAME_PROVISIONAL)
  private Boolean provisional;

  public static final String SERIALIZED_NAME_AI_LEVEL = "aiLevel";
  @SerializedName(SERIALIZED_NAME_AI_LEVEL)
  private BigDecimal aiLevel;

  public static final String SERIALIZED_NAME_ANALYSIS = "analysis";
  @SerializedName(SERIALIZED_NAME_ANALYSIS)
  private GameUserAnalysis analysis;

  public static final String SERIALIZED_NAME_TEAM = "team";
  @SerializedName(SERIALIZED_NAME_TEAM)
  private String team;


  public GameUser user(LightUser user) {
    
    this.user = user;
    return this;
  }

   /**
   * Get user
   * @return user
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public LightUser getUser() {
    return user;
  }


  public void setUser(LightUser user) {
    this.user = user;
  }


  public GameUser rating(BigDecimal rating) {
    
    this.rating = rating;
    return this;
  }

   /**
   * Get rating
   * @return rating
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public BigDecimal getRating() {
    return rating;
  }


  public void setRating(BigDecimal rating) {
    this.rating = rating;
  }


  public GameUser ratingDiff(BigDecimal ratingDiff) {
    
    this.ratingDiff = ratingDiff;
    return this;
  }

   /**
   * Get ratingDiff
   * @return ratingDiff
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public BigDecimal getRatingDiff() {
    return ratingDiff;
  }


  public void setRatingDiff(BigDecimal ratingDiff) {
    this.ratingDiff = ratingDiff;
  }


  public GameUser name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public GameUser provisional(Boolean provisional) {
    
    this.provisional = provisional;
    return this;
  }

   /**
   * Get provisional
   * @return provisional
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getProvisional() {
    return provisional;
  }


  public void setProvisional(Boolean provisional) {
    this.provisional = provisional;
  }


  public GameUser aiLevel(BigDecimal aiLevel) {
    
    this.aiLevel = aiLevel;
    return this;
  }

   /**
   * Get aiLevel
   * @return aiLevel
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public BigDecimal getAiLevel() {
    return aiLevel;
  }


  public void setAiLevel(BigDecimal aiLevel) {
    this.aiLevel = aiLevel;
  }


  public GameUser analysis(GameUserAnalysis analysis) {
    
    this.analysis = analysis;
    return this;
  }

   /**
   * Get analysis
   * @return analysis
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public GameUserAnalysis getAnalysis() {
    return analysis;
  }


  public void setAnalysis(GameUserAnalysis analysis) {
    this.analysis = analysis;
  }


  public GameUser team(String team) {
    
    this.team = team;
    return this;
  }

   /**
   * Get team
   * @return team
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getTeam() {
    return team;
  }


  public void setTeam(String team) {
    this.team = team;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GameUser gameUser = (GameUser) o;
    return Objects.equals(this.user, gameUser.user) &&
        Objects.equals(this.rating, gameUser.rating) &&
        Objects.equals(this.ratingDiff, gameUser.ratingDiff) &&
        Objects.equals(this.name, gameUser.name) &&
        Objects.equals(this.provisional, gameUser.provisional) &&
        Objects.equals(this.aiLevel, gameUser.aiLevel) &&
        Objects.equals(this.analysis, gameUser.analysis) &&
        Objects.equals(this.team, gameUser.team);
  }

  @Override
  public int hashCode() {
    return Objects.hash(user, rating, ratingDiff, name, provisional, aiLevel, analysis, team);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GameUser {\n");
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("    rating: ").append(toIndentedString(rating)).append("\n");
    sb.append("    ratingDiff: ").append(toIndentedString(ratingDiff)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    provisional: ").append(toIndentedString(provisional)).append("\n");
    sb.append("    aiLevel: ").append(toIndentedString(aiLevel)).append("\n");
    sb.append("    analysis: ").append(toIndentedString(analysis)).append("\n");
    sb.append("    team: ").append(toIndentedString(team)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

