/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * InlineResponse200
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class InlineResponse200 {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_TITLE = "title";
  @SerializedName(SERIALIZED_NAME_TITLE)
  private String title;

  public static final String SERIALIZED_NAME_ONLINE = "online";
  @SerializedName(SERIALIZED_NAME_ONLINE)
  private Boolean online;

  public static final String SERIALIZED_NAME_PLAYING = "playing";
  @SerializedName(SERIALIZED_NAME_PLAYING)
  private Boolean playing;

  public static final String SERIALIZED_NAME_STREAMING = "streaming";
  @SerializedName(SERIALIZED_NAME_STREAMING)
  private Boolean streaming;

  public static final String SERIALIZED_NAME_PATRON = "patron";
  @SerializedName(SERIALIZED_NAME_PATRON)
  private Boolean patron;


  public InlineResponse200 id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public InlineResponse200 name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public InlineResponse200 title(String title) {
    
    this.title = title;
    return this;
  }

   /**
   * Get title
   * @return title
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getTitle() {
    return title;
  }


  public void setTitle(String title) {
    this.title = title;
  }


  public InlineResponse200 online(Boolean online) {
    
    this.online = online;
    return this;
  }

   /**
   * Get online
   * @return online
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getOnline() {
    return online;
  }


  public void setOnline(Boolean online) {
    this.online = online;
  }


  public InlineResponse200 playing(Boolean playing) {
    
    this.playing = playing;
    return this;
  }

   /**
   * Get playing
   * @return playing
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getPlaying() {
    return playing;
  }


  public void setPlaying(Boolean playing) {
    this.playing = playing;
  }


  public InlineResponse200 streaming(Boolean streaming) {
    
    this.streaming = streaming;
    return this;
  }

   /**
   * Get streaming
   * @return streaming
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getStreaming() {
    return streaming;
  }


  public void setStreaming(Boolean streaming) {
    this.streaming = streaming;
  }


  public InlineResponse200 patron(Boolean patron) {
    
    this.patron = patron;
    return this;
  }

   /**
   * Get patron
   * @return patron
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getPatron() {
    return patron;
  }


  public void setPatron(Boolean patron) {
    this.patron = patron;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InlineResponse200 inlineResponse200 = (InlineResponse200) o;
    return Objects.equals(this.id, inlineResponse200.id) &&
        Objects.equals(this.name, inlineResponse200.name) &&
        Objects.equals(this.title, inlineResponse200.title) &&
        Objects.equals(this.online, inlineResponse200.online) &&
        Objects.equals(this.playing, inlineResponse200.playing) &&
        Objects.equals(this.streaming, inlineResponse200.streaming) &&
        Objects.equals(this.patron, inlineResponse200.patron);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, title, online, playing, streaming, patron);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InlineResponse200 {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    online: ").append(toIndentedString(online)).append("\n");
    sb.append("    playing: ").append(toIndentedString(playing)).append("\n");
    sb.append("    streaming: ").append(toIndentedString(streaming)).append("\n");
    sb.append("    patron: ").append(toIndentedString(patron)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

