/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Team;

/**
 * InlineResponse2001
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class InlineResponse2001 {
  public static final String SERIALIZED_NAME_CURRENT_PAGE = "currentPage";
  @SerializedName(SERIALIZED_NAME_CURRENT_PAGE)
  private BigDecimal currentPage;

  public static final String SERIALIZED_NAME_MAX_PER_PAGE = "maxPerPage";
  @SerializedName(SERIALIZED_NAME_MAX_PER_PAGE)
  private BigDecimal maxPerPage;

  public static final String SERIALIZED_NAME_CURRENT_PAGE_RESULTS = "currentPageResults";
  @SerializedName(SERIALIZED_NAME_CURRENT_PAGE_RESULTS)
  private List<Team> currentPageResults = null;

  public static final String SERIALIZED_NAME_NB_RESULTS = "nbResults";
  @SerializedName(SERIALIZED_NAME_NB_RESULTS)
  private BigDecimal nbResults;

  public static final String SERIALIZED_NAME_PREVIOUS_PAGE = "previousPage";
  @SerializedName(SERIALIZED_NAME_PREVIOUS_PAGE)
  private BigDecimal previousPage;

  public static final String SERIALIZED_NAME_NEXT_PAGE = "nextPage";
  @SerializedName(SERIALIZED_NAME_NEXT_PAGE)
  private BigDecimal nextPage;

  public static final String SERIALIZED_NAME_NB_PAGES = "nbPages";
  @SerializedName(SERIALIZED_NAME_NB_PAGES)
  private BigDecimal nbPages;


  public InlineResponse2001 currentPage(BigDecimal currentPage) {
    
    this.currentPage = currentPage;
    return this;
  }

   /**
   * Get currentPage
   * @return currentPage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4", value = "")

  public BigDecimal getCurrentPage() {
    return currentPage;
  }


  public void setCurrentPage(BigDecimal currentPage) {
    this.currentPage = currentPage;
  }


  public InlineResponse2001 maxPerPage(BigDecimal maxPerPage) {
    
    this.maxPerPage = maxPerPage;
    return this;
  }

   /**
   * Get maxPerPage
   * @return maxPerPage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "15", value = "")

  public BigDecimal getMaxPerPage() {
    return maxPerPage;
  }


  public void setMaxPerPage(BigDecimal maxPerPage) {
    this.maxPerPage = maxPerPage;
  }


  public InlineResponse2001 currentPageResults(List<Team> currentPageResults) {
    
    this.currentPageResults = currentPageResults;
    return this;
  }

  public InlineResponse2001 addCurrentPageResultsItem(Team currentPageResultsItem) {
    if (this.currentPageResults == null) {
      this.currentPageResults = new ArrayList<Team>();
    }
    this.currentPageResults.add(currentPageResultsItem);
    return this;
  }

   /**
   * Get currentPageResults
   * @return currentPageResults
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<Team> getCurrentPageResults() {
    return currentPageResults;
  }


  public void setCurrentPageResults(List<Team> currentPageResults) {
    this.currentPageResults = currentPageResults;
  }


  public InlineResponse2001 nbResults(BigDecimal nbResults) {
    
    this.nbResults = nbResults;
    return this;
  }

   /**
   * Get nbResults
   * @return nbResults
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "205194", value = "")

  public BigDecimal getNbResults() {
    return nbResults;
  }


  public void setNbResults(BigDecimal nbResults) {
    this.nbResults = nbResults;
  }


  public InlineResponse2001 previousPage(BigDecimal previousPage) {
    
    this.previousPage = previousPage;
    return this;
  }

   /**
   * Get previousPage
   * @return previousPage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "")

  public BigDecimal getPreviousPage() {
    return previousPage;
  }


  public void setPreviousPage(BigDecimal previousPage) {
    this.previousPage = previousPage;
  }


  public InlineResponse2001 nextPage(BigDecimal nextPage) {
    
    this.nextPage = nextPage;
    return this;
  }

   /**
   * Get nextPage
   * @return nextPage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "5", value = "")

  public BigDecimal getNextPage() {
    return nextPage;
  }


  public void setNextPage(BigDecimal nextPage) {
    this.nextPage = nextPage;
  }


  public InlineResponse2001 nbPages(BigDecimal nbPages) {
    
    this.nbPages = nbPages;
    return this;
  }

   /**
   * Get nbPages
   * @return nbPages
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "13680", value = "")

  public BigDecimal getNbPages() {
    return nbPages;
  }


  public void setNbPages(BigDecimal nbPages) {
    this.nbPages = nbPages;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InlineResponse2001 inlineResponse2001 = (InlineResponse2001) o;
    return Objects.equals(this.currentPage, inlineResponse2001.currentPage) &&
        Objects.equals(this.maxPerPage, inlineResponse2001.maxPerPage) &&
        Objects.equals(this.currentPageResults, inlineResponse2001.currentPageResults) &&
        Objects.equals(this.nbResults, inlineResponse2001.nbResults) &&
        Objects.equals(this.previousPage, inlineResponse2001.previousPage) &&
        Objects.equals(this.nextPage, inlineResponse2001.nextPage) &&
        Objects.equals(this.nbPages, inlineResponse2001.nbPages);
  }

  @Override
  public int hashCode() {
    return Objects.hash(currentPage, maxPerPage, currentPageResults, nbResults, previousPage, nextPage, nbPages);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InlineResponse2001 {\n");
    sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
    sb.append("    maxPerPage: ").append(toIndentedString(maxPerPage)).append("\n");
    sb.append("    currentPageResults: ").append(toIndentedString(currentPageResults)).append("\n");
    sb.append("    nbResults: ").append(toIndentedString(nbResults)).append("\n");
    sb.append("    previousPage: ").append(toIndentedString(previousPage)).append("\n");
    sb.append("    nextPage: ").append(toIndentedString(nextPage)).append("\n");
    sb.append("    nbPages: ").append(toIndentedString(nbPages)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

