/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Move
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class Move {
  public static final String SERIALIZED_NAME_UCI = "uci";
  @SerializedName(SERIALIZED_NAME_UCI)
  private String uci;

  public static final String SERIALIZED_NAME_SAN = "san";
  @SerializedName(SERIALIZED_NAME_SAN)
  private String san;

  /**
   * Gets or Sets category
   */
  @JsonAdapter(CategoryEnum.Adapter.class)
  public enum CategoryEnum {
    LOSS("loss"),
    
    UNKNOWN("unknown"),
    
    MAYBE_LOSS("maybe-loss"),
    
    BLESSED_LOSS("blessed-loss"),
    
    DRAW("draw"),
    
    CURSED_WIN("cursed-win"),
    
    MAYBE_WIN("maybe-win"),
    
    WIN("win");

    private String value;

    CategoryEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static CategoryEnum fromValue(String value) {
      for (CategoryEnum b : CategoryEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<CategoryEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final CategoryEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public CategoryEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return CategoryEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_CATEGORY = "category";
  @SerializedName(SERIALIZED_NAME_CATEGORY)
  private CategoryEnum category;

  public static final String SERIALIZED_NAME_DTZ = "dtz";
  @SerializedName(SERIALIZED_NAME_DTZ)
  private Integer dtz;

  public static final String SERIALIZED_NAME_DTM = "dtm";
  @SerializedName(SERIALIZED_NAME_DTM)
  private Integer dtm;

  public static final String SERIALIZED_NAME_ZEROING = "zeroing";
  @SerializedName(SERIALIZED_NAME_ZEROING)
  private Boolean zeroing;

  public static final String SERIALIZED_NAME_CHECKMATE = "checkmate";
  @SerializedName(SERIALIZED_NAME_CHECKMATE)
  private Boolean checkmate;

  public static final String SERIALIZED_NAME_STALEMATE = "stalemate";
  @SerializedName(SERIALIZED_NAME_STALEMATE)
  private Boolean stalemate;

  public static final String SERIALIZED_NAME_VARIANT_WIN = "variant_win";
  @SerializedName(SERIALIZED_NAME_VARIANT_WIN)
  private Boolean variantWin;

  public static final String SERIALIZED_NAME_VARIANT_LOSS = "variant_loss";
  @SerializedName(SERIALIZED_NAME_VARIANT_LOSS)
  private Boolean variantLoss;

  public static final String SERIALIZED_NAME_INSUFFICIENT_MATERIAL = "insufficient_material";
  @SerializedName(SERIALIZED_NAME_INSUFFICIENT_MATERIAL)
  private Boolean insufficientMaterial;


  public Move uci(String uci) {
    
    this.uci = uci;
    return this;
  }

   /**
   * Get uci
   * @return uci
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "h7h8q", value = "")

  public String getUci() {
    return uci;
  }


  public void setUci(String uci) {
    this.uci = uci;
  }


  public Move san(String san) {
    
    this.san = san;
    return this;
  }

   /**
   * Get san
   * @return san
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "h8=Q+", value = "")

  public String getSan() {
    return san;
  }


  public void setSan(String san) {
    this.san = san;
  }


  public Move category(CategoryEnum category) {
    
    this.category = category;
    return this;
  }

   /**
   * Get category
   * @return category
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public CategoryEnum getCategory() {
    return category;
  }


  public void setCategory(CategoryEnum category) {
    this.category = category;
  }


  public Move dtz(Integer dtz) {
    
    this.dtz = dtz;
    return this;
  }

   /**
   * DTZ50&#39;&#39; with rounding or null if unknown
   * @return dtz
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "DTZ50'' with rounding or null if unknown")

  public Integer getDtz() {
    return dtz;
  }


  public void setDtz(Integer dtz) {
    this.dtz = dtz;
  }


  public Move dtm(Integer dtm) {
    
    this.dtm = dtm;
    return this;
  }

   /**
   * Distance to mate (only for positions with not more than 5 pieces)
   * @return dtm
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Distance to mate (only for positions with not more than 5 pieces)")

  public Integer getDtm() {
    return dtm;
  }


  public void setDtm(Integer dtm) {
    this.dtm = dtm;
  }


  public Move zeroing(Boolean zeroing) {
    
    this.zeroing = zeroing;
    return this;
  }

   /**
   * Get zeroing
   * @return zeroing
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getZeroing() {
    return zeroing;
  }


  public void setZeroing(Boolean zeroing) {
    this.zeroing = zeroing;
  }


  public Move checkmate(Boolean checkmate) {
    
    this.checkmate = checkmate;
    return this;
  }

   /**
   * Get checkmate
   * @return checkmate
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getCheckmate() {
    return checkmate;
  }


  public void setCheckmate(Boolean checkmate) {
    this.checkmate = checkmate;
  }


  public Move stalemate(Boolean stalemate) {
    
    this.stalemate = stalemate;
    return this;
  }

   /**
   * Get stalemate
   * @return stalemate
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getStalemate() {
    return stalemate;
  }


  public void setStalemate(Boolean stalemate) {
    this.stalemate = stalemate;
  }


  public Move variantWin(Boolean variantWin) {
    
    this.variantWin = variantWin;
    return this;
  }

   /**
   * Get variantWin
   * @return variantWin
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getVariantWin() {
    return variantWin;
  }


  public void setVariantWin(Boolean variantWin) {
    this.variantWin = variantWin;
  }


  public Move variantLoss(Boolean variantLoss) {
    
    this.variantLoss = variantLoss;
    return this;
  }

   /**
   * Get variantLoss
   * @return variantLoss
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getVariantLoss() {
    return variantLoss;
  }


  public void setVariantLoss(Boolean variantLoss) {
    this.variantLoss = variantLoss;
  }


  public Move insufficientMaterial(Boolean insufficientMaterial) {
    
    this.insufficientMaterial = insufficientMaterial;
    return this;
  }

   /**
   * Get insufficientMaterial
   * @return insufficientMaterial
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getInsufficientMaterial() {
    return insufficientMaterial;
  }


  public void setInsufficientMaterial(Boolean insufficientMaterial) {
    this.insufficientMaterial = insufficientMaterial;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Move move = (Move) o;
    return Objects.equals(this.uci, move.uci) &&
        Objects.equals(this.san, move.san) &&
        Objects.equals(this.category, move.category) &&
        Objects.equals(this.dtz, move.dtz) &&
        Objects.equals(this.dtm, move.dtm) &&
        Objects.equals(this.zeroing, move.zeroing) &&
        Objects.equals(this.checkmate, move.checkmate) &&
        Objects.equals(this.stalemate, move.stalemate) &&
        Objects.equals(this.variantWin, move.variantWin) &&
        Objects.equals(this.variantLoss, move.variantLoss) &&
        Objects.equals(this.insufficientMaterial, move.insufficientMaterial);
  }

  @Override
  public int hashCode() {
    return Objects.hash(uci, san, category, dtz, dtm, zeroing, checkmate, stalemate, variantWin, variantLoss, insufficientMaterial);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Move {\n");
    sb.append("    uci: ").append(toIndentedString(uci)).append("\n");
    sb.append("    san: ").append(toIndentedString(san)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    dtz: ").append(toIndentedString(dtz)).append("\n");
    sb.append("    dtm: ").append(toIndentedString(dtm)).append("\n");
    sb.append("    zeroing: ").append(toIndentedString(zeroing)).append("\n");
    sb.append("    checkmate: ").append(toIndentedString(checkmate)).append("\n");
    sb.append("    stalemate: ").append(toIndentedString(stalemate)).append("\n");
    sb.append("    variantWin: ").append(toIndentedString(variantWin)).append("\n");
    sb.append("    variantLoss: ").append(toIndentedString(variantLoss)).append("\n");
    sb.append("    insufficientMaterial: ").append(toIndentedString(insufficientMaterial)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

