/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Perf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class Perf {
  public static final String SERIALIZED_NAME_GAMES = "games";
  @SerializedName(SERIALIZED_NAME_GAMES)
  private Integer games;

  public static final String SERIALIZED_NAME_RATING = "rating";
  @SerializedName(SERIALIZED_NAME_RATING)
  private Integer rating;

  public static final String SERIALIZED_NAME_RD = "rd";
  @SerializedName(SERIALIZED_NAME_RD)
  private Integer rd;

  public static final String SERIALIZED_NAME_PROG = "prog";
  @SerializedName(SERIALIZED_NAME_PROG)
  private Integer prog;

  public static final String SERIALIZED_NAME_PROV = "prov";
  @SerializedName(SERIALIZED_NAME_PROV)
  private Boolean prov;


  public Perf games(Integer games) {
    
    this.games = games;
    return this;
  }

   /**
   * Get games
   * @return games
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2945", value = "")

  public Integer getGames() {
    return games;
  }


  public void setGames(Integer games) {
    this.games = games;
  }


  public Perf rating(Integer rating) {
    
    this.rating = rating;
    return this;
  }

   /**
   * Get rating
   * @return rating
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1609", value = "")

  public Integer getRating() {
    return rating;
  }


  public void setRating(Integer rating) {
    this.rating = rating;
  }


  public Perf rd(Integer rd) {
    
    this.rd = rd;
    return this;
  }

   /**
   * Get rd
   * @return rd
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "60", value = "")

  public Integer getRd() {
    return rd;
  }


  public void setRd(Integer rd) {
    this.rd = rd;
  }


  public Perf prog(Integer prog) {
    
    this.prog = prog;
    return this;
  }

   /**
   * Get prog
   * @return prog
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "-22", value = "")

  public Integer getProg() {
    return prog;
  }


  public void setProg(Integer prog) {
    this.prog = prog;
  }


  public Perf prov(Boolean prov) {
    
    this.prov = prov;
    return this;
  }

   /**
   * Get prov
   * @return prov
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Boolean getProv() {
    return prov;
  }


  public void setProv(Boolean prov) {
    this.prov = prov;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Perf perf = (Perf) o;
    return Objects.equals(this.games, perf.games) &&
        Objects.equals(this.rating, perf.rating) &&
        Objects.equals(this.rd, perf.rd) &&
        Objects.equals(this.prog, perf.prog) &&
        Objects.equals(this.prov, perf.prov);
  }

  @Override
  public int hashCode() {
    return Objects.hash(games, rating, rd, prog, prov);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Perf {\n");
    sb.append("    games: ").append(toIndentedString(games)).append("\n");
    sb.append("    rating: ").append(toIndentedString(rating)).append("\n");
    sb.append("    rd: ").append(toIndentedString(rd)).append("\n");
    sb.append("    prog: ").append(toIndentedString(prog)).append("\n");
    sb.append("    prov: ").append(toIndentedString(prov)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

