/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.Perf;
import org.openapitools.client.model.StormPerf;

/**
 * Perfs
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class Perfs {
  public static final String SERIALIZED_NAME_CHESS960 = "chess960";
  @SerializedName(SERIALIZED_NAME_CHESS960)
  private Perf chess960;

  public static final String SERIALIZED_NAME_ATOMIC = "atomic";
  @SerializedName(SERIALIZED_NAME_ATOMIC)
  private Perf atomic;

  public static final String SERIALIZED_NAME_RACING_KINGS = "racingKings";
  @SerializedName(SERIALIZED_NAME_RACING_KINGS)
  private Perf racingKings;

  public static final String SERIALIZED_NAME_ULTRA_BULLET = "ultraBullet";
  @SerializedName(SERIALIZED_NAME_ULTRA_BULLET)
  private Perf ultraBullet;

  public static final String SERIALIZED_NAME_BLITZ = "blitz";
  @SerializedName(SERIALIZED_NAME_BLITZ)
  private Perf blitz;

  public static final String SERIALIZED_NAME_KING_OF_THE_HILL = "kingOfTheHill";
  @SerializedName(SERIALIZED_NAME_KING_OF_THE_HILL)
  private Perf kingOfTheHill;

  public static final String SERIALIZED_NAME_BULLET = "bullet";
  @SerializedName(SERIALIZED_NAME_BULLET)
  private Perf bullet;

  public static final String SERIALIZED_NAME_CORRESPONDENCE = "correspondence";
  @SerializedName(SERIALIZED_NAME_CORRESPONDENCE)
  private Perf correspondence;

  public static final String SERIALIZED_NAME_HORDE = "horde";
  @SerializedName(SERIALIZED_NAME_HORDE)
  private Perf horde;

  public static final String SERIALIZED_NAME_PUZZLE = "puzzle";
  @SerializedName(SERIALIZED_NAME_PUZZLE)
  private Perf puzzle;

  public static final String SERIALIZED_NAME_CLASSICAL = "classical";
  @SerializedName(SERIALIZED_NAME_CLASSICAL)
  private Perf classical;

  public static final String SERIALIZED_NAME_RAPID = "rapid";
  @SerializedName(SERIALIZED_NAME_RAPID)
  private Perf rapid;

  public static final String SERIALIZED_NAME_STORM = "storm";
  @SerializedName(SERIALIZED_NAME_STORM)
  private StormPerf storm;


  public Perfs chess960(Perf chess960) {
    
    this.chess960 = chess960;
    return this;
  }

   /**
   * Get chess960
   * @return chess960
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getChess960() {
    return chess960;
  }


  public void setChess960(Perf chess960) {
    this.chess960 = chess960;
  }


  public Perfs atomic(Perf atomic) {
    
    this.atomic = atomic;
    return this;
  }

   /**
   * Get atomic
   * @return atomic
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getAtomic() {
    return atomic;
  }


  public void setAtomic(Perf atomic) {
    this.atomic = atomic;
  }


  public Perfs racingKings(Perf racingKings) {
    
    this.racingKings = racingKings;
    return this;
  }

   /**
   * Get racingKings
   * @return racingKings
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getRacingKings() {
    return racingKings;
  }


  public void setRacingKings(Perf racingKings) {
    this.racingKings = racingKings;
  }


  public Perfs ultraBullet(Perf ultraBullet) {
    
    this.ultraBullet = ultraBullet;
    return this;
  }

   /**
   * Get ultraBullet
   * @return ultraBullet
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getUltraBullet() {
    return ultraBullet;
  }


  public void setUltraBullet(Perf ultraBullet) {
    this.ultraBullet = ultraBullet;
  }


  public Perfs blitz(Perf blitz) {
    
    this.blitz = blitz;
    return this;
  }

   /**
   * Get blitz
   * @return blitz
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getBlitz() {
    return blitz;
  }


  public void setBlitz(Perf blitz) {
    this.blitz = blitz;
  }


  public Perfs kingOfTheHill(Perf kingOfTheHill) {
    
    this.kingOfTheHill = kingOfTheHill;
    return this;
  }

   /**
   * Get kingOfTheHill
   * @return kingOfTheHill
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getKingOfTheHill() {
    return kingOfTheHill;
  }


  public void setKingOfTheHill(Perf kingOfTheHill) {
    this.kingOfTheHill = kingOfTheHill;
  }


  public Perfs bullet(Perf bullet) {
    
    this.bullet = bullet;
    return this;
  }

   /**
   * Get bullet
   * @return bullet
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getBullet() {
    return bullet;
  }


  public void setBullet(Perf bullet) {
    this.bullet = bullet;
  }


  public Perfs correspondence(Perf correspondence) {
    
    this.correspondence = correspondence;
    return this;
  }

   /**
   * Get correspondence
   * @return correspondence
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getCorrespondence() {
    return correspondence;
  }


  public void setCorrespondence(Perf correspondence) {
    this.correspondence = correspondence;
  }


  public Perfs horde(Perf horde) {
    
    this.horde = horde;
    return this;
  }

   /**
   * Get horde
   * @return horde
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getHorde() {
    return horde;
  }


  public void setHorde(Perf horde) {
    this.horde = horde;
  }


  public Perfs puzzle(Perf puzzle) {
    
    this.puzzle = puzzle;
    return this;
  }

   /**
   * Get puzzle
   * @return puzzle
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getPuzzle() {
    return puzzle;
  }


  public void setPuzzle(Perf puzzle) {
    this.puzzle = puzzle;
  }


  public Perfs classical(Perf classical) {
    
    this.classical = classical;
    return this;
  }

   /**
   * Get classical
   * @return classical
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getClassical() {
    return classical;
  }


  public void setClassical(Perf classical) {
    this.classical = classical;
  }


  public Perfs rapid(Perf rapid) {
    
    this.rapid = rapid;
    return this;
  }

   /**
   * Get rapid
   * @return rapid
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perf getRapid() {
    return rapid;
  }


  public void setRapid(Perf rapid) {
    this.rapid = rapid;
  }


  public Perfs storm(StormPerf storm) {
    
    this.storm = storm;
    return this;
  }

   /**
   * Get storm
   * @return storm
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public StormPerf getStorm() {
    return storm;
  }


  public void setStorm(StormPerf storm) {
    this.storm = storm;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Perfs perfs = (Perfs) o;
    return Objects.equals(this.chess960, perfs.chess960) &&
        Objects.equals(this.atomic, perfs.atomic) &&
        Objects.equals(this.racingKings, perfs.racingKings) &&
        Objects.equals(this.ultraBullet, perfs.ultraBullet) &&
        Objects.equals(this.blitz, perfs.blitz) &&
        Objects.equals(this.kingOfTheHill, perfs.kingOfTheHill) &&
        Objects.equals(this.bullet, perfs.bullet) &&
        Objects.equals(this.correspondence, perfs.correspondence) &&
        Objects.equals(this.horde, perfs.horde) &&
        Objects.equals(this.puzzle, perfs.puzzle) &&
        Objects.equals(this.classical, perfs.classical) &&
        Objects.equals(this.rapid, perfs.rapid) &&
        Objects.equals(this.storm, perfs.storm);
  }

  @Override
  public int hashCode() {
    return Objects.hash(chess960, atomic, racingKings, ultraBullet, blitz, kingOfTheHill, bullet, correspondence, horde, puzzle, classical, rapid, storm);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Perfs {\n");
    sb.append("    chess960: ").append(toIndentedString(chess960)).append("\n");
    sb.append("    atomic: ").append(toIndentedString(atomic)).append("\n");
    sb.append("    racingKings: ").append(toIndentedString(racingKings)).append("\n");
    sb.append("    ultraBullet: ").append(toIndentedString(ultraBullet)).append("\n");
    sb.append("    blitz: ").append(toIndentedString(blitz)).append("\n");
    sb.append("    kingOfTheHill: ").append(toIndentedString(kingOfTheHill)).append("\n");
    sb.append("    bullet: ").append(toIndentedString(bullet)).append("\n");
    sb.append("    correspondence: ").append(toIndentedString(correspondence)).append("\n");
    sb.append("    horde: ").append(toIndentedString(horde)).append("\n");
    sb.append("    puzzle: ").append(toIndentedString(puzzle)).append("\n");
    sb.append("    classical: ").append(toIndentedString(classical)).append("\n");
    sb.append("    rapid: ").append(toIndentedString(rapid)).append("\n");
    sb.append("    storm: ").append(toIndentedString(storm)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

