/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.Perfs;
import org.openapitools.client.model.PlayTime;
import org.openapitools.client.model.Profile;
import org.openapitools.client.model.Title;

/**
 * User
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class User {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_USERNAME = "username";
  @SerializedName(SERIALIZED_NAME_USERNAME)
  private String username;

  public static final String SERIALIZED_NAME_ONLINE = "online";
  @SerializedName(SERIALIZED_NAME_ONLINE)
  private Boolean online;

  public static final String SERIALIZED_NAME_PERFS = "perfs";
  @SerializedName(SERIALIZED_NAME_PERFS)
  private Perfs perfs;

  public static final String SERIALIZED_NAME_CREATED_AT = "createdAt";
  @SerializedName(SERIALIZED_NAME_CREATED_AT)
  private Integer createdAt;

  public static final String SERIALIZED_NAME_DISABLED = "disabled";
  @SerializedName(SERIALIZED_NAME_DISABLED)
  private Boolean disabled;

  public static final String SERIALIZED_NAME_TOS_VIOLATION = "tosViolation";
  @SerializedName(SERIALIZED_NAME_TOS_VIOLATION)
  private Boolean tosViolation;

  public static final String SERIALIZED_NAME_PROFILE = "profile";
  @SerializedName(SERIALIZED_NAME_PROFILE)
  private Profile profile;

  public static final String SERIALIZED_NAME_SEEN_AT = "seenAt";
  @SerializedName(SERIALIZED_NAME_SEEN_AT)
  private Integer seenAt;

  public static final String SERIALIZED_NAME_PATRON = "patron";
  @SerializedName(SERIALIZED_NAME_PATRON)
  private Boolean patron;

  public static final String SERIALIZED_NAME_VERIFIED = "verified";
  @SerializedName(SERIALIZED_NAME_VERIFIED)
  private Boolean verified;

  public static final String SERIALIZED_NAME_PLAY_TIME = "playTime";
  @SerializedName(SERIALIZED_NAME_PLAY_TIME)
  private PlayTime playTime;

  public static final String SERIALIZED_NAME_TITLE = "title";
  @SerializedName(SERIALIZED_NAME_TITLE)
  private Title title;


  public User id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "georges", value = "")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public User username(String username) {
    
    this.username = username;
    return this;
  }

   /**
   * Get username
   * @return username
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Georges", value = "")

  public String getUsername() {
    return username;
  }


  public void setUsername(String username) {
    this.username = username;
  }


  public User online(Boolean online) {
    
    this.online = online;
    return this;
  }

   /**
   * Get online
   * @return online
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getOnline() {
    return online;
  }


  public void setOnline(Boolean online) {
    this.online = online;
  }


  public User perfs(Perfs perfs) {
    
    this.perfs = perfs;
    return this;
  }

   /**
   * Get perfs
   * @return perfs
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Perfs getPerfs() {
    return perfs;
  }


  public void setPerfs(Perfs perfs) {
    this.perfs = perfs;
  }


  public User createdAt(Integer createdAt) {
    
    this.createdAt = createdAt;
    return this;
  }

   /**
   * Get createdAt
   * @return createdAt
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1290415680000", value = "")

  public Integer getCreatedAt() {
    return createdAt;
  }


  public void setCreatedAt(Integer createdAt) {
    this.createdAt = createdAt;
  }


  public User disabled(Boolean disabled) {
    
    this.disabled = disabled;
    return this;
  }

   /**
   * Get disabled
   * @return disabled
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getDisabled() {
    return disabled;
  }


  public void setDisabled(Boolean disabled) {
    this.disabled = disabled;
  }


  public User tosViolation(Boolean tosViolation) {
    
    this.tosViolation = tosViolation;
    return this;
  }

   /**
   * Get tosViolation
   * @return tosViolation
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getTosViolation() {
    return tosViolation;
  }


  public void setTosViolation(Boolean tosViolation) {
    this.tosViolation = tosViolation;
  }


  public User profile(Profile profile) {
    
    this.profile = profile;
    return this;
  }

   /**
   * Get profile
   * @return profile
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Profile getProfile() {
    return profile;
  }


  public void setProfile(Profile profile) {
    this.profile = profile;
  }


  public User seenAt(Integer seenAt) {
    
    this.seenAt = seenAt;
    return this;
  }

   /**
   * Get seenAt
   * @return seenAt
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1522636452014", value = "")

  public Integer getSeenAt() {
    return seenAt;
  }


  public void setSeenAt(Integer seenAt) {
    this.seenAt = seenAt;
  }


  public User patron(Boolean patron) {
    
    this.patron = patron;
    return this;
  }

   /**
   * Get patron
   * @return patron
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getPatron() {
    return patron;
  }


  public void setPatron(Boolean patron) {
    this.patron = patron;
  }


  public User verified(Boolean verified) {
    
    this.verified = verified;
    return this;
  }

   /**
   * Get verified
   * @return verified
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getVerified() {
    return verified;
  }


  public void setVerified(Boolean verified) {
    this.verified = verified;
  }


  public User playTime(PlayTime playTime) {
    
    this.playTime = playTime;
    return this;
  }

   /**
   * Get playTime
   * @return playTime
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public PlayTime getPlayTime() {
    return playTime;
  }


  public void setPlayTime(PlayTime playTime) {
    this.playTime = playTime;
  }


  public User title(Title title) {
    
    this.title = title;
    return this;
  }

   /**
   * Get title
   * @return title
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Title getTitle() {
    return title;
  }


  public void setTitle(Title title) {
    this.title = title;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    User user = (User) o;
    return Objects.equals(this.id, user.id) &&
        Objects.equals(this.username, user.username) &&
        Objects.equals(this.online, user.online) &&
        Objects.equals(this.perfs, user.perfs) &&
        Objects.equals(this.createdAt, user.createdAt) &&
        Objects.equals(this.disabled, user.disabled) &&
        Objects.equals(this.tosViolation, user.tosViolation) &&
        Objects.equals(this.profile, user.profile) &&
        Objects.equals(this.seenAt, user.seenAt) &&
        Objects.equals(this.patron, user.patron) &&
        Objects.equals(this.verified, user.verified) &&
        Objects.equals(this.playTime, user.playTime) &&
        Objects.equals(this.title, user.title);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, username, online, perfs, createdAt, disabled, tosViolation, profile, seenAt, patron, verified, playTime, title);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class User {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    online: ").append(toIndentedString(online)).append("\n");
    sb.append("    perfs: ").append(toIndentedString(perfs)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    disabled: ").append(toIndentedString(disabled)).append("\n");
    sb.append("    tosViolation: ").append(toIndentedString(tosViolation)).append("\n");
    sb.append("    profile: ").append(toIndentedString(profile)).append("\n");
    sb.append("    seenAt: ").append(toIndentedString(seenAt)).append("\n");
    sb.append("    patron: ").append(toIndentedString(patron)).append("\n");
    sb.append("    verified: ").append(toIndentedString(verified)).append("\n");
    sb.append("    playTime: ").append(toIndentedString(playTime)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

