/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.net.URI;
import org.openapitools.client.model.Count;

/**
 * UserExtendedAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class UserExtendedAllOf {
  public static final String SERIALIZED_NAME_URL = "url";
  @SerializedName(SERIALIZED_NAME_URL)
  private URI url;

  public static final String SERIALIZED_NAME_PLAYING = "playing";
  @SerializedName(SERIALIZED_NAME_PLAYING)
  private URI playing;

  public static final String SERIALIZED_NAME_COMPLETION_RATE = "completionRate";
  @SerializedName(SERIALIZED_NAME_COMPLETION_RATE)
  private Integer completionRate;

  public static final String SERIALIZED_NAME_COUNT = "count";
  @SerializedName(SERIALIZED_NAME_COUNT)
  private Count count;

  public static final String SERIALIZED_NAME_STREAMING = "streaming";
  @SerializedName(SERIALIZED_NAME_STREAMING)
  private Boolean streaming;

  public static final String SERIALIZED_NAME_FOLLOWABLE = "followable";
  @SerializedName(SERIALIZED_NAME_FOLLOWABLE)
  private Boolean followable;

  public static final String SERIALIZED_NAME_FOLLOWING = "following";
  @SerializedName(SERIALIZED_NAME_FOLLOWING)
  private Boolean following;

  public static final String SERIALIZED_NAME_BLOCKING = "blocking";
  @SerializedName(SERIALIZED_NAME_BLOCKING)
  private Boolean blocking;

  public static final String SERIALIZED_NAME_FOLLOWS_YOU = "followsYou";
  @SerializedName(SERIALIZED_NAME_FOLLOWS_YOU)
  private Boolean followsYou;


  public UserExtendedAllOf url(URI url) {
    
    this.url = url;
    return this;
  }

   /**
   * Get url
   * @return url
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://lichess.org/@/georges", value = "")

  public URI getUrl() {
    return url;
  }


  public void setUrl(URI url) {
    this.url = url;
  }


  public UserExtendedAllOf playing(URI playing) {
    
    this.playing = playing;
    return this;
  }

   /**
   * Get playing
   * @return playing
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://lichess.org/yqfLYJ5E/black", value = "")

  public URI getPlaying() {
    return playing;
  }


  public void setPlaying(URI playing) {
    this.playing = playing;
  }


  public UserExtendedAllOf completionRate(Integer completionRate) {
    
    this.completionRate = completionRate;
    return this;
  }

   /**
   * Get completionRate
   * @return completionRate
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "97", value = "")

  public Integer getCompletionRate() {
    return completionRate;
  }


  public void setCompletionRate(Integer completionRate) {
    this.completionRate = completionRate;
  }


  public UserExtendedAllOf count(Count count) {
    
    this.count = count;
    return this;
  }

   /**
   * Get count
   * @return count
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Count getCount() {
    return count;
  }


  public void setCount(Count count) {
    this.count = count;
  }


  public UserExtendedAllOf streaming(Boolean streaming) {
    
    this.streaming = streaming;
    return this;
  }

   /**
   * Get streaming
   * @return streaming
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getStreaming() {
    return streaming;
  }


  public void setStreaming(Boolean streaming) {
    this.streaming = streaming;
  }


  public UserExtendedAllOf followable(Boolean followable) {
    
    this.followable = followable;
    return this;
  }

   /**
   * Get followable
   * @return followable
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getFollowable() {
    return followable;
  }


  public void setFollowable(Boolean followable) {
    this.followable = followable;
  }


  public UserExtendedAllOf following(Boolean following) {
    
    this.following = following;
    return this;
  }

   /**
   * Get following
   * @return following
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getFollowing() {
    return following;
  }


  public void setFollowing(Boolean following) {
    this.following = following;
  }


  public UserExtendedAllOf blocking(Boolean blocking) {
    
    this.blocking = blocking;
    return this;
  }

   /**
   * Get blocking
   * @return blocking
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getBlocking() {
    return blocking;
  }


  public void setBlocking(Boolean blocking) {
    this.blocking = blocking;
  }


  public UserExtendedAllOf followsYou(Boolean followsYou) {
    
    this.followsYou = followsYou;
    return this;
  }

   /**
   * Get followsYou
   * @return followsYou
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getFollowsYou() {
    return followsYou;
  }


  public void setFollowsYou(Boolean followsYou) {
    this.followsYou = followsYou;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserExtendedAllOf userExtendedAllOf = (UserExtendedAllOf) o;
    return Objects.equals(this.url, userExtendedAllOf.url) &&
        Objects.equals(this.playing, userExtendedAllOf.playing) &&
        Objects.equals(this.completionRate, userExtendedAllOf.completionRate) &&
        Objects.equals(this.count, userExtendedAllOf.count) &&
        Objects.equals(this.streaming, userExtendedAllOf.streaming) &&
        Objects.equals(this.followable, userExtendedAllOf.followable) &&
        Objects.equals(this.following, userExtendedAllOf.following) &&
        Objects.equals(this.blocking, userExtendedAllOf.blocking) &&
        Objects.equals(this.followsYou, userExtendedAllOf.followsYou);
  }

  @Override
  public int hashCode() {
    return Objects.hash(url, playing, completionRate, count, streaming, followable, following, blocking, followsYou);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserExtendedAllOf {\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    playing: ").append(toIndentedString(playing)).append("\n");
    sb.append("    completionRate: ").append(toIndentedString(completionRate)).append("\n");
    sb.append("    count: ").append(toIndentedString(count)).append("\n");
    sb.append("    streaming: ").append(toIndentedString(streaming)).append("\n");
    sb.append("    followable: ").append(toIndentedString(followable)).append("\n");
    sb.append("    following: ").append(toIndentedString(following)).append("\n");
    sb.append("    blocking: ").append(toIndentedString(blocking)).append("\n");
    sb.append("    followsYou: ").append(toIndentedString(followsYou)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

