/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.net.URI;

/**
 * UserPreferences
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-12-01T01:33:45.712176+01:00[Europe/Vienna]")
public class UserPreferences {
  public static final String SERIALIZED_NAME_DARK = "dark";
  @SerializedName(SERIALIZED_NAME_DARK)
  private Boolean dark;

  public static final String SERIALIZED_NAME_TRANSP = "transp";
  @SerializedName(SERIALIZED_NAME_TRANSP)
  private Boolean transp;

  public static final String SERIALIZED_NAME_BG_IMG = "bgImg";
  @SerializedName(SERIALIZED_NAME_BG_IMG)
  private URI bgImg;

  public static final String SERIALIZED_NAME_IS3D = "is3d";
  @SerializedName(SERIALIZED_NAME_IS3D)
  private Boolean is3d;

  /**
   * Gets or Sets theme
   */
  @JsonAdapter(ThemeEnum.Adapter.class)
  public enum ThemeEnum {
    BLUE("blue"),
    
    BLUE2("blue2"),
    
    BLUE3("blue3"),
    
    BLUE_MARBLE("blue-marble"),
    
    CANVAS("canvas"),
    
    WOOD("wood"),
    
    WOOD2("wood2"),
    
    WOOD3("wood3"),
    
    WOOD4("wood4"),
    
    MAPLE("maple"),
    
    MAPLE2("maple2"),
    
    BROWN("brown"),
    
    LEATHER("leather"),
    
    GREEN("green"),
    
    MARBLE("marble"),
    
    GREEN_PLASTIC("green-plastic"),
    
    GREY("grey"),
    
    METAL("metal"),
    
    OLIVE("olive"),
    
    NEWSPAPER("newspaper"),
    
    PURPLE("purple"),
    
    PURPLE_DIAG("purple-diag"),
    
    PINK("pink"),
    
    IC("ic");

    private String value;

    ThemeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ThemeEnum fromValue(String value) {
      for (ThemeEnum b : ThemeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<ThemeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ThemeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ThemeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return ThemeEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_THEME = "theme";
  @SerializedName(SERIALIZED_NAME_THEME)
  private ThemeEnum theme;

  /**
   * Gets or Sets pieceSet
   */
  @JsonAdapter(PieceSetEnum.Adapter.class)
  public enum PieceSetEnum {
    CBURNETT("cburnett"),
    
    MERIDA("merida"),
    
    ALPHA("alpha"),
    
    PIROUETTI("pirouetti"),
    
    CHESSNUT("chessnut"),
    
    CHESS7("chess7"),
    
    REILLYCRAIG("reillycraig"),
    
    COMPANION("companion"),
    
    RIOHACHA("riohacha"),
    
    KOSAL("kosal"),
    
    LEIPZIG("leipzig"),
    
    FANTASY("fantasy"),
    
    SPATIAL("spatial"),
    
    CALIFORNIA("california"),
    
    PIXEL("pixel"),
    
    MAESTRO("maestro"),
    
    FRESCA("fresca"),
    
    CARDINAL("cardinal"),
    
    GIOCO("gioco"),
    
    TATIANA("tatiana"),
    
    STAUNTY("staunty"),
    
    GOVERNOR("governor"),
    
    DUBROVNY("dubrovny"),
    
    ICPIECES("icpieces"),
    
    SHAPES("shapes"),
    
    LETTER("letter");

    private String value;

    PieceSetEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static PieceSetEnum fromValue(String value) {
      for (PieceSetEnum b : PieceSetEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<PieceSetEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final PieceSetEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public PieceSetEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return PieceSetEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_PIECE_SET = "pieceSet";
  @SerializedName(SERIALIZED_NAME_PIECE_SET)
  private PieceSetEnum pieceSet;

  /**
   * Gets or Sets theme3d
   */
  @JsonAdapter(Theme3dEnum.Adapter.class)
  public enum Theme3dEnum {
    BLACK_WHITE_ALUMINIUM("Black-White-Aluminium"),
    
    BRUSHED_ALUMINIUM("Brushed-Aluminium"),
    
    CHINA_BLUE("China-Blue"),
    
    CHINA_GREEN("China-Green"),
    
    CHINA_GREY("China-Grey"),
    
    CHINA_SCARLET("China-Scarlet"),
    
    CLASSIC_BLUE("Classic-Blue"),
    
    GOLD_SILVER("Gold-Silver"),
    
    LIGHT_WOOD("Light-Wood"),
    
    POWER_COATED("Power-Coated"),
    
    ROSEWOOD("Rosewood"),
    
    MARBLE("Marble"),
    
    WAX("Wax"),
    
    JADE("Jade"),
    
    WOODI("Woodi");

    private String value;

    Theme3dEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static Theme3dEnum fromValue(String value) {
      for (Theme3dEnum b : Theme3dEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<Theme3dEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final Theme3dEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public Theme3dEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return Theme3dEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_THEME3D = "theme3d";
  @SerializedName(SERIALIZED_NAME_THEME3D)
  private Theme3dEnum theme3d;

  /**
   * Gets or Sets pieceSet3d
   */
  @JsonAdapter(PieceSet3dEnum.Adapter.class)
  public enum PieceSet3dEnum {
    BASIC("Basic"),
    
    WOOD("Wood"),
    
    METAL("Metal"),
    
    REDVBLUE("RedVBlue"),
    
    MODERNJADE("ModernJade"),
    
    MODERNWOOD("ModernWood"),
    
    GLASS("Glass"),
    
    TRIMMED("Trimmed"),
    
    EXPERIMENTAL("Experimental"),
    
    STAUNTON("Staunton"),
    
    CUBESANDPI("CubesAndPi");

    private String value;

    PieceSet3dEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static PieceSet3dEnum fromValue(String value) {
      for (PieceSet3dEnum b : PieceSet3dEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<PieceSet3dEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final PieceSet3dEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public PieceSet3dEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return PieceSet3dEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_PIECE_SET3D = "pieceSet3d";
  @SerializedName(SERIALIZED_NAME_PIECE_SET3D)
  private PieceSet3dEnum pieceSet3d;

  /**
   * Gets or Sets soundSet
   */
  @JsonAdapter(SoundSetEnum.Adapter.class)
  public enum SoundSetEnum {
    SILENT("silent"),
    
    STANDARD("standard"),
    
    PIANO("piano"),
    
    NES("nes"),
    
    SFX("sfx"),
    
    FUTURISTIC("futuristic"),
    
    ROBOT("robot"),
    
    MUSIC("music"),
    
    SPEECH("speech");

    private String value;

    SoundSetEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SoundSetEnum fromValue(String value) {
      for (SoundSetEnum b : SoundSetEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<SoundSetEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SoundSetEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SoundSetEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return SoundSetEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_SOUND_SET = "soundSet";
  @SerializedName(SERIALIZED_NAME_SOUND_SET)
  private SoundSetEnum soundSet;

  public static final String SERIALIZED_NAME_BLINDFOLD = "blindfold";
  @SerializedName(SERIALIZED_NAME_BLINDFOLD)
  private Integer blindfold;

  public static final String SERIALIZED_NAME_AUTO_QUEEN = "autoQueen";
  @SerializedName(SERIALIZED_NAME_AUTO_QUEEN)
  private Integer autoQueen;

  public static final String SERIALIZED_NAME_AUTO_THREEFOLD = "autoThreefold";
  @SerializedName(SERIALIZED_NAME_AUTO_THREEFOLD)
  private Integer autoThreefold;

  public static final String SERIALIZED_NAME_TAKEBACK = "takeback";
  @SerializedName(SERIALIZED_NAME_TAKEBACK)
  private Integer takeback;

  public static final String SERIALIZED_NAME_MORETIME = "moretime";
  @SerializedName(SERIALIZED_NAME_MORETIME)
  private Integer moretime;

  public static final String SERIALIZED_NAME_CLOCK_TENTHS = "clockTenths";
  @SerializedName(SERIALIZED_NAME_CLOCK_TENTHS)
  private Integer clockTenths;

  public static final String SERIALIZED_NAME_CLOCK_BAR = "clockBar";
  @SerializedName(SERIALIZED_NAME_CLOCK_BAR)
  private Boolean clockBar;

  public static final String SERIALIZED_NAME_CLOCK_SOUND = "clockSound";
  @SerializedName(SERIALIZED_NAME_CLOCK_SOUND)
  private Boolean clockSound;

  public static final String SERIALIZED_NAME_PREMOVE = "premove";
  @SerializedName(SERIALIZED_NAME_PREMOVE)
  private Boolean premove;

  public static final String SERIALIZED_NAME_ANIMATION = "animation";
  @SerializedName(SERIALIZED_NAME_ANIMATION)
  private Integer animation;

  public static final String SERIALIZED_NAME_CAPTURED = "captured";
  @SerializedName(SERIALIZED_NAME_CAPTURED)
  private Boolean captured;

  public static final String SERIALIZED_NAME_FOLLOW = "follow";
  @SerializedName(SERIALIZED_NAME_FOLLOW)
  private Boolean follow;

  public static final String SERIALIZED_NAME_HIGHLIGHT = "highlight";
  @SerializedName(SERIALIZED_NAME_HIGHLIGHT)
  private Boolean highlight;

  public static final String SERIALIZED_NAME_DESTINATION = "destination";
  @SerializedName(SERIALIZED_NAME_DESTINATION)
  private Boolean destination;

  public static final String SERIALIZED_NAME_COORDS = "coords";
  @SerializedName(SERIALIZED_NAME_COORDS)
  private Integer coords;

  public static final String SERIALIZED_NAME_REPLAY = "replay";
  @SerializedName(SERIALIZED_NAME_REPLAY)
  private Integer replay;

  public static final String SERIALIZED_NAME_CHALLENGE = "challenge";
  @SerializedName(SERIALIZED_NAME_CHALLENGE)
  private Integer challenge;

  public static final String SERIALIZED_NAME_MESSAGE = "message";
  @SerializedName(SERIALIZED_NAME_MESSAGE)
  private Integer message;

  public static final String SERIALIZED_NAME_COORD_COLOR = "coordColor";
  @SerializedName(SERIALIZED_NAME_COORD_COLOR)
  private Integer coordColor;

  public static final String SERIALIZED_NAME_SUBMIT_MOVE = "submitMove";
  @SerializedName(SERIALIZED_NAME_SUBMIT_MOVE)
  private Integer submitMove;

  public static final String SERIALIZED_NAME_CONFIRM_RESIGN = "confirmResign";
  @SerializedName(SERIALIZED_NAME_CONFIRM_RESIGN)
  private Integer confirmResign;

  public static final String SERIALIZED_NAME_INSIGHT_SHARE = "insightShare";
  @SerializedName(SERIALIZED_NAME_INSIGHT_SHARE)
  private Integer insightShare;

  public static final String SERIALIZED_NAME_KEYBOARD_MOVE = "keyboardMove";
  @SerializedName(SERIALIZED_NAME_KEYBOARD_MOVE)
  private Integer keyboardMove;

  public static final String SERIALIZED_NAME_ZEN = "zen";
  @SerializedName(SERIALIZED_NAME_ZEN)
  private Integer zen;

  public static final String SERIALIZED_NAME_MOVE_EVENT = "moveEvent";
  @SerializedName(SERIALIZED_NAME_MOVE_EVENT)
  private Integer moveEvent;

  public static final String SERIALIZED_NAME_ROOK_CASTLE = "rookCastle";
  @SerializedName(SERIALIZED_NAME_ROOK_CASTLE)
  private Integer rookCastle;


  public UserPreferences dark(Boolean dark) {
    
    this.dark = dark;
    return this;
  }

   /**
   * Get dark
   * @return dark
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getDark() {
    return dark;
  }


  public void setDark(Boolean dark) {
    this.dark = dark;
  }


  public UserPreferences transp(Boolean transp) {
    
    this.transp = transp;
    return this;
  }

   /**
   * Get transp
   * @return transp
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getTransp() {
    return transp;
  }


  public void setTransp(Boolean transp) {
    this.transp = transp;
  }


  public UserPreferences bgImg(URI bgImg) {
    
    this.bgImg = bgImg;
    return this;
  }

   /**
   * Get bgImg
   * @return bgImg
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public URI getBgImg() {
    return bgImg;
  }


  public void setBgImg(URI bgImg) {
    this.bgImg = bgImg;
  }


  public UserPreferences is3d(Boolean is3d) {
    
    this.is3d = is3d;
    return this;
  }

   /**
   * Get is3d
   * @return is3d
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false", value = "")

  public Boolean getIs3d() {
    return is3d;
  }


  public void setIs3d(Boolean is3d) {
    this.is3d = is3d;
  }


  public UserPreferences theme(ThemeEnum theme) {
    
    this.theme = theme;
    return this;
  }

   /**
   * Get theme
   * @return theme
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ThemeEnum getTheme() {
    return theme;
  }


  public void setTheme(ThemeEnum theme) {
    this.theme = theme;
  }


  public UserPreferences pieceSet(PieceSetEnum pieceSet) {
    
    this.pieceSet = pieceSet;
    return this;
  }

   /**
   * Get pieceSet
   * @return pieceSet
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public PieceSetEnum getPieceSet() {
    return pieceSet;
  }


  public void setPieceSet(PieceSetEnum pieceSet) {
    this.pieceSet = pieceSet;
  }


  public UserPreferences theme3d(Theme3dEnum theme3d) {
    
    this.theme3d = theme3d;
    return this;
  }

   /**
   * Get theme3d
   * @return theme3d
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public Theme3dEnum getTheme3d() {
    return theme3d;
  }


  public void setTheme3d(Theme3dEnum theme3d) {
    this.theme3d = theme3d;
  }


  public UserPreferences pieceSet3d(PieceSet3dEnum pieceSet3d) {
    
    this.pieceSet3d = pieceSet3d;
    return this;
  }

   /**
   * Get pieceSet3d
   * @return pieceSet3d
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public PieceSet3dEnum getPieceSet3d() {
    return pieceSet3d;
  }


  public void setPieceSet3d(PieceSet3dEnum pieceSet3d) {
    this.pieceSet3d = pieceSet3d;
  }


  public UserPreferences soundSet(SoundSetEnum soundSet) {
    
    this.soundSet = soundSet;
    return this;
  }

   /**
   * Get soundSet
   * @return soundSet
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public SoundSetEnum getSoundSet() {
    return soundSet;
  }


  public void setSoundSet(SoundSetEnum soundSet) {
    this.soundSet = soundSet;
  }


  public UserPreferences blindfold(Integer blindfold) {
    
    this.blindfold = blindfold;
    return this;
  }

   /**
   * Get blindfold
   * @return blindfold
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")

  public Integer getBlindfold() {
    return blindfold;
  }


  public void setBlindfold(Integer blindfold) {
    this.blindfold = blindfold;
  }


  public UserPreferences autoQueen(Integer autoQueen) {
    
    this.autoQueen = autoQueen;
    return this;
  }

   /**
   * Get autoQueen
   * @return autoQueen
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getAutoQueen() {
    return autoQueen;
  }


  public void setAutoQueen(Integer autoQueen) {
    this.autoQueen = autoQueen;
  }


  public UserPreferences autoThreefold(Integer autoThreefold) {
    
    this.autoThreefold = autoThreefold;
    return this;
  }

   /**
   * Get autoThreefold
   * @return autoThreefold
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getAutoThreefold() {
    return autoThreefold;
  }


  public void setAutoThreefold(Integer autoThreefold) {
    this.autoThreefold = autoThreefold;
  }


  public UserPreferences takeback(Integer takeback) {
    
    this.takeback = takeback;
    return this;
  }

   /**
   * Get takeback
   * @return takeback
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "")

  public Integer getTakeback() {
    return takeback;
  }


  public void setTakeback(Integer takeback) {
    this.takeback = takeback;
  }


  public UserPreferences moretime(Integer moretime) {
    
    this.moretime = moretime;
    return this;
  }

   /**
   * Get moretime
   * @return moretime
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "")

  public Integer getMoretime() {
    return moretime;
  }


  public void setMoretime(Integer moretime) {
    this.moretime = moretime;
  }


  public UserPreferences clockTenths(Integer clockTenths) {
    
    this.clockTenths = clockTenths;
    return this;
  }

   /**
   * Get clockTenths
   * @return clockTenths
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1", value = "")

  public Integer getClockTenths() {
    return clockTenths;
  }


  public void setClockTenths(Integer clockTenths) {
    this.clockTenths = clockTenths;
  }


  public UserPreferences clockBar(Boolean clockBar) {
    
    this.clockBar = clockBar;
    return this;
  }

   /**
   * Get clockBar
   * @return clockBar
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getClockBar() {
    return clockBar;
  }


  public void setClockBar(Boolean clockBar) {
    this.clockBar = clockBar;
  }


  public UserPreferences clockSound(Boolean clockSound) {
    
    this.clockSound = clockSound;
    return this;
  }

   /**
   * Get clockSound
   * @return clockSound
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getClockSound() {
    return clockSound;
  }


  public void setClockSound(Boolean clockSound) {
    this.clockSound = clockSound;
  }


  public UserPreferences premove(Boolean premove) {
    
    this.premove = premove;
    return this;
  }

   /**
   * Get premove
   * @return premove
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getPremove() {
    return premove;
  }


  public void setPremove(Boolean premove) {
    this.premove = premove;
  }


  public UserPreferences animation(Integer animation) {
    
    this.animation = animation;
    return this;
  }

   /**
   * Get animation
   * @return animation
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getAnimation() {
    return animation;
  }


  public void setAnimation(Integer animation) {
    this.animation = animation;
  }


  public UserPreferences captured(Boolean captured) {
    
    this.captured = captured;
    return this;
  }

   /**
   * Get captured
   * @return captured
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getCaptured() {
    return captured;
  }


  public void setCaptured(Boolean captured) {
    this.captured = captured;
  }


  public UserPreferences follow(Boolean follow) {
    
    this.follow = follow;
    return this;
  }

   /**
   * Get follow
   * @return follow
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getFollow() {
    return follow;
  }


  public void setFollow(Boolean follow) {
    this.follow = follow;
  }


  public UserPreferences highlight(Boolean highlight) {
    
    this.highlight = highlight;
    return this;
  }

   /**
   * Get highlight
   * @return highlight
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getHighlight() {
    return highlight;
  }


  public void setHighlight(Boolean highlight) {
    this.highlight = highlight;
  }


  public UserPreferences destination(Boolean destination) {
    
    this.destination = destination;
    return this;
  }

   /**
   * Get destination
   * @return destination
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "")

  public Boolean getDestination() {
    return destination;
  }


  public void setDestination(Boolean destination) {
    this.destination = destination;
  }


  public UserPreferences coords(Integer coords) {
    
    this.coords = coords;
    return this;
  }

   /**
   * Get coords
   * @return coords
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getCoords() {
    return coords;
  }


  public void setCoords(Integer coords) {
    this.coords = coords;
  }


  public UserPreferences replay(Integer replay) {
    
    this.replay = replay;
    return this;
  }

   /**
   * Get replay
   * @return replay
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getReplay() {
    return replay;
  }


  public void setReplay(Integer replay) {
    this.replay = replay;
  }


  public UserPreferences challenge(Integer challenge) {
    
    this.challenge = challenge;
    return this;
  }

   /**
   * Get challenge
   * @return challenge
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4", value = "")

  public Integer getChallenge() {
    return challenge;
  }


  public void setChallenge(Integer challenge) {
    this.challenge = challenge;
  }


  public UserPreferences message(Integer message) {
    
    this.message = message;
    return this;
  }

   /**
   * Get message
   * @return message
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "")

  public Integer getMessage() {
    return message;
  }


  public void setMessage(Integer message) {
    this.message = message;
  }


  public UserPreferences coordColor(Integer coordColor) {
    
    this.coordColor = coordColor;
    return this;
  }

   /**
   * Get coordColor
   * @return coordColor
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getCoordColor() {
    return coordColor;
  }


  public void setCoordColor(Integer coordColor) {
    this.coordColor = coordColor;
  }


  public UserPreferences submitMove(Integer submitMove) {
    
    this.submitMove = submitMove;
    return this;
  }

   /**
   * Get submitMove
   * @return submitMove
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "4", value = "")

  public Integer getSubmitMove() {
    return submitMove;
  }


  public void setSubmitMove(Integer submitMove) {
    this.submitMove = submitMove;
  }


  public UserPreferences confirmResign(Integer confirmResign) {
    
    this.confirmResign = confirmResign;
    return this;
  }

   /**
   * Get confirmResign
   * @return confirmResign
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1", value = "")

  public Integer getConfirmResign() {
    return confirmResign;
  }


  public void setConfirmResign(Integer confirmResign) {
    this.confirmResign = confirmResign;
  }


  public UserPreferences insightShare(Integer insightShare) {
    
    this.insightShare = insightShare;
    return this;
  }

   /**
   * Get insightShare
   * @return insightShare
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1", value = "")

  public Integer getInsightShare() {
    return insightShare;
  }


  public void setInsightShare(Integer insightShare) {
    this.insightShare = insightShare;
  }


  public UserPreferences keyboardMove(Integer keyboardMove) {
    
    this.keyboardMove = keyboardMove;
    return this;
  }

   /**
   * Get keyboardMove
   * @return keyboardMove
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")

  public Integer getKeyboardMove() {
    return keyboardMove;
  }


  public void setKeyboardMove(Integer keyboardMove) {
    this.keyboardMove = keyboardMove;
  }


  public UserPreferences zen(Integer zen) {
    
    this.zen = zen;
    return this;
  }

   /**
   * Get zen
   * @return zen
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")

  public Integer getZen() {
    return zen;
  }


  public void setZen(Integer zen) {
    this.zen = zen;
  }


  public UserPreferences moveEvent(Integer moveEvent) {
    
    this.moveEvent = moveEvent;
    return this;
  }

   /**
   * Get moveEvent
   * @return moveEvent
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2", value = "")

  public Integer getMoveEvent() {
    return moveEvent;
  }


  public void setMoveEvent(Integer moveEvent) {
    this.moveEvent = moveEvent;
  }


  public UserPreferences rookCastle(Integer rookCastle) {
    
    this.rookCastle = rookCastle;
    return this;
  }

   /**
   * Get rookCastle
   * @return rookCastle
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1", value = "")

  public Integer getRookCastle() {
    return rookCastle;
  }


  public void setRookCastle(Integer rookCastle) {
    this.rookCastle = rookCastle;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserPreferences userPreferences = (UserPreferences) o;
    return Objects.equals(this.dark, userPreferences.dark) &&
        Objects.equals(this.transp, userPreferences.transp) &&
        Objects.equals(this.bgImg, userPreferences.bgImg) &&
        Objects.equals(this.is3d, userPreferences.is3d) &&
        Objects.equals(this.theme, userPreferences.theme) &&
        Objects.equals(this.pieceSet, userPreferences.pieceSet) &&
        Objects.equals(this.theme3d, userPreferences.theme3d) &&
        Objects.equals(this.pieceSet3d, userPreferences.pieceSet3d) &&
        Objects.equals(this.soundSet, userPreferences.soundSet) &&
        Objects.equals(this.blindfold, userPreferences.blindfold) &&
        Objects.equals(this.autoQueen, userPreferences.autoQueen) &&
        Objects.equals(this.autoThreefold, userPreferences.autoThreefold) &&
        Objects.equals(this.takeback, userPreferences.takeback) &&
        Objects.equals(this.moretime, userPreferences.moretime) &&
        Objects.equals(this.clockTenths, userPreferences.clockTenths) &&
        Objects.equals(this.clockBar, userPreferences.clockBar) &&
        Objects.equals(this.clockSound, userPreferences.clockSound) &&
        Objects.equals(this.premove, userPreferences.premove) &&
        Objects.equals(this.animation, userPreferences.animation) &&
        Objects.equals(this.captured, userPreferences.captured) &&
        Objects.equals(this.follow, userPreferences.follow) &&
        Objects.equals(this.highlight, userPreferences.highlight) &&
        Objects.equals(this.destination, userPreferences.destination) &&
        Objects.equals(this.coords, userPreferences.coords) &&
        Objects.equals(this.replay, userPreferences.replay) &&
        Objects.equals(this.challenge, userPreferences.challenge) &&
        Objects.equals(this.message, userPreferences.message) &&
        Objects.equals(this.coordColor, userPreferences.coordColor) &&
        Objects.equals(this.submitMove, userPreferences.submitMove) &&
        Objects.equals(this.confirmResign, userPreferences.confirmResign) &&
        Objects.equals(this.insightShare, userPreferences.insightShare) &&
        Objects.equals(this.keyboardMove, userPreferences.keyboardMove) &&
        Objects.equals(this.zen, userPreferences.zen) &&
        Objects.equals(this.moveEvent, userPreferences.moveEvent) &&
        Objects.equals(this.rookCastle, userPreferences.rookCastle);
  }

  @Override
  public int hashCode() {
    return Objects.hash(dark, transp, bgImg, is3d, theme, pieceSet, theme3d, pieceSet3d, soundSet, blindfold, autoQueen, autoThreefold, takeback, moretime, clockTenths, clockBar, clockSound, premove, animation, captured, follow, highlight, destination, coords, replay, challenge, message, coordColor, submitMove, confirmResign, insightShare, keyboardMove, zen, moveEvent, rookCastle);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserPreferences {\n");
    sb.append("    dark: ").append(toIndentedString(dark)).append("\n");
    sb.append("    transp: ").append(toIndentedString(transp)).append("\n");
    sb.append("    bgImg: ").append(toIndentedString(bgImg)).append("\n");
    sb.append("    is3d: ").append(toIndentedString(is3d)).append("\n");
    sb.append("    theme: ").append(toIndentedString(theme)).append("\n");
    sb.append("    pieceSet: ").append(toIndentedString(pieceSet)).append("\n");
    sb.append("    theme3d: ").append(toIndentedString(theme3d)).append("\n");
    sb.append("    pieceSet3d: ").append(toIndentedString(pieceSet3d)).append("\n");
    sb.append("    soundSet: ").append(toIndentedString(soundSet)).append("\n");
    sb.append("    blindfold: ").append(toIndentedString(blindfold)).append("\n");
    sb.append("    autoQueen: ").append(toIndentedString(autoQueen)).append("\n");
    sb.append("    autoThreefold: ").append(toIndentedString(autoThreefold)).append("\n");
    sb.append("    takeback: ").append(toIndentedString(takeback)).append("\n");
    sb.append("    moretime: ").append(toIndentedString(moretime)).append("\n");
    sb.append("    clockTenths: ").append(toIndentedString(clockTenths)).append("\n");
    sb.append("    clockBar: ").append(toIndentedString(clockBar)).append("\n");
    sb.append("    clockSound: ").append(toIndentedString(clockSound)).append("\n");
    sb.append("    premove: ").append(toIndentedString(premove)).append("\n");
    sb.append("    animation: ").append(toIndentedString(animation)).append("\n");
    sb.append("    captured: ").append(toIndentedString(captured)).append("\n");
    sb.append("    follow: ").append(toIndentedString(follow)).append("\n");
    sb.append("    highlight: ").append(toIndentedString(highlight)).append("\n");
    sb.append("    destination: ").append(toIndentedString(destination)).append("\n");
    sb.append("    coords: ").append(toIndentedString(coords)).append("\n");
    sb.append("    replay: ").append(toIndentedString(replay)).append("\n");
    sb.append("    challenge: ").append(toIndentedString(challenge)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    coordColor: ").append(toIndentedString(coordColor)).append("\n");
    sb.append("    submitMove: ").append(toIndentedString(submitMove)).append("\n");
    sb.append("    confirmResign: ").append(toIndentedString(confirmResign)).append("\n");
    sb.append("    insightShare: ").append(toIndentedString(insightShare)).append("\n");
    sb.append("    keyboardMove: ").append(toIndentedString(keyboardMove)).append("\n");
    sb.append("    zen: ").append(toIndentedString(zen)).append("\n");
    sb.append("    moveEvent: ").append(toIndentedString(moveEvent)).append("\n");
    sb.append("    rookCastle: ").append(toIndentedString(rookCastle)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

