/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.UserExtended;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for AccountApi
 */
@Ignore
public class AccountApiTest {

    private final AccountApi api = new AccountApi();

    
    /**
     * Get my preferences
     *
     * Read the preferences of the logged in user.  - &lt;https://lichess.org/account/preferences/game-display&gt; - &lt;https://github.com/ornicar/lila/blob/master/modules/pref/src/main/Pref.scala&gt; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void accountTest() throws ApiException {
                Object response = api.account();
        // TODO: test validations
    }
    
    /**
     * Get my email address
     *
     * Read the email address of the logged in user. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void accountEmailTest() throws ApiException {
                Object response = api.accountEmail();
        // TODO: test validations
    }
    
    /**
     * Get my kid mode status
     *
     * Read the kid mode status of the logged in user.  - &lt;https://lichess.org/account/kid&gt; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void accountKidTest() throws ApiException {
                Object response = api.accountKid();
        // TODO: test validations
    }
    
    /**
     * Set my kid mode status
     *
     * Set the kid mode status of the logged in user.  - &lt;https://lichess.org/account/kid&gt; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void accountKidPostTest() throws ApiException {
        Boolean v = null;
                Ok response = api.accountKidPost(v);
        // TODO: test validations
    }
    
    /**
     * Get my profile
     *
     * Public informations about the logged in user. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void accountMeTest() throws ApiException {
                UserExtended response = api.accountMe();
        // TODO: test validations
    }
    
}
