/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.ArenaTournaments;
import java.math.BigDecimal;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.VariantKey;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ArenaTournamentsApi
 */
@Ignore
public class ArenaTournamentsApiTest {

    private final ArenaTournamentsApi api = new ArenaTournamentsApi();

    
    /**
     * Get team Arena tournaments
     *
     * Get all Arena tournaments relevant to a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTeamArenaTest() throws ApiException {
        String teamId = null;
        Integer max = null;
                List<Object> response = api.apiTeamArena(teamId, max);
        // TODO: test validations
    }
    
    /**
     * Get current tournaments
     *
     * Get recently finished, ongoing, and upcoming tournaments.  This API is used to display the [Lichess tournament schedule](https://lichess.org/tournament). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentTest() throws ApiException {
                ArenaTournaments response = api.apiTournament();
        // TODO: test validations
    }
    
    /**
     * Join an Arena tournament
     *
     * Join an Arena tournament, possibly with a password and/or a team. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentJoinTest() throws ApiException {
        String id = null;
        String password = null;
        String team = null;
                Ok response = api.apiTournamentJoin(id, password, team);
        // TODO: test validations
    }
    
    /**
     * Create a new Arena tournament
     *
     * Create a public or private Arena tournament.  This endpoint mirrors the form on &lt;https://lichess.org/tournament/new&gt;.  You can create up to 12 public tournaments per day, or 24 private tournaments.  A team battle can be created by specifying the &#x60;teambBattleByTeam&#x60; argument. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentPostTest() throws ApiException {
        BigDecimal clockTime = null;
        Integer clockIncrement = null;
        Integer minutes = null;
        String name = null;
        Integer waitMinutes = null;
        Integer startDate = null;
        VariantKey variant = null;
        Boolean rated = null;
        String position = null;
        Boolean berserkable = null;
        Boolean streakable = null;
        Boolean hasChat = null;
        String description = null;
        String password = null;
        String teambBattleByTeam = null;
        String conditionsTeamMemberTeamId = null;
        Integer conditionsMinRatingRating = null;
        Integer conditionsMaxRatingRating = null;
        Integer conditionsNbRatedGameNb = null;
                Object response = api.apiTournamentPost(clockTime, clockIncrement, minutes, name, waitMinutes, startDate, variant, rated, position, berserkable, streakable, hasChat, description, password, teambBattleByTeam, conditionsTeamMemberTeamId, conditionsMinRatingRating, conditionsMaxRatingRating, conditionsNbRatedGameNb);
        // TODO: test validations
    }
    
    /**
     * Update a team battle
     *
     * Set the teams and number of leaders of a team battle.  To update the other attributes of a team battle, use the [tournament update endpoint](#operation/apiTournamentUpdate). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentTeamBattlePostTest() throws ApiException {
        String id = null;
        String teams = null;
        Integer nbLeaders = null;
                Object response = api.apiTournamentTeamBattlePost(id, teams, nbLeaders);
        // TODO: test validations
    }
    
    /**
     * Terminate an Arena tournament
     *
     * Terminate an Arena tournament 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentTerminateTest() throws ApiException {
        String id = null;
                Ok response = api.apiTournamentTerminate(id);
        // TODO: test validations
    }
    
    /**
     * Update an Arena tournament
     *
     * Update an Arena tournament.  Be mindful not to make important changes to ongoing tournaments.  Can be used to update a team battle. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentUpdateTest() throws ApiException {
        String id = null;
        BigDecimal clockTime = null;
        Integer clockIncrement = null;
        Integer minutes = null;
        String name = null;
        Integer waitMinutes = null;
        Integer startDate = null;
        VariantKey variant = null;
        Boolean rated = null;
        String position = null;
        Boolean berserkable = null;
        Boolean streakable = null;
        Boolean hasChat = null;
        String description = null;
        String password = null;
        Integer conditionsMinRatingRating = null;
        Integer conditionsMaxRatingRating = null;
        Integer conditionsNbRatedGameNb = null;
                Object response = api.apiTournamentUpdate(id, clockTime, clockIncrement, minutes, name, waitMinutes, startDate, variant, rated, position, berserkable, streakable, hasChat, description, password, conditionsMinRatingRating, conditionsMaxRatingRating, conditionsNbRatedGameNb);
        // TODO: test validations
    }
    
    /**
     * Pause of leave an Arena tournament
     *
     * Leave a future Arena tournament, or take a break on an ongoing Arena tournament. It&#39;s possible to join again later. Points and streaks are preserved. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTournamentWithdrawTest() throws ApiException {
        String id = null;
                Ok response = api.apiTournamentWithdraw(id);
        // TODO: test validations
    }
    
    /**
     * Get tournaments created by a user
     *
     * Get all tournaments created by a given user.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUserNameTournamentCreatedTest() throws ApiException {
        String username = null;
        Integer status = null;
                Object response = api.apiUserNameTournamentCreated(username, status);
        // TODO: test validations
    }
    
    /**
     * Export games of an Arena tournament
     *
     * Download games of a tournament in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Games are sorted by reverse chronological order (most recent first) 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void gamesByTournamentTest() throws ApiException {
        String id = null;
        String player = null;
        Boolean moves = null;
        Boolean pgnInJson = null;
        Boolean tags = null;
        Boolean clocks = null;
        Boolean evals = null;
        Boolean opening = null;
                Object response = api.gamesByTournament(id, player, moves, pgnInJson, tags, clocks, evals, opening);
        // TODO: test validations
    }
    
    /**
     * Get results of an Arena tournament
     *
     * Players of an Arena tournament, with their score and performance, sorted by rank (best first).  **Players are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON)**, i.e. one JSON object per line.  If called on an ongoing tournament, results can be inconsistent due to ranking changes while the players are being streamed. Use on finished tournaments for guaranteed consistency. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void resultsByTournamentTest() throws ApiException {
        String id = null;
        Integer nb = null;
                Object response = api.resultsByTournament(id, nb);
        // TODO: test validations
    }
    
    /**
     * Get team standing of a team battle
     *
     * Teams of a team battle tournament, with top players, sorted by rank (best first). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamsByTournamentTest() throws ApiException {
        String id = null;
                Object response = api.teamsByTournament(id);
        // TODO: test validations
    }
    
    /**
     * Get info about an Arena tournament
     *
     * Get detailed info about recently finished, current, or upcoming tournament&#39;s duels, player standings, and other info. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void tournamentTest() throws ApiException {
        String id = null;
        BigDecimal page = null;
                Object response = api.tournament(id, page);
        // TODO: test validations
    }
    
}
