/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.ApiStreamEvent;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.GameStreamEvent;
import org.openapitools.client.model.NotFound;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.User;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for BotApi
 */
@Ignore
public class BotApiTest {

    private final BotApi api = new BotApi();

    
    /**
     * Get online bots
     *
     * Stream the [online bot users](https://lichess.org/player/bots), as [ndjson](#section/Introduction/Streaming-with-ND-JSON). Throttled to 50 bot users per second.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiBotOnlineTest() throws ApiException {
        Integer nb = null;
                User response = api.apiBotOnline(nb);
        // TODO: test validations
    }
    
    /**
     * Stream incoming events
     *
     *    Stream the events reaching a lichess user in real time as [ndjson](#section/Introduction/Streaming-with-ND-JSON).    Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameStart&#x60; Start of a game   - &#x60;gameFinish&#x60; Completion of a game   - &#x60;challenge&#x60; A player sends you a challenge   - &#x60;challengeCanceled&#x60; A player cancels their challenge to you   - &#x60;challengeDeclined&#x60; The opponent declines your challenge     When the stream opens, all current challenges and games are sent.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiStreamEventTest() throws ApiException {
                ApiStreamEvent response = api.apiStreamEvent();
        // TODO: test validations
    }
    
    /**
     * Upgrade to Bot account
     *
     * Upgrade a lichess player account into a Bot account. Only Bot accounts can use the Bot API.  The account **cannot have played any game** before becoming a Bot account. The upgrade is **irreversible**. The account will only be able to play as a Bot.  To upgrade an account to Bot, use the [official lichess-bot client](https://github.com/careless25/lichess-bot), or follow these steps: - Create an [API access token](https://lichess.org/account/oauth/token/create?scopes[]&#x3D;bot:play) with \&quot;Play bot moves\&quot; permission. - &#x60;curl -d &#39;&#39; https://lichess.org/api/bot/account/upgrade -H \&quot;Authorization: Bearer &lt;yourTokenHere&gt;\&quot;&#x60;  To know if an account has already been upgraded, use the [Get my profile API](#operation/accountMe): the &#x60;title&#x60; field should be set to &#x60;BOT&#x60;. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void botAccountUpgradeTest() throws ApiException {
                Ok response = api.botAccountUpgrade();
        // TODO: test validations
    }
    
    /**
     * Abort a game
     *
     * Abort a game being played with the Bot API. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void botGameAbortTest() throws ApiException {
        String gameId = null;
                Ok response = api.botGameAbort(gameId);
        // TODO: test validations
    }
    
    /**
     * Write in the chat
     *
     * Post a message to the player or spectator chat, in a game being played with the Bot API. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void botGameChatTest() throws ApiException {
        String gameId = null;
        String room = null;
        String text = null;
                Ok response = api.botGameChat(gameId, room, text);
        // TODO: test validations
    }
    
    /**
     * Make a Bot move
     *
     * Make a move in a game being played with the Bot API.  The move can also contain a draw offer/agreement. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void botGameMoveTest() throws ApiException {
        String gameId = null;
        String move = null;
        Boolean offeringDraw = null;
                Ok response = api.botGameMove(gameId, move, offeringDraw);
        // TODO: test validations
    }
    
    /**
     * Resign a game
     *
     * Resign a game being played with the Bot API. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void botGameResignTest() throws ApiException {
        String gameId = null;
                Ok response = api.botGameResign(gameId);
        // TODO: test validations
    }
    
    /**
     * Stream Bot game state
     *
     *  Stream the state of a game being played with the Bot API, as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  Use this endpoint to get updates about the game in real-time, with a single request.  Each line is a JSON object containing a &#x60;type&#x60; field. Possible values are:   - &#x60;gameFull&#x60; Full game data. All values are immutable, except for the &#x60;state&#x60; field.   - &#x60;gameState&#x60; Current state of the game. Immutable values not included.   - &#x60;chatLine&#x60; Chat message sent by a user (or the bot itself) in the &#x60;room&#x60; \&quot;player\&quot; or \&quot;spectator\&quot;.    The first line is always of type &#x60;gameFull&#x60;.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void botGameStreamTest() throws ApiException {
        String gameId = null;
                GameStreamEvent response = api.botGameStream(gameId);
        // TODO: test validations
    }
    
}
