/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.Ok;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for BroadcastsApi
 */
@Ignore
public class BroadcastsApiTest {

    private final BroadcastsApi api = new BroadcastsApi();

    
    /**
     * Export all rounds as PGN
     *
     * Download all games of all rounds of a broadcast in PGN format.  You may want to [download only the games of a single round](#operation/broadcastRoundPgn) instead. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastAllRoundsPgnTest() throws ApiException {
        String broadcastTournamentId = null;
                Object response = api.broadcastAllRoundsPgn(broadcastTournamentId);
        // TODO: test validations
    }
    
    /**
     * Get official broadcasts
     *
     * Get all incoming, ongoing, and finished official broadcasts. The broadcasts are sorted by start date, most recent first.  Broadcasts are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastIndexTest() throws ApiException {
        Integer nb = null;
                List<Object> response = api.broadcastIndex(nb);
        // TODO: test validations
    }
    
    /**
     * Push PGN to your broadcast round
     *
     * Update your broadcast with new PGN. Only for broadcast without a source URL. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastPushTest() throws ApiException {
        String broadcastRoundId = null;
        String body = null;
                List<Ok> response = api.broadcastPush(broadcastRoundId, body);
        // TODO: test validations
    }
    
    /**
     * Create a broadcast round
     *
     * Create a new broadcast round to relay external games. This endpoint accepts the same form data as the web form. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastRoundCreateTest() throws ApiException {
        String broadcastTournamentId = null;
        String name = null;
        String syncUrl = null;
        Integer startsAt = null;
                Object response = api.broadcastRoundCreate(broadcastTournamentId, name, syncUrl, startsAt);
        // TODO: test validations
    }
    
    /**
     * Get your broadcast round
     *
     * Get information about a broadcast round that you created. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastRoundGetTest() throws ApiException {
        String broadcastTournamentSlug = null;
        String broadcastRoundSlug = null;
        String broadcastRoundId = null;
                List<Object> response = api.broadcastRoundGet(broadcastTournamentSlug, broadcastRoundSlug, broadcastRoundId);
        // TODO: test validations
    }
    
    /**
     * Export one round as PGN
     *
     * Download all games of a single round of a broadcast tournament in PGN format.  You *could* poll this endpoint to get updates about a tournament, but it would be slow, and very inneficient.  Instead, consider [streaming the tournament](#operation/broadcastStreamRoundPgn) to get a new PGN every time a game is updated, in real-time. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastRoundPgnTest() throws ApiException {
        String broadcastRoundId = null;
                Object response = api.broadcastRoundPgn(broadcastRoundId);
        // TODO: test validations
    }
    
    /**
     * Update your broadcast round
     *
     * Update information about a broadcast round that you created. This endpoint accepts the same form data as the web form. All fields must be populated with data. Missing fields will override the broadcast with empty data. For instance, if you omit &#x60;startDate&#x60;, then any pre-existing start date will be removed. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastRoundUpdateTest() throws ApiException {
        String broadcastRoundId = null;
        String name = null;
        String syncUrl = null;
        Integer startsAt = null;
                Ok response = api.broadcastRoundUpdate(broadcastRoundId, name, syncUrl, startsAt);
        // TODO: test validations
    }
    
    /**
     * Stream an ongoing broadcast tournament as PGN
     *
     * This streaming endpoint first sends all games of a broadcast tournament in PGN format.  Then, it waits for new moves to be played. As soon as it happens, the entire PGN of the game is sent to the stream.  The stream will also send PGNs when games are added to the tournament.  This is the best way to get updates about an ongoing tournament. Streaming means no polling, and no pollings means no latency, and minimum impact on the server. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastStreamRoundPgnTest() throws ApiException {
        String broadcastRoundId = null;
                Object response = api.broadcastStreamRoundPgn(broadcastRoundId);
        // TODO: test validations
    }
    
    /**
     * Create a broadcast tournament
     *
     * Create a new broadcast tournament to relay external games. This endpoint accepts the same form data as the [web form](https://lichess.org/broadcast/new). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastTourCreateTest() throws ApiException {
        String name = null;
        String description = null;
        String markup = null;
        Boolean official = null;
                Object response = api.broadcastTourCreate(name, description, markup, official);
        // TODO: test validations
    }
    
    /**
     * Get your broadcast tournament
     *
     * Get information about a broadcast tournament that you created. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastTourGetTest() throws ApiException {
        String slug = null;
        String broadcastTournamentId = null;
                List<Object> response = api.broadcastTourGet(slug, broadcastTournamentId);
        // TODO: test validations
    }
    
    /**
     * Update your broadcast tournament
     *
     * Update information about a broadcast tournament that you created. This endpoint accepts the same form data as the web form. All fields must be populated with data. Missing fields will override the broadcast with empty data. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void broadcastTourUpdateTest() throws ApiException {
        String broadcastTournamentId = null;
        String name = null;
        String description = null;
        String markup = null;
        Boolean official = null;
                Ok response = api.broadcastTourUpdate(broadcastTournamentId, name, description, markup, official);
        // TODO: test validations
    }
    
}
