/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import java.math.BigDecimal;
import org.openapitools.client.model.ChallengeJson;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.GameJson;
import org.openapitools.client.model.InlineResponse2003;
import org.openapitools.client.model.NotFound;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.VariantKey;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ChallengesApi
 */
@Ignore
public class ChallengesApiTest {

    private final ChallengesApi api = new ChallengesApi();

    
    /**
     * Admin challenge tokens
     *
     * **For administrators only. You are not allowed to use this endpoint.**  Create and obtain &#x60;challenge:write&#x60; tokens for multiple users.  If a similar token already exists for a user, it is reused. This endpoint is idempotent. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void adminChallengeTokensTest() throws ApiException {
        String users = null;
        String description = null;
                api.adminChallengeTokens(users, description);
        // TODO: test validations
    }
    
    /**
     * Accept a challenge
     *
     * Accept an incoming challenge.  You should receive a &#x60;gameStart&#x60; event on the [incoming events stream](#operation/apiStreamEvent). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeAcceptTest() throws ApiException {
        String challengeId = null;
                Ok response = api.challengeAccept(challengeId);
        // TODO: test validations
    }
    
    /**
     * Challenge the AI
     *
     * Start a game with Lichess AI.  You will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeAiTest() throws ApiException {
        BigDecimal level = null;
        BigDecimal clockLimit = null;
        Integer clockIncrement = null;
        Integer days = null;
        String color = null;
        VariantKey variant = null;
        String fen = null;
                GameJson response = api.challengeAi(level, clockLimit, clockIncrement, days, color, variant, fen);
        // TODO: test validations
    }
    
    /**
     * Cancel a challenge
     *
     * Cancel a challenge you sent, or aborts the game if the challenge was accepted, but the game was not yet played. Note that the ID of a game is the same as the ID of the challenge that created it. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeCancelTest() throws ApiException {
        String challengeId = null;
        String opponentToken = null;
                Ok response = api.challengeCancel(challengeId, opponentToken);
        // TODO: test validations
    }
    
    /**
     * Create a challenge
     *
     * Challenge someone to play. The targeted player can choose to accept or decline.  If the challenge is accepted, you will be notified on the [event stream](#operation/apiStreamEvent) that a new game has started. The game ID will be the same as the challenge ID.  If you also have an OAuth token with &#x60;challenge:write&#x60; scope for the receiving user, you can make them accept the challenge immediately by setting the &#x60;acceptByToken&#x60; field.  Challenges for realtime games (not correspondence) expire after 20s if not accepted. To prevent that, use the &#x60;keepAliveStream&#x60; flag described below. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeCreateTest() throws ApiException {
        String username = null;
        Boolean rated = null;
        BigDecimal clockLimit = null;
        Integer clockIncrement = null;
        Integer days = null;
        String color = null;
        VariantKey variant = null;
        String fen = null;
        Boolean keepAliveStream = null;
        String acceptByToken = null;
        String message = null;
                ChallengeJson response = api.challengeCreate(username, rated, clockLimit, clockIncrement, days, color, variant, fen, keepAliveStream, acceptByToken, message);
        // TODO: test validations
    }
    
    /**
     * Decline a challenge
     *
     * Decline an incoming challenge. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeDeclineTest() throws ApiException {
        String challengeId = null;
        String reason = null;
                Ok response = api.challengeDecline(challengeId, reason);
        // TODO: test validations
    }
    
    /**
     * List your challenges
     *
     * Get a list of challenges created by or targeted at you. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeListTest() throws ApiException {
                InlineResponse2003 response = api.challengeList();
        // TODO: test validations
    }
    
    /**
     * Open-ended challenge
     *
     * Create a challenge that any 2 players can join.  Share the URL of the challenge. the first 2 players to click it will be paired for a game.  The response body also contains &#x60;whiteUrl&#x60; and &#x60;blackUrl&#x60;. You can control which color each player gets by giving them these URLs, instead of the main challenge URL.  Open challenges expire after 24h.  To directly pair 2 known players, use [this endpoint](#operation/challengeCreate) instead, with the &#x60;acceptByToken&#x60; parameter. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeOpenTest() throws ApiException {
        Boolean rated = null;
        BigDecimal clockLimit = null;
        Integer clockIncrement = null;
        VariantKey variant = null;
        String fen = null;
        String name = null;
                Object response = api.challengeOpen(rated, clockLimit, clockIncrement, variant, fen, name);
        // TODO: test validations
    }
    
    /**
     * Start clocks of a game
     *
     * Start the clocks of a game immediately, even if a player has not yet made a move.  Requires the OAuth tokens of both players with &#x60;challenge:write&#x60; scope.  If the clocks have already started, the call will have no effect. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void challengeStartClocksTest() throws ApiException {
        String gameId = null;
        String token1 = null;
        String token2 = null;
                Ok response = api.challengeStartClocks(gameId, token1, token2);
        // TODO: test validations
    }
    
    /**
     * Add time to the opponent clock
     *
     * Add seconds to the opponent&#39;s clock. Can be used to create games with time odds. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void roundAddTimeTest() throws ApiException {
        String gameId = null;
        String seconds = null;
                Ok response = api.roundAddTime(gameId, seconds);
        // TODO: test validations
    }
    
}
