/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.PerfType;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for GamesApi
 */
@Ignore
public class GamesApiTest {

    private final GamesApi api = new GamesApi();

    
    /**
     * Get my ongoing games
     *
     * Get the ongoing games of the current user. Real-time and correspondence games are included. The most urgent games are listed first. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiAccountPlayingTest() throws ApiException {
        Integer nb = null;
                Object response = api.apiAccountPlaying(nb);
        // TODO: test validations
    }
    
    /**
     * Export games of a user
     *
     * Download all games of any user in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Games are sorted by reverse chronological order (most recent first)  We recommend streaming the response, for it can be very long. &lt;https://lichess.org/@/german11&gt; for instance has more than 320,000 games.  The game stream is throttled, depending on who is making the request:   - Anonymous request: 20 games per second   - [OAuth2 authenticated](#section/Authentication) request: 30 games per second   - Authenticated, downloading your own games: 60 games per second 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiGamesUserTest() throws ApiException {
        String username = null;
        Integer since = null;
        Integer until = null;
        Integer max = null;
        String vs = null;
        Boolean rated = null;
        PerfType perfType = null;
        String color = null;
        Boolean analysed = null;
        Boolean moves = null;
        Boolean pgnInJson = null;
        Boolean tags = null;
        Boolean clocks = null;
        Boolean evals = null;
        Boolean opening = null;
        Boolean ongoing = null;
        Boolean finished = null;
        String players = null;
        String sort = null;
                Object response = api.apiGamesUser(username, since, until, max, vs, rated, perfType, color, analysed, moves, pgnInJson, tags, clocks, evals, opening, ongoing, finished, players, sort);
        // TODO: test validations
    }
    
    /**
     * Export ongoing game of a user
     *
     * Download the ongoing game, or the last game played, of a user. Available in either PGN or JSON format. If the game is ongoing, the 3 last moves are omitted. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUserCurrentGameTest() throws ApiException {
        String username = null;
        Boolean moves = null;
        Boolean pgnInJson = null;
        Boolean tags = null;
        Boolean clocks = null;
        Boolean evals = null;
        Boolean opening = null;
        Boolean literate = null;
        String players = null;
                Object response = api.apiUserCurrentGame(username, moves, pgnInJson, tags, clocks, evals, opening, literate, players);
        // TODO: test validations
    }
    
    /**
     * Import one game
     *
     * Import a game from PGN. See &lt;https://lichess.org/paste&gt;.  Rate limiting: 200 games per hour for OAuth requests, 100 games per hour for anonymous requests.  To broadcast ongoing games, consider [pushing to a broadcast instead](#operation/broadcastPush). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void gameImportTest() throws ApiException {
        String pgn = null;
                Object response = api.gameImport(pgn);
        // TODO: test validations
    }
    
    /**
     * Export one game
     *
     * Download one game in either PGN or JSON format.  Ongoing games have their last 3 moves omitted, after move 5. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void gamePgnTest() throws ApiException {
        String gameId = null;
        Boolean moves = null;
        Boolean pgnInJson = null;
        Boolean tags = null;
        Boolean clocks = null;
        Boolean evals = null;
        Boolean opening = null;
        Boolean literate = null;
        String players = null;
                Object response = api.gamePgn(gameId, moves, pgnInJson, tags, clocks, evals, opening, literate, players);
        // TODO: test validations
    }
    
    /**
     * Stream games of users
     *
     * Stream the games played between a list of users, in real time. Only games where **both players** are part of the list are included.  By default, games are only sent to the stream when they start. To also get all ongoing games at the beginning of the stream, use the &#x60;withCurrentGames&#x60; flag.  Maximum number of users: 300.  Games are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  The method is &#x60;POST&#x60; so a longer list of IDs can be sent in the request body. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void gamesByUsersTest() throws ApiException {
        String body = null;
        Boolean withCurrentGames = null;
                Object response = api.gamesByUsers(body, withCurrentGames);
        // TODO: test validations
    }
    
    /**
     * Export games by IDs
     *
     * Download games by IDs in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format, depending on the request Accept header.  Games are sorted by reverse chronological order (most recent first)  The method is &#x60;POST&#x60; so a longer list of IDs can be sent in the request body.  300 IDs can be submitted.  Ongoing games have their last 3 moves omitted, after move 5. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void gamesExportIdsTest() throws ApiException {
        String body = null;
        Boolean moves = null;
        Boolean pgnInJson = null;
        Boolean tags = null;
        Boolean clocks = null;
        Boolean evals = null;
        Boolean opening = null;
        String players = null;
                Object response = api.gamesExportIds(body, moves, pgnInJson, tags, clocks, evals, opening, players);
        // TODO: test validations
    }
    
    /**
     * Stream moves of a game
     *
     * Stream positions and moves of any ongoing game, in [ndjson](#section/Introduction/Streaming-with-ND-JSON).  A description of the game is sent as a first message. Then a message is sent each time a move is played. Finally a description of the game is sent when it finishes, and the stream is closed.  After move 5, the stream intentionally remains 3 moves behind the game status, as to prevent cheat bots from using this API.  No more than 8 game streams can be opened at the same time from the same IP address. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void streamGameTest() throws ApiException {
        String id = null;
                Object response = api.streamGame(id);
        // TODO: test validations
    }
    
}
