/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import java.math.BigDecimal;
import org.openapitools.client.model.Speed;
import org.openapitools.client.model.VariantKey;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for OpeningExplorerApi
 */
@Ignore
public class OpeningExplorerApiTest {

    private final OpeningExplorerApi api = new OpeningExplorerApi();

    
    /**
     * Lichess games
     *
     * **Endpoint: &lt;https://explorer.lichess.ovh/lichess&gt;**  Games sampled from all Lichess players.  Example: &#x60;curl https://explorer.lichess.ovh/lichess?variant&#x3D;standard&amp;speeds&#x3D;blitz,rapid,classical&amp;ratings&#x3D;2200,2500&amp;fen&#x3D;rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR%20w%20KQkq%20-%200%201&#x60; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void openingExplorerLichessTest() throws ApiException {
        VariantKey variant = null;
        String fen = null;
        String play = null;
        List<Speed> speeds = null;
        List<BigDecimal> ratings = null;
        String since = null;
        String until = null;
        BigDecimal moves = null;
        BigDecimal topGames = null;
        BigDecimal recentGames = null;
                Object response = api.openingExplorerLichess(variant, fen, play, speeds, ratings, since, until, moves, topGames, recentGames);
        // TODO: test validations
    }
    
    /**
     * Masters database
     *
     * **Endpoint: &lt;https://explorer.lichess.ovh/masters&gt;**  Example: &#x60;curl https://explorer.lichess.ovh/masters?play&#x3D;d2d4,d7d5,c2c4,c7c6,c4d5&#x60; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void openingExplorerMasterTest() throws ApiException {
        String fen = null;
        String play = null;
        BigDecimal since = null;
        BigDecimal until = null;
        BigDecimal moves = null;
        BigDecimal topGames = null;
                Object response = api.openingExplorerMaster(fen, play, since, until, moves, topGames);
        // TODO: test validations
    }
    
    /**
     * OTB master game
     *
     * **Endpoint: &#x60;https://explorer.lichess.ovh/masters/pgn/{gameId}&#x60;**  Example: &#x60;curl https://explorer.lichess.ovh/masters/pgn/aAbqI4ey&#x60; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void openingExplorerMasterGameTest() throws ApiException {
        String gameId = null;
                Object response = api.openingExplorerMasterGame(gameId);
        // TODO: test validations
    }
    
    /**
     * Player games
     *
     * **Endpoint: &lt;https://explorer.lichess.ovh/player&gt;**  Games of a Lichess player.  Responds with a stream of newline delimited JSON. Will start indexing on demand, immediately respond with the current results, and stream more updates until indexing is complete. The stream is throttled and deduplicated. Empty lines may be sent to avoid timeouts.  Will index new games at most once per minute, and revisit previously ongoing games at most once every day.  Example: &#x60;curl https://explorer.lichess.ovh/player?player&#x3D;revoof&amp;color&#x3D;white&amp;play&#x3D;d2d4,d7d5&amp;recentGames&#x3D;1&#x60; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void openingExplorerPlayerTest() throws ApiException {
        VariantKey variant = null;
        String fen = null;
        String play = null;
        List<Speed> speeds = null;
        List<String> modes = null;
        String since = null;
        String until = null;
        BigDecimal moves = null;
        BigDecimal recentGames = null;
                Object response = api.openingExplorerPlayer(variant, fen, play, speeds, modes, since, until, moves, recentGames);
        // TODO: test validations
    }
    
}
