/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.PuzzleRoundJson;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for PuzzlesApi
 */
@Ignore
public class PuzzlesApiTest {

    private final PuzzlesApi api = new PuzzlesApi();

    
    /**
     * Get your puzzle activity
     *
     * Download your puzzle activity in [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Puzzle activity is sorted by reverse chronological order (most recent first)  We recommend streaming the response, for it can be very long. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiPuzzleActivityTest() throws ApiException {
        Integer max = null;
                PuzzleRoundJson response = api.apiPuzzleActivity(max);
        // TODO: test validations
    }
    
    /**
     * Get the daily puzzle
     *
     * Get the daily Lichess puzzle in JSON format.  Alternatively, you can [post it in your slack workspace](https://lichess.org/daily-puzzle-slack). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiPuzzleDailyTest() throws ApiException {
                Object response = api.apiPuzzleDaily();
        // TODO: test validations
    }
    
    /**
     * Get your puzzle dashboard
     *
     * Download your [puzzle dashboard](https://lichess.org/training/dashboard/30/dashboard) as JSON.  Also includes all puzzle themes played, with aggregated results.  Allows re-creating the [improvement/strengths](https://lichess.org/training/dashboard/30/improvementAreas) interfaces. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiPuzzleDashboardTest() throws ApiException {
        Integer days = null;
                Object response = api.apiPuzzleDashboard(days);
        // TODO: test validations
    }
    
    /**
     * Get the storm dashboard of a player
     *
     * Download the [storm dashboard](https://lichess.org/storm/dashboard/mrbasso) of any player as JSON.  Contains the aggregated highscores, and the history of storm runs aggregated by days.  Use &#x60;?days&#x3D;0&#x60; if you only care about the highscores. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiStormDashboardTest() throws ApiException {
        String username = null;
        Integer days = null;
                Object response = api.apiStormDashboard(username, days);
        // TODO: test validations
    }
    
}
