/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for StudiesApi
 */
@Ignore
public class StudiesApiTest {

    private final StudiesApi api = new StudiesApi();

    
    /**
     * Export all chapters
     *
     * Download all chapters of a study in PGN format. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void studyAllChaptersPgnTest() throws ApiException {
        String studyId = null;
        Boolean clocks = null;
        Boolean comments = null;
        Boolean variations = null;
                Object response = api.studyAllChaptersPgn(studyId, clocks, comments, variations);
        // TODO: test validations
    }
    
    /**
     * Export one study chapter
     *
     * Download one study chapter in PGN format. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void studyChapterPgnTest() throws ApiException {
        String studyId = null;
        String chapterId = null;
        Boolean clocks = null;
        Boolean comments = null;
        Boolean variations = null;
                Object response = api.studyChapterPgn(studyId, chapterId, clocks, comments, variations);
        // TODO: test validations
    }
    
    /**
     * Export all studies of a user
     *
     * Download all chapters of all studies of a user in PGN format.  If authenticated, then all public, unlisted, and private studies are included.  If not, only public, listed studies are included. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void studyExportAllPgnTest() throws ApiException {
        String username = null;
        Boolean clocks = null;
        Boolean comments = null;
        Boolean variations = null;
                Object response = api.studyExportAllPgn(username, clocks, comments, variations);
        // TODO: test validations
    }
    
}
