/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import java.math.BigDecimal;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.SwissUnauthorisedEdit;
import org.openapitools.client.model.VariantKey;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for SwissTournamentsApi
 */
@Ignore
public class SwissTournamentsApiTest {

    private final SwissTournamentsApi api = new SwissTournamentsApi();

    
    /**
     * Join a Swiss tournament
     *
     * Join a Swiss tournament, possibly with a password. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiSwissJoinTest() throws ApiException {
        String id = null;
        String password = null;
                Ok response = api.apiSwissJoin(id, password);
        // TODO: test validations
    }
    
    /**
     * Create a new Swiss tournament
     *
     * Create a Swiss tournament for your team.  This endpoint mirrors the Swiss tournament form from your team pagee.  You can create up to 12 tournaments per day. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiSwissNewTest() throws ApiException {
        String teamId = null;
        BigDecimal clockLimit = null;
        Integer clockIncrement = null;
        Integer nbRounds = null;
        String name = null;
        Integer startsAt = null;
        Integer roundInterval = null;
        VariantKey variant = null;
        String description = null;
        Boolean rated = null;
        BigDecimal chatFor = null;
                Object response = api.apiSwissNew(teamId, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor);
        // TODO: test validations
    }
    
    /**
     * Terminate a Swiss tournament
     *
     * Terminate a Swiss tournament 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiSwissTerminateTest() throws ApiException {
        String id = null;
                Ok response = api.apiSwissTerminate(id);
        // TODO: test validations
    }
    
    /**
     * Update a Swiss tournament.
     *
     * Update a Swiss tournament.  Be mindful not to make important changes to ongoing tournaments. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiSwissUpdateTest() throws ApiException {
        String id = null;
        BigDecimal clockLimit = null;
        Integer clockIncrement = null;
        Integer nbRounds = null;
        String name = null;
        Integer startsAt = null;
        Integer roundInterval = null;
        VariantKey variant = null;
        String description = null;
        Boolean rated = null;
        BigDecimal chatFor = null;
                Object response = api.apiSwissUpdate(id, clockLimit, clockIncrement, nbRounds, name, startsAt, roundInterval, variant, description, rated, chatFor);
        // TODO: test validations
    }
    
    /**
     * Get team swiss tournaments
     *
     * Get all swiss tournaments of a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTeamSwissTest() throws ApiException {
        String teamId = null;
        Integer max = null;
                List<Object> response = api.apiTeamSwiss(teamId, max);
        // TODO: test validations
    }
    
    /**
     * Export games of a Swiss tournament
     *
     * Download games of a swiss tournament in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Games are sorted by reverse chronological order (last round first) 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void gamesBySwissTest() throws ApiException {
        String id = null;
        Boolean moves = null;
        Boolean pgnInJson = null;
        Boolean tags = null;
        Boolean clocks = null;
        Boolean evals = null;
        Boolean opening = null;
                Object response = api.gamesBySwiss(id, moves, pgnInJson, tags, clocks, evals, opening);
        // TODO: test validations
    }
    
    /**
     * Get results of a swiss tournament
     *
     * Players of a swiss tournament, with their score and performance, sorted by rank (best first).  Players are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON).  If called on an ongoing tournament, results can be inconsistent due to ranking changes while the players are being streamed. Use on finished tournaments for guaranteed consistency. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void resultsBySwissTest() throws ApiException {
        String id = null;
        Integer nb = null;
                Object response = api.resultsBySwiss(id, nb);
        // TODO: test validations
    }
    
    /**
     * Export TRF of a Swiss tournament
     *
     * Download a tournament in the Tournament Report File format, the FIDE standard.  Documentation: &lt;https://www.fide.com/FIDE/handbook/C04Annex2_TRF16.pdf&gt;  Example: &lt;https://lichess.org/swiss/j8rtJ5GL.trf&gt; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void swissTrfTest() throws ApiException {
        String id = null;
                String response = api.swissTrf(id);
        // TODO: test validations
    }
    
}
