/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import java.math.BigDecimal;
import org.openapitools.client.model.Error;
import org.openapitools.client.model.InlineResponse2001;
import org.openapitools.client.model.Ok;
import org.openapitools.client.model.Team;
import org.openapitools.client.model.UserExtended;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for TeamsApi
 */
@Ignore
public class TeamsApiTest {

    private final TeamsApi api = new TeamsApi();

    
    /**
     * Get team Arena tournaments
     *
     * Get all Arena tournaments relevant to a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTeamArenaTest() throws ApiException {
        String teamId = null;
        Integer max = null;
                List<Object> response = api.apiTeamArena(teamId, max);
        // TODO: test validations
    }
    
    /**
     * Get team swiss tournaments
     *
     * Get all swiss tournaments of a team.  Tournaments are sorted by reverse chronological order of start date (last starting first).  Tournaments are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiTeamSwissTest() throws ApiException {
        String teamId = null;
        Integer max = null;
                List<Object> response = api.apiTeamSwiss(teamId, max);
        // TODO: test validations
    }
    
    /**
     * Get popular teams
     *
     * Paginator of the most popular teams. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamAllTest() throws ApiException {
        BigDecimal page = null;
                InlineResponse2001 response = api.teamAll(page);
        // TODO: test validations
    }
    
    /**
     * Join a team
     *
     * Join a team. If the team requires a password but the &#x60;password&#x60; field is incorrect, then the call fails with &#x60;403 Forbidden&#x60;. Similarly, if the team join policy requires a confirmation but the &#x60;message&#x60; parameter is not given, then the call fails with &#x60;403 Forbidden&#x60;. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamIdJoinTest() throws ApiException {
        String teamId = null;
        String message = null;
        String password = null;
                Ok response = api.teamIdJoin(teamId, message, password);
        // TODO: test validations
    }
    
    /**
     * Kick a user from your team
     *
     * Kick a member out of one of your teams. - &lt;https://lichess.org/team&gt; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamIdKickUserIdTest() throws ApiException {
        String teamId = null;
        String userId = null;
                Ok response = api.teamIdKickUserId(teamId, userId);
        // TODO: test validations
    }
    
    /**
     * Message all members
     *
     * Send a private message to all members of a team. You must own the team. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamIdPmAllTest() throws ApiException {
        String teamId = null;
        String message = null;
                Ok response = api.teamIdPmAll(teamId, message);
        // TODO: test validations
    }
    
    /**
     * Leave a team
     *
     * Leave a team. - &lt;https://lichess.org/team&gt; 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamIdQuitTest() throws ApiException {
        String teamId = null;
                Ok response = api.teamIdQuit(teamId);
        // TODO: test validations
    }
    
    /**
     * Get members of a team
     *
     * Members are sorted by reverse chronological order of joining the team (most recent first). OAuth only required if the list of members is private.  Members are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamIdUsersTest() throws ApiException {
        String teamId = null;
                UserExtended response = api.teamIdUsers(teamId);
        // TODO: test validations
    }
    
    /**
     * Teams of a player
     *
     * All the teams a player is a member of. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamOfUsernameTest() throws ApiException {
        String username = null;
                List<Team> response = api.teamOfUsername(username);
        // TODO: test validations
    }
    
    /**
     * Search teams
     *
     * Paginator of team search results for a keyword. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamSearchTest() throws ApiException {
        String text = null;
        BigDecimal page = null;
                List<Team> response = api.teamSearch(text, page);
        // TODO: test validations
    }
    
    /**
     * Get a single team
     *
     * Infos about a team
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamShowTest() throws ApiException {
        String teamId = null;
                Team response = api.teamShow(teamId);
        // TODO: test validations
    }
    
}
