/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.InlineResponse200;
import org.openapitools.client.model.InlineResponse2002;
import org.openapitools.client.model.PerfType;
import org.openapitools.client.model.User;
import org.openapitools.client.model.UserExtended;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for UsersApi
 */
@Ignore
public class UsersApiTest {

    private final UsersApi api = new UsersApi();

    
    /**
     * Get crosstable
     *
     * Get total number of games, and current score, of any two users.  If the &#x60;matchup&#x60; flag is provided, and the users are currently playing, also gets the current match game number and scores. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiCrosstableTest() throws ApiException {
        String user1 = null;
        String user2 = null;
        Boolean matchup = null;
                Object response = api.apiCrosstable(user1, user2, matchup);
        // TODO: test validations
    }
    
    /**
     * Get user public data
     *
     * Read public data of a user. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUserTest() throws ApiException {
        String username = null;
                UserExtended response = api.apiUser(username);
        // TODO: test validations
    }
    
    /**
     * Get user activity
     *
     * Read data to generate the activity feed of a user. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUserActivityTest() throws ApiException {
        String username = null;
                api.apiUserActivity(username);
        // TODO: test validations
    }
    
    /**
     * Get performance statistics of a user
     *
     * Read performance statistics of a user, for a single performance. Similar to the [performance pages on the website](https://lichess.org/@/thibault/perf/bullet). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUserPerfTest() throws ApiException {
        String username = null;
        PerfType perf = null;
                Object response = api.apiUserPerf(username, perf);
        // TODO: test validations
    }
    
    /**
     * Get rating history of a user
     *
     * Read rating history of a user, for all perf types. There is at most one entry per day. Format of an entry is &#x60;[year, month, day, rating]&#x60;. &#x60;month&#x60; starts at zero (January). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUserRatingHistoryTest() throws ApiException {
        String username = null;
                Object response = api.apiUserRatingHistory(username);
        // TODO: test validations
    }
    
    /**
     * Get users by ID
     *
     * Get up to 300 users by their IDs. Users are returned in the same order as the IDs.  The method is &#x60;POST&#x60; so a longer list of IDs can be sent in the request body. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUsersTest() throws ApiException {
        String body = null;
                List<User> response = api.apiUsers(body);
        // TODO: test validations
    }
    
    /**
     * Get real-time users status
     *
     * Read the &#x60;online&#x60;, &#x60;playing&#x60; and &#x60;streaming&#x60; flags of several users.  This API is very fast and cheap on lichess side. So you can call it quite often (like once every 5 seconds).  Use it to track players and know when they&#39;re connected on lichess and playing games. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void apiUsersStatusTest() throws ApiException {
        String ids = null;
                List<InlineResponse200> response = api.apiUsersStatus(ids);
        // TODO: test validations
    }
    
    /**
     * Get all top 10
     *
     * Get the top 10 players for each speed and variant.  See &lt;https://lichess.org/player&gt;. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void playerTest() throws ApiException {
                Object response = api.player();
        // TODO: test validations
    }
    
    /**
     * Get one leaderboard
     *
     * Get the leaderboard for a single speed or variant (a.k.a. &#x60;perfType&#x60;). There is no leaderboard for correspondence or puzzles.  See &lt;https://lichess.org/player/top/200/bullet&gt;. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void playerTopNbPerfTypeTest() throws ApiException {
        Integer nb = null;
        String perfType = null;
                Object response = api.playerTopNbPerfType(nb, perfType);
        // TODO: test validations
    }
    
    /**
     * Get live streamers
     *
     * Get basic info about currently streaming users.  This API is very fast and cheap on lichess side. So you can call it quite often (like once every 5 seconds). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void streamerLiveTest() throws ApiException {
                List<InlineResponse2002> response = api.streamerLive();
        // TODO: test validations
    }
    
    /**
     * Get members of a team
     *
     * Members are sorted by reverse chronological order of joining the team (most recent first). OAuth only required if the list of members is private.  Members are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void teamIdUsersTest() throws ApiException {
        String teamId = null;
                UserExtended response = api.teamIdUsers(teamId);
        // TODO: test validations
    }
    
}
