/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.GameJsonAnalysis;
import org.openapitools.client.model.GameJsonClock;
import org.openapitools.client.model.GameJsonOpening;
import org.openapitools.client.model.GameJsonPlayers;
import org.openapitools.client.model.GameStatus;
import org.openapitools.client.model.Speed;
import org.openapitools.client.model.VariantKey;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;


/**
 * Model tests for GameJson
 */
public class GameJsonTest {
    private final GameJson model = new GameJson();

    /**
     * Model tests for GameJson
     */
    @Test
    public void testGameJson() {
        // TODO: test GameJson
    }

    /**
     * Test the property 'id'
     */
    @Test
    public void idTest() {
        // TODO: test id
    }

    /**
     * Test the property 'rated'
     */
    @Test
    public void ratedTest() {
        // TODO: test rated
    }

    /**
     * Test the property 'variant'
     */
    @Test
    public void variantTest() {
        // TODO: test variant
    }

    /**
     * Test the property 'speed'
     */
    @Test
    public void speedTest() {
        // TODO: test speed
    }

    /**
     * Test the property 'perf'
     */
    @Test
    public void perfTest() {
        // TODO: test perf
    }

    /**
     * Test the property 'createdAt'
     */
    @Test
    public void createdAtTest() {
        // TODO: test createdAt
    }

    /**
     * Test the property 'lastMoveAt'
     */
    @Test
    public void lastMoveAtTest() {
        // TODO: test lastMoveAt
    }

    /**
     * Test the property 'status'
     */
    @Test
    public void statusTest() {
        // TODO: test status
    }

    /**
     * Test the property 'players'
     */
    @Test
    public void playersTest() {
        // TODO: test players
    }

    /**
     * Test the property 'initialFen'
     */
    @Test
    public void initialFenTest() {
        // TODO: test initialFen
    }

    /**
     * Test the property 'winner'
     */
    @Test
    public void winnerTest() {
        // TODO: test winner
    }

    /**
     * Test the property 'opening'
     */
    @Test
    public void openingTest() {
        // TODO: test opening
    }

    /**
     * Test the property 'moves'
     */
    @Test
    public void movesTest() {
        // TODO: test moves
    }

    /**
     * Test the property 'pgn'
     */
    @Test
    public void pgnTest() {
        // TODO: test pgn
    }

    /**
     * Test the property 'daysPerTurn'
     */
    @Test
    public void daysPerTurnTest() {
        // TODO: test daysPerTurn
    }

    /**
     * Test the property 'analysis'
     */
    @Test
    public void analysisTest() {
        // TODO: test analysis
    }

    /**
     * Test the property 'tournament'
     */
    @Test
    public void tournamentTest() {
        // TODO: test tournament
    }

    /**
     * Test the property 'swiss'
     */
    @Test
    public void swissTest() {
        // TODO: test swiss
    }

    /**
     * Test the property 'clock'
     */
    @Test
    public void clockTest() {
        // TODO: test clock
    }

}
