/*
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * The version of the OpenAPI document: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.net.URI;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;


/**
 * Model tests for UserPreferences
 */
public class UserPreferencesTest {
    private final UserPreferences model = new UserPreferences();

    /**
     * Model tests for UserPreferences
     */
    @Test
    public void testUserPreferences() {
        // TODO: test UserPreferences
    }

    /**
     * Test the property 'dark'
     */
    @Test
    public void darkTest() {
        // TODO: test dark
    }

    /**
     * Test the property 'transp'
     */
    @Test
    public void transpTest() {
        // TODO: test transp
    }

    /**
     * Test the property 'bgImg'
     */
    @Test
    public void bgImgTest() {
        // TODO: test bgImg
    }

    /**
     * Test the property 'is3d'
     */
    @Test
    public void is3dTest() {
        // TODO: test is3d
    }

    /**
     * Test the property 'theme'
     */
    @Test
    public void themeTest() {
        // TODO: test theme
    }

    /**
     * Test the property 'pieceSet'
     */
    @Test
    public void pieceSetTest() {
        // TODO: test pieceSet
    }

    /**
     * Test the property 'theme3d'
     */
    @Test
    public void theme3dTest() {
        // TODO: test theme3d
    }

    /**
     * Test the property 'pieceSet3d'
     */
    @Test
    public void pieceSet3dTest() {
        // TODO: test pieceSet3d
    }

    /**
     * Test the property 'soundSet'
     */
    @Test
    public void soundSetTest() {
        // TODO: test soundSet
    }

    /**
     * Test the property 'blindfold'
     */
    @Test
    public void blindfoldTest() {
        // TODO: test blindfold
    }

    /**
     * Test the property 'autoQueen'
     */
    @Test
    public void autoQueenTest() {
        // TODO: test autoQueen
    }

    /**
     * Test the property 'autoThreefold'
     */
    @Test
    public void autoThreefoldTest() {
        // TODO: test autoThreefold
    }

    /**
     * Test the property 'takeback'
     */
    @Test
    public void takebackTest() {
        // TODO: test takeback
    }

    /**
     * Test the property 'moretime'
     */
    @Test
    public void moretimeTest() {
        // TODO: test moretime
    }

    /**
     * Test the property 'clockTenths'
     */
    @Test
    public void clockTenthsTest() {
        // TODO: test clockTenths
    }

    /**
     * Test the property 'clockBar'
     */
    @Test
    public void clockBarTest() {
        // TODO: test clockBar
    }

    /**
     * Test the property 'clockSound'
     */
    @Test
    public void clockSoundTest() {
        // TODO: test clockSound
    }

    /**
     * Test the property 'premove'
     */
    @Test
    public void premoveTest() {
        // TODO: test premove
    }

    /**
     * Test the property 'animation'
     */
    @Test
    public void animationTest() {
        // TODO: test animation
    }

    /**
     * Test the property 'captured'
     */
    @Test
    public void capturedTest() {
        // TODO: test captured
    }

    /**
     * Test the property 'follow'
     */
    @Test
    public void followTest() {
        // TODO: test follow
    }

    /**
     * Test the property 'highlight'
     */
    @Test
    public void highlightTest() {
        // TODO: test highlight
    }

    /**
     * Test the property 'destination'
     */
    @Test
    public void destinationTest() {
        // TODO: test destination
    }

    /**
     * Test the property 'coords'
     */
    @Test
    public void coordsTest() {
        // TODO: test coords
    }

    /**
     * Test the property 'replay'
     */
    @Test
    public void replayTest() {
        // TODO: test replay
    }

    /**
     * Test the property 'challenge'
     */
    @Test
    public void challengeTest() {
        // TODO: test challenge
    }

    /**
     * Test the property 'message'
     */
    @Test
    public void messageTest() {
        // TODO: test message
    }

    /**
     * Test the property 'coordColor'
     */
    @Test
    public void coordColorTest() {
        // TODO: test coordColor
    }

    /**
     * Test the property 'submitMove'
     */
    @Test
    public void submitMoveTest() {
        // TODO: test submitMove
    }

    /**
     * Test the property 'confirmResign'
     */
    @Test
    public void confirmResignTest() {
        // TODO: test confirmResign
    }

    /**
     * Test the property 'insightShare'
     */
    @Test
    public void insightShareTest() {
        // TODO: test insightShare
    }

    /**
     * Test the property 'keyboardMove'
     */
    @Test
    public void keyboardMoveTest() {
        // TODO: test keyboardMove
    }

    /**
     * Test the property 'zen'
     */
    @Test
    public void zenTest() {
        // TODO: test zen
    }

    /**
     * Test the property 'moveEvent'
     */
    @Test
    public void moveEventTest() {
        // TODO: test moveEvent
    }

    /**
     * Test the property 'rookCastle'
     */
    @Test
    public void rookCastleTest() {
        // TODO: test rookCastle
    }

}
